Copyright 1991, 1992, 1993, 1994, 1995, 1996, 1997, 1998, 1999, 2000, 2001,
	  2002, 2003, 2004, 2005, 2006, 2007 Free Software Foundation, Inc.
.
This file is part of the GNU MP Library.
.
The GNU MP Library is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 3 of the License, or (at your
option) any later version.
.
The GNU MP Library is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
License for more details.
.
You should have received a copy of the GNU Lesser General Public License
along with the GNU MP Library.  If not, see http://www.gnu.org/licenses/.

2007-09-10  Torbjorn Granlund  <tege@swox.com>

	* Version 4.2.2 released.

	* mpn/powerpc32/addlsh1_n.asm: Use L() for labels.
	* mpn/powerpc32/sublsh1_n.asm: Likewise.
	* mpn/x86_64/add_n.asm: Likewise.
	* mpn/x86_64/addmul_1.asm: Likewise.
	* mpn/x86_64/lshift.asm: Likewise.
	* mpn/x86_64/mul_1.asm: Likewise.
	* mpn/x86_64/rshift.asm: Likewise.
	* mpn/x86_64/sub_n.asm: Likewise.
	* mpn/x86_64/submul_1.asm: Likewise.

2007-09-09  Torbjorn Granlund  <tege@swox.com>

	* mpn/x86/x86-defs.m4 (LEA): New define.
	* mpn/x86/darwin.m4: New file, for now just defining LEA.
	* configure.in: Pick up x86/darwin.m4.
	* mpn/x86/*: Use LEA for PIC references.

	* configure.in: For X86/32, treat core2 like pentium3.

2007-09-06  Torbjorn Granlund  <tege@swox.com>

	* tests/amd64check.c (calling_conventions_values): Put constants,
	dynamic values in this array (was in scalars).
	(calling_conventions_check): Corresponding changes.
	* tests/amd64call.asm: Rewrite to be PIC, smaller, using amd64check.c's
	array.

	* configure.in: Match powerpc7410 consistently.

	* ltmain.sh, aclocal.m4, configure: Update to libtool 1.5.24.

2007-09-04  Torbjorn Granlund  <tege@swox.com>

	* tests/amd64call.asm: Remove bogus no-op moves.

2007-09-03  Torbjorn Granlund  <tege@swox.com>

	From Richard Guenther:
	* gmp-h.in (__GMP_EXTERN_INLINE): Declare conditionally on
	__GNUC_STDC_INLINE__.
	* tests/cxx/t-locale.cc: #include <cstdlib>, for abort.

2007-09-01  Torbjorn Granlund  <tege@swox.com>

	* mpn/x86_64/core2/gmp-mparam.h: New file.
	* mpn/x86_64/pentium4/gmp-mparam.h: New file.

	* configure.in: Handle athlon64, core2, and pentium4 separately for
	64-bit ABI.

	* config.sub: Recog athlon64, core2, and opteron.

	* config.guess: Make two x86 variants, for 32-bit ABI and 64-bit ABI.
	Return "athlon64" and "core2", not x86_64.

2007-08-31  Torbjorn Granlund  <tege@swox.com>

	From Patrick Pelissier:
	* gmp-h.in: Don't refer to FILE from C++ unless we've seen FILE.

2007-08-30  Torbjorn Granlund  <tege@swox.com>

	* demos/isprime.c: Include string.h for strcmp.

	* demos/pexpr.c (TIME): Remove an unused variable.

	* demos/factorize.c (main): Declare to int.

	* Update license to version 3.  All files affected.

2007-08-24  Torbjorn Granlund  <tege@swox.com>

	* tests/mpz/convert.c (string_urandomb): Slant random base generation
	towards base 10.

2007-05-22  Torbjorn Granlund  <tege@swox.com>

	* tests/memory.c: Cast args to new mem* calls to avoid unaligned ops.

2007-05-19  Torbjorn Granlund  <tege@swox.com>

	* tests/memory.c: Add red zones around allocations.

2007-05-15  Torbjorn Granlund  <tege@swox.com>

	* tests/mpz/convert.c (string_urandomb): New function.
	(main): Use it by enabling ifdef'ed out code.

2007-04-25  Torbjorn Granlund  <tege@swox.com>

	* mpz/divexact.c: Handle undefined case of |N| < |D| to avoid segfaults.

	* tests/mpz/reuse.c: Increase operand sizes, decrease # of tests.

2007-02-24  Torbjorn Granlund  <tege@swox.com>

	* gmp-impl.h (x86 ULONG_PARITY): Don't let Intel's icc fool us it is
	GCC.

	* doc/gmp.texi (Toom 3-Way Multiplication): Fix typo.
	(mpz_scan0, mpz_scan1): Fix typos.
	(Float Internals): Rewrite paragraph about struct types.

2007-02-05  Torbjorn Granlund  <tege@swox.com>

	* mpn/generic/mul_fft.c (mpn_fft_mul_modF_K): Fix an ASSERT_NOCARRY
	that caused invalid recomputation.

2006-11-23  Torbjorn Granlund  <tege@swox.com>

	* randmt.c (__gmp_randclear_mt): Initialize ALLOC field, like in
	__gmp_randinit_mt_noseed.
	(__gmp_randclear_mt, __gmp_randinit_mt_noseed): Make similar functions
	look similar.
	(__gmp_randclear_mt): Pass actually allocated size.

	* tune/speed.h (SPEED_ROUTINE_MPN_MUL_BASECASE): Allocate space for xp
	locally, s->xp might be insufficient.

2006-11-22  Torbjorn Granlund  <tege@swox.com>

	From Pedro Gimeno:
	* randmt.c (__gmp_randinit_mt_noseed): Initialize ALLOC field of result
	param.

	* configure.in (x86): Append cc to cclist.

2006-10-31  Torbjorn Granlund  <tege@swox.com>

	* gmp-h.in (__GNU_MP_VERSION_PATCHLEVEL): Bump.

	* gmpxx.h: Remove ternary stuff, it is hardly an optimization and it
	writes to destination before reading all source operands.

2006-07-12  Torbjorn Granlund  <tege@swox.com>

	* mpn/x86_64/lshift.asm: Use .byte sequence instead of movd for moving
	from MMX register to general register (workaround for GNU vs Solaris
	assembler incompatibility).
	* mpn/x86_64/rshift.asm: Likewise.

	* tests/amd64call.asm: Use jmp instead of jmpq to placate Solaris.

2006-06-30  Torbjorn Granlund  <tege@swox.com>

	* configure.in (powerpc-*): Remove repeated path component.

2006-06-29  Torbjorn Granlund  <tege@swox.com>

	* doc/texinfo.tex: Update to 2004-11-25.16 version.

2006-06-15  Torbjorn Granlund  <tege@swox.com>

	* mpn/ia64/add_n.asm: Move mutex decls to work around Intel assembler
	bug.
	* mpn/ia64/sub_n.asm: Likewise.

	* configure.in (ia64-*-linux*): Don't use -O3.

2006-06-14  Torbjorn Granlund  <tege@swox.com>

	* mpq/get_str.c: Fix upper base limit boundary in an ASSERT.

	* tests/refmpn.c (refmpn_sb_divrem_mn): Use ASSERT_CARRY for add-back.

2006-05-31  Torbjorn Granlund  <tege@swox.com>

	* tests/mpz/t-set_d.c (check_data): Add more data points.

	* mpz/set_d.c: Handle negative return values from __gmp_extract_double.

2006-05-20  Torbjorn Granlund  <tege@swox.com>

	* mpn/ia64/popcount.asm: Extend arguments for ABI=32.

2006-05-16  Torbjorn Granlund  <tege@swox.com>

	* configure.in: Clear out gcc_cflags_cpu and gcc_cflags_arch for a fat
	build.

	* demos/primes.c (find_primes): Increase mpz_probab_prime_p cnt to 10.

	* mpn/generic/addsub_n.c: Fix criteria for when to call _nc functions.

2006-05-12  Torbjorn Granlund  <tege@swox.com>

	* configure.in: Handle "powerpc744?" like "powerpc745?".

	* config.guess: Recognize more ppc processor types.

2006-05-11  Torbjorn Granlund  <tege@swox.com>

	* tune/speed.c (usage): Update URL for gnuplot and quickplot.

2006-05-09  Torbjorn Granlund  <tege@swox.com>

	* configure.in (powerpc-*-*): Pass -maltivec to assembler for
	appropriate CPUs.

2006-05-08  Torbjorn Granlund  <tege@swox.com>

	* mpn/powerpc32/aix.m4 (LEA): Remove [RW] attribute.

2006-05-04  Torbjorn Granlund  <tege@swox.com>

	* Version 4.2.1 released.

2006-05-03  Torbjorn Granlund  <tege@swox.com>

	* mpn/powerpc64/vmx/popcount.asm: Conditionally zero extend n.

2006-04-27  Torbjorn Granlund  <tege@swox.com>

	* mpz/divexact.c: Call mpz_tdiv_q for large operands.

	* configure.in (powerpc-*-darwin): Remove -fast, it affects PIC.

2006-04-26  Torbjorn Granlund  <tege@swox.com>

	* config.guess: Try to recognize Ultrasparc T1 (as ultrasparct1).
	* config.sub: Handle ultrasparct1.

2006-04-25  Torbjorn Granlund  <tege@swox.com>

	* mpn/sparc64/gmp-mparam.h: Retune, without separation of GNUC and
	non-GNUC data.

2006-04-19  Torbjorn Granlund  <tege@swox.com>

	* configure.in: Support powerpc eABI.
	* mpn/powerpc32/eabi.m4: New file.

	* configure.in: Support powerpc *bsd.
	* mpn/powerpc64/elf.m4: New name for mpn/powerpc64/linux64.m4.
	* mpn/powerpc32/elf.m4: New name for mpn/powerpc32/linux.m4.

	* mpn/powerpc64/linux64.m4 (ASM_END): Quote TOC_ENTRY.

2006-04-18  Torbjorn Granlund  <tege@swox.com>

	* configure.in (gmp_mpn_functions_optional): Add lshiftc.
	(HAVE_NATIVE): Add lshiftc.

	* tune/speed.h (SPEED_ROUTINE_MPN_ADDSUB_N_CALL): New macro.
	* tune/common.c (speed_mpn_addsub_n): New function.
	* tune/speed.c (routine): Add measuring of mpn_addsub_n.

	* mpn/powerpc64/linux64.m4 (TOC_ENTRY): Define to empty.
	* mpn/powerpc64/aix.m4 (TOC_ENTRY): Likewise.
	* mpn/powerpc32/aix.m4 (TOC_ENTRY): Likewise.

	* mpn/powerpc32/aix.m4 (EXTERN): New, copied form powerpc64/aix.m4.
	* mpn/powerpc32/mode1o.asm: Use EXTERN.
	* mpn/powerpc32/linux.m4 (EXTERN): Provide dummy definition.
	* mpn/powerpc32/darwin.m4 (EXTERN): Likewise.

2006-04-13  Torbjorn Granlund  <tege@swox.com>

	* tests/devel/try.c (choice_array): Add mpn_addsub_n[c].

2006-04-12  Torbjorn Granlund  <tege@swox.com>

	* extract-dbl.c: Don't rely on undefined casts to mp_limb_signed_t.

	* configure.in: Disable AC_C_RESTRICT for now.
	* mpn/generic/diveby3.c: Don't use restrict keyword for now.

2006-04-11  Torbjorn Granlund  <tege@swox.com>

	* gmp-h.in (__GNU_MP_VERSION_PATCHLEVEL): Bump.

	* aclocal.m4: Regenerate with patched libtool.

	* mpn/asm-defs.m4 (ASM_END): Provide (empty) default.

2006-04-08  Torbjorn Granlund  <tege@swox.com>

	* configure.in (gmp_mpn_functions_optional): Add addsub.

	* Makefile.am (LIBGMP_LT_*, LIBGMPXX_LT_*, LIBMP_LT_*):
	Bump version info.

	* gmpxx.h: Remove missed MPFR references.

	* gmp-impl.h (TMP_*, WANT_TMP_DEBUG): Don't expect marker argument;
	define TMP_SALLOC and TMP_BALLOC.

2006-04-05  Torbjorn Granlund  <tege@swox.com>

	* tal-notreent.c (__gmp_tmp_mark): Add "struct" tag for tmp_marker.
	(__gmp_tmp_free): Likewise.

2006-03-26  Torbjorn Granlund  <tege@swox.com>

	* Version 4.2 released.

	* mpn/powerpc64/aix.m4 (LEA): Renamed from LDSYM.
	* mpn/powerpc64/darwin.m4: Likewise.
	* mpn/powerpc64/linux64.m4: Likewise.
	* mpn/powerpc64/vmx/popcount.asm: Use LEA, not LDSYM.

2006-03-23  Torbjorn Granlund  <tege@swox.com>

	* gmp-impl.h: (class gmp_allocated_string): Prefix strlen with std::.

	* gmpxx.h (__GMP_DEFINE_TERNARY_EXPR2): Remove for now.
	(struct __gmp_ternary_addmul2): Likewise.
	(struct __gmp_ternary_submul2): Likewise.

	* gmpxx.h: #include <cstring>.
	(struct __gmp_alloc_cstring): Prefix strlen with std::.

	* mpn/x86/pentium/com_n.asm: Add TEXT and ALIGN.
	* mpn/x86/pentium/copyi.asm: Likewise.
	* mpn/x86/pentium/copyd.asm: Likewise.

2006-03-22  Torbjorn Granlund  <tege@swox.com>

	* gmp-h.in: Add a "using std::FILE" for C++.
	(_GMP_H_HAVE_FILE): Check also _ISO_STDIO_ISO_H.

	* gmpxx.h: Remove mpfr code.
	* tests/cxx: Likewise.

	* gmp-impl.h (FORCE_DOUBLE): Rename a tempvar to avoid a clash with
	GNU/Linux public include file.

	* configure.in (powerpc64, darwin): New optional, gcc_cflags_subtype.
	Grab powerpc32/darwin.m4 for ABI=mode32.

	* configure.in: Use host_cpu whenever just the cpu type is needed.

2006-03-08  Torbjorn Granlund  <tege@swox.com>

	* mpz/get_si.c: Fix a typo.

	* tests/mpq/t-get_d.c (check_random): Improve random generation for
	nails.

2006-02-28  Torbjorn Granlund  <tege@swox.com>

	* tests/mpq/t-get_d.c (check_random): New function.
	(main): Call check_random.

	* mpq/set_d.c: Make choices based on LIMBS_PER_DOUBLE, not
	BITS_PER_MP_LIMB.  Make it work for LIMBS_PER_DOUBLE == 4.
	Use MPZ_REALLOC.

	* mpz/set_d.c: Make it work for LIMBS_PER_DOUBLE == 4.

	* extract-dbl.c: Make it work for LIMBS_PER_DOUBLE > 3.

2006-02-27  Torbjorn Granlund  <tege@swox.com>

	* mpz/cmp_d.c: Declare `i'.
	* mpz/cmpabs_d.c: Likewise.

2006-02-23  Torbjorn Granlund  <tege@swox.com>

	* mpn/powerpc32/vmx/copyd.asm: Set right VRSAVE bits.
	* mpn/powerpc32/vmx/copyi.asm: Likewise.

2006-02-22  Torbjorn Granlund  <tege@swox.com>

	* mpn/powerpc32/vmx/logops_n.asm: New file.

	* mpn/powerpc32/diveby3.asm: Rewrite.

2006-02-21  Torbjorn Granlund  <tege@swox.com>

	* mpn/powerpc32/vmx/copyi.asm: New file.
	* mpn/powerpc32/vmx/copyd.asm: New file.

2006-02-17  Torbjorn Granlund  <tege@swox.com>

	* mpn/alpha/ev6/nails/aors_n.asm (CYSH): Import proper setting from
	deleted mpn_sub_n.

2006-02-16  Torbjorn Granlund  <tege@swox.com>

	* mpn/alpha/ev6/addmul_1.asm: Correct slotting comments.

2006-02-15  Torbjorn Granlund  <tege@swox.com>

	* tests/devel/anymul_1.c: Copy error reporting code from addmul_N.c.

	* tests/devel/addmul_N.c: New file.
	* tests/devel/mul_N.c: New file.

	* mpn/alpha/default.m4 (PROLOGUE_cpu): Align functions at 16-byte
	boundary.

	* mpn/alpha/ev6/nails/aors_n.asm: New file.
	* mpn/alpha/ev6/nails/add_n.asm: Remove.
	* mpn/alpha/ev6/nails/sub_n.asm: Remove.

	* mpn/alpha/ev6/nails/addmul_1.asm: Rewrite.
	* mpn/alpha/ev6/nails/submul_1.asm: Likewise.
	* mpn/alpha/ev6/nails/mul_1.asm: Likewise.

	* mpn/alpha/ev6/nails/addmul_2.asm: Use L() for labels.
	* mpn/alpha/ev6/nails/addmul_3.asm: Use L() for labels.
	* mpn/alpha/ev6/nails/addmul_4.asm: Use L() for labels.

2006-02-13  Torbjorn Granlund  <tege@swox.com>

	* mpn/powerpc32/diveby3.asm: Trivially reorder loop insns to save
	1 c/l.

2006-02-10  Torbjorn Granlund  <tege@swox.com>

	* mpn/powerpc64/sqr_diagonal.asm: Software pipeline.

	* mpn/powerpc64/vmx/popcount.asm: Add prefetching.

2006-02-04  Torbjorn Granlund  <tege@swox.com>

	* mpn/powerpc64/vmx/popcount.asm: Remove mpn_hamdist partial code.
	Move compare for huge n so that it is always executed.

2006-02-03  Torbjorn Granlund  <tege@swox.com>

	* mpn/powerpc32/linux.m4 (LEA): Add support for PIC.

	* configure.in (powerpc): New optional, gcc_cflags_subtype.

	* mpn/powerpc64/linux64.m4 (PROLOGUE_cpu): Align function start to
	16-multiple.
	* mpn/powerpc64/aix.m4: Likewise.
	* mpn/powerpc64/darwin.m4: Likewise.

	* mpn/powerpc64/copyi.asm: Align loop to 16-multiple.
	* mpn/powerpc64/copyd.asm: Likewise

	* configure.in (powerpc): Add vmx to relevant paths.

	* mpn/powerpc64/linux64.m4 (DEF_OBJECT): Accept 2nd argument, for
	alignment.
	* mpn/powerpc64/aix.m4: Likewise.
	* mpn/powerpc64/darwin.m4: Likewise.

	* mpn/powerpc32/linux.m4 (DEF_OBJECT, END_OBJECT): New macros,
	inherited from powerpc64 versions.
	* mpn/powerpc32/aix.m4: Likewise.
	* mpn/powerpc32/darwin.m4: Likewise.

	* mpn/powerpc64/vmx/popcount.asm: New file, for ppc32 and ppc64.
	* mpn/powerpc32/vmx/popcount.asm: New file, grabbing above file.

2006-01-22  Torbjorn Granlund  <tege@swox.com>

	* configure.in: Generalize OS-dependent patterns for powerpcs.

2006-01-20  Torbjorn Granlund  <tege@swox.com>

	* config.guess: Recognize power4 and up under linux-gnu.
	* config.sub: Generalize power recognition code.
	* acinclude.m4 (POWERPC64_PATTERN): Add 64-bit powerpc processors.
	* configure.in: Recognize powerpc processors masquerading as power
	processors.

2006-01-17  Torbjorn Granlund  <tege@swox.com>

	* mpn/generic/diveby3.c: Use GMP standard parameter names.  Nailify
	alternative code.  Use restrict for params.

	* configure.in: Recognize andn_n as not needing nailification.

	* tests/mpq/t-equal.c (check_various): Disable a test that gives common
	factors for GMP_NUMB_BITS == 62.

2006-01-16  Torbjorn Granlund  <tege@swox.com>

	* mpn/generic/get_str.c (mpn_sb_get_str): Fix digit count computation,
	was inaccurate for nails.

2006-01-15  Torbjorn Granlund  <tege@swox.com>

	* mpn/x86_64/mode1o.asm: Remove unneeded carry register zeroing.

2006-01-08  Torbjorn Granlund  <tege@swox.com>

	* mpn/alpha/ev6/sqr_diagonal.asm: New file.

2006-01-06  Torbjorn Granlund  <tege@swox.com>

	* mpn/generic/mullow_n.c (MUL_BASECASE_ALLOC): New #define.
	(mpn_mullow_n): Use it.

	* mpn/powerpc64/aix.m4 (EXTERN): Define to import symbol.
	(LDSYM): Remove [RW] attribute.
	* mpn/powerpc64/linux64.m4 (EXTERN): Dummy definition.
	* mpn/powerpc64/darwin.m4 (EXTERN): Likewise.

2006-01-05  Torbjorn Granlund  <tege@swox.com>

	* mpn/powerpc64/linux64.m4: Move toc entry generation from direct at
	DEF_OBJECT to delayed via LDSYM, define ASM_END to output it.
	* mpn/powerpc64/aix.m4: Likewise.
	* mpn/powerpc64/darwin.m4: Define a dummy ASM_END.

2006-01-03  Torbjorn Granlund  <tege@swox.com>

	* configure.in: Update bugs reporting address.

2006-01-02  Torbjorn Granlund  <tege@swox.com>

	* mpn/powerpc64/linux64.m4 (CALL): New macro.
	* mpn/powerpc64/aix.m4: Likewise.
	* mpn/powerpc64/darwin.m4: Likewise, also define macro "DARWIN".

2005-12-18  Torbjorn Granlund  <tege@swox.com>

	* mpf/ui_div.c: Implement workaround for GCC bug triggered on alpha.
	* mpf/set_q.c: Likewise.

2005-12-16  Torbjorn Granlund  <tege@swox.com>

	* mpn/generic/tdiv_qr.c: Remove statement with no effect.
	Rename dead variable to `dummy'.

2005-12-15  Torbjorn Granlund  <tege@swox.com>

	* demos/pexpr.c (setup_error_handler): Add a missing ";".

2005-11-27  Torbjorn Granlund  <tege@swox.com>

	* mpn/generic/mul.c: Crudely call mpn_mul_fft_full before checking
	for unbalanced operands.

	* mpn/generic/mul_fft.c: Remove many scalar divisions.
	(mpn_mul_fft_lcm): Simplify.
	(mpn_mul_fft_decompose): Rewrite to handle arbitrarily unbalanced
	operands.

2005-11-22  Torbjorn Granlund  <tege@swox.com>

	* configure.in: Properly recognize all 32-bit Solaris releases.

2005-11-10  Torbjorn Granlund  <tege@swox.com>

	* mpn/generic/mul_fft.c: Inline mpn_fft_mul_2exp_modF,
	mpn_fft_add_modF and mpn_fft_normalize.

2005-11-02  Torbjorn Granlund  <tege@swox.com>

	* tests/mpz/reuse.c: Increase operand size, decrease # of reps.

2005-10-31  Torbjorn Granlund  <tege@swox.com>

	* mpz/pprime_p.c (mpz_probab_prime_p): Considerably limit trial
	dividing.

	* mpz/perfpow.c (mpz_perfect_power_p): Use mpz_divisible_ui_p instead
	of mpz_tdiv_ui.

	* mpz/divegcd.c: Correct probability number for GCD == 1.

	* mpn/x86: Add cycle counts for array of x86 processors.

	* mpn/x86/k7/mod_34lsub1.asm: Remove spurious mentions of ebp.

	* mpn/powerpc32: Add POWER5 timings.

	* mpn/powerpc32/README: Describe global reference variations.

	* mpn/generic/dive_1.c: Whitespace cleanup.

	* mpn/alpha/ev6/nails/addmul_1.asm: Correct comments on slotting.
	* mpn/alpha/ev6/nails/addmul_2.asm: Likewise.
	* mpn/alpha/ev6/nails/addmul_4.asm: Likewise.

	* mpf/out_str.c: List some allocation improvement ideas.

	* doc/gmp.texi: Update many URLs and email addresses.

	* gmp-h.in (_GMP_H_HAVE_FILE): Check also _STDIO_H_INCLUDED.

2005-10-26  Torbjorn Granlund  <tege@swox.com>

	* tune/tuneup.c (tune_mullow): Update param.max_size for each threshold
	measurement.

	* configure.in (POWERPC64_PATTERN/*-*-darwin*): Set
	SPEED_CYCLECOUNTER_OBJ_mode64 and cyclecounter_size_mode64.
	(POWERPC64_PATTERN/*-*-linux*): Likewise.

2005-10-03  Torbjorn Granlund  <tege@swox.com>

	* demos/factorize.c (factor_using_division_2kp): Honor verbose flag.
	(factor_using_pollard_rho): Divide out new factor before it's
	clobbered.  Don't stop factoring after a composite factor was found.

2005-09-17  Torbjorn Granlund  <tege@swox.com>

	* demos/pexpr.c (fns): Add factorial keywords.

2005-08-16  Torbjorn Granlund  <tege@swox.com>

	* tune/Makefile.am (EXTRA_DIST): Change "amd64" => "x86_64".
	* mpn/Makefile.am (TARG_DIST): Change "amd64" => "x86_64".

2005-08-15  Torbjorn Granlund  <tege@swox.com>

	* configure.in: Change "amd64" => "x86_64".

2005-06-13  Torbjorn Granlund  <tege@swox.com>

	* mpn/generic/pre_mod_1.c: Canonicalize variable names.

	* mpn/generic/divrem.c: Rate qxn test as UNLIKELY.

	* tune/tuneup.c (tune_mullow): Fix all max_size fields.

	* gmp-impl.h (SQR_TOOM3_THRESHOLD_LIMIT): New #define.
	* tune/tuneup.c (tune_sqr): Use SQR_TOOM3_THRESHOLD_LIMIT.
	(sqr_toom3_threshold): Initialize from SQR_TOOM3_THRESHOLD_LIMIT.

	* mpn/generic/mul_n.c (mpn_sqr_n): Use SQR_TOOM3_THRESHOLD_LIMIT.

	* gmp-impl.h (mpn_nand_n, mpn_iorn_n, mpn_nior_n, mpn_xnor_n):
	Handle nails.

2005-06-12  Torbjorn Granlund  <tege@swox.com>

	* mpn/alpha/ev6/sub_n.asm: Analogous changes as to add_n.asm last.

2005-06-11  Torbjorn Granlund  <tege@swox.com>

	* mpn/alpha/ev6/add_n.asm: Rewrite inner loop to load later.
	Add mpn_add_nc entry.

	* mpn/alpha/ev6/addmul_1.asm: Remove redundant initial loads.

2005-06-07  Torbjorn Granlund  <tege@swox.com>

	* mpn/generic/dive_1.c: Use variable h for upper umul_ppmm result.

2005-06-04  Torbjorn Granlund  <tege@swox.com>

	* tests/devel/try.c (choice_array): Exclude mpn_preinv_mod_1 unless
	USE_PREINV_MOD_1.
	(choice_array): Exclude mpn_sqr_basecase if SQR_KARATSUBA_THRESHOLD
	is zero.

2005-06-03  Torbjorn Granlund  <tege@swox.com>

	* mpn/alpha/ev6/addmul_1.asm: Prefix all labels with "$".
	* mpn/alpha/ev6/mul_1.asm: Likewise.

2005-06-02  Torbjorn Granlund  <tege@swox.com>

	* tests/refmpn.c (refmpn_divmod_1c_workaround): Implement workaround
	to gcc 3.4.x bug triggered on powerpc64 with 32-bit ABI.

2005-06-01  Torbjorn Granlund  <tege@swox.com>

	* tests/devel/try.c (main): Fix a typo.

2005-05-31  Torbjorn Granlund  <tege@swox.com>

	* mpn/alpha/ev6/addmul_1.asm: Rewrite for L1 cache, add prefetch.

2005-05-30  Torbjorn Granlund  <tege@swox.com>

	* tests/misc.c (tests_rand_start): Mask random seed to 32 bits.

2005-05-29  Torbjorn Granlund  <tege@swox.com>

	* mpn/powerpc64/mode32/mul_1.asm: Handle BROKEN_LONGLONG_PARAM.
	* mpn/powerpc64/mode32/addmul_1.asm: Likewise.
	* mpn/powerpc64/mode32/submul_1.asm: Likewise.

	* mpn/powerpc32/mode1o.asm: Rewrite to actually work.

	* mpn/powerpc32/aix.m4 (LEA): New macro.
	(ASM_END): New macro.

	* mpn/powerpc32/linux.m4: New file.
	* mpn/powerpc32/darwin.m4: New file.
	* configure.in: Use linux.m4 and darwin.m4.
	(powerpc64-linux-gnu): Add support for mode32.

2005-05-25  Torbjorn Granlund  <tege@swox.com>

	* mpn/generic/mullow_n.c: Remove FIXME mentioning fixed flaw.

	* tests/mpz/t-cmp_d.c (check_one): Fix printf fmt string typo.

	* demos/isprime.c: #include stdlib.h.
	* tests/rand/t-urbui.c: Likewise.
	* tests/rand/t-urmui.c: Likewise.

	* tests/mpz/t-popcount.c (check_random): Remove spurious printf arg.

2005-05-24  Torbjorn Granlund  <tege@swox.com>

	* tests/devel/try.c (param_init) [TYPE_GET_STR]: Set retval field.
	(compare): Handle SIZE_GET_STR as SIZE_RETVAL.

	* tests/refmpn.c (refmpn_get_str): Rewrite to make it work.

2005-05-23  Torbjorn Granlund  <tege@swox.com>

	* longlong.h (many places): Remove lvalue casts.

	* gmp-impl.h (MPF_SIGNIFICANT_DIGITS): Cast prec to avoid overflow
	for > 4G digits.

	* mpn/alpha/ev6/add_n.asm: Prefetch using ldl.
	* mpn/alpha/ev6/sub_n.asm: Likewise.

	* mpn/alpha/ev6/slot.pl (optable): Recognize negq and ldl.

2005-05-22  Torbjorn Granlund  <tege@swox.com>

	* mpn/alpha/ev67/popcount.asm: Prefetch.
	* mpn/alpha/ev67/hamdist.asm: Prefetch.

	* longlong.h (add_ssaaaa) [x86]: Remove lvalue casts.
	(sub_ddmmss) [x86]: Likewise.

	* tests/devel/try.c (param_init) [TYPE_MPZ_JACOBI]: Add DATA_SRC1_ODD.
	(param_init) [TYPE_MPZ_KRONECKER]: Clear inherited DATA_SRC1_ODD.
	(param_init) [TYPE_DIVEXACT_1]: Use symbolic name DIVISOR_LIMB.

2005-05-21  Torbjorn Granlund  <tege@swox.com>

	* tests/devel/try.c (param_init) [TYPE_MPZ_JACOBI]: Initialize divisor
	field according to UDIV_NEEDS_NORMALIZATION.

	* mpz/mul_i.h: Remove left-over TMP_XXXX marker arguments.

2005-05-20  Torbjorn Granlund  <tege@swox.com>

	* mpn/x86/pentium4/sse2/addmul_1.asm (mpn_addmul_1c): Put carry in
	proper register.

	* mpn/generic/sqr_basecase.c (mpn_sqr_basecase, addmul_2 version):
	Avoid accesses out-of-bound in MPN_SQR_DIAGONAL applicate code.

2005-05-19  Torbjorn Granlund  <tege@swox.com>

	* mpn/alpha/diveby3.asm: Make it actually work.

	* gmp-impl.h (MULLOW_BASECASE_THRESHOLD_LIMIT): New #define.
	* mpn/generic/mullow_n.c: Use fixed stack allocation for the smallest
	operands; use TMP_S* allocation for medium operands.

	* gmp-impl.h: Remove nested TUNE_PROGRAM_BUILD test.

2005-05-18  Torbjorn Granlund  <tege@swox.com>

	* mpn/generic/mul_n.c: Make squaring and multiplication code more
	similar.  Use TMP_S* functions.

	* gmp-impl.h (TMP_DECL, TMP_MARK, TMP_FREE): Get rid of argument.
	(TMP_SALLOC): New macro for "small" allocations.
	(TMP_BALLOC): New macro for "big" allocations.
	(TMP_SDECL, TMP_SMARK, TMP_SFREE): New macros for functions that use
	just TMP_SALLOC.
	(WANT_TMP_ALLOCA): Make default functions choose alloca or reentrant
	functions, depending on size.

	* *.c: Remove TMP_XXXX marker arguments.

	* acinclude.m4 (WANT_TMP): Want tal-reent.lo also for alloca case.

2005-05-15  Torbjorn Granlund  <tege@swox.com>

	* gmp-impl.h (udiv_qrnnd_preinv2): Pull an add into add_ssaaaa.
	(udiv_qrnnd_preinv2gen): Likewise.

2005-05-14  Torbjorn Granlund  <tege@swox.com>

	* longlong.h (add_ssaaaa) [x86_64]: Restrict allowed immediate
	operands.
	* (sub_ddmmss) [x86_64]: Likewise.

2005-05-02  Torbjorn Granlund  <tege@swox.com>

	* acinclude.m4 (GMP_HPC_HPPA_2_0): Make gmp_tmp_v1 sed pattern handle
	version numbers like B.11.X.32509-32512.GP.

	* mpn/m68k/aors_n.asm: Correct MULFUNC_PROLOGUE.

	* mpf/inp_str.c: Use plain int for mpf_set_str return value (works
	around gcc 4 bug).

	* acinclude.m4 (GMP_ASM_POWERPC_PIC_ALWAYS): Handle darwin's assembly
	syntax.
	(long long reliability test 1): New GMP_PROG_CC_WORKS_PART test.
	(long long reliability test 2): New GMP_PROG_CC_WORKS_PART test.

	* configure.in: Add mode64 support for darwin.  Use darwin.m4.
	Add cflags_opt flags for mode32 darwin.

	* mpn/asm-defs.m4 (PIC_ALWAYS): Define PIC just iff PIC_ALWAYS = "yes".

	* mpn/powerpc64/darwin.m4: New file.

	* mpn/powerpc64/linux64.m4: Remove TOCREF, add LDSYM.
	Rework DEF_OBJECT to need just one argument.
	* mpn/powerpc64/aix.m4: Likewise.

2005-05-01  Torbjorn Granlund  <tege@swox.com>

	* mpn/generic/popham.c: Compute final summation differently for 64-bit.

	* tests/mpz/t-popcount.c (check_random): New function.
	(main): Call it.

2005-04-09  Torbjorn Granlund  <tege@swox.com>

	* mpn/powerpc64/copyi.asm: If HAVE_ABI_mode32, ignore upper 32 bits of
	mp_size_t argument.
	* mpn/powerpc64/copyd.asm: Likewise.
	* mpn/powerpc64/sqr_diagonal.asm: Likewise.
	* mpn/powerpc64/lshift.asm: Likewise.
	* mpn/powerpc64/rshift.asm: Likewise.

2005-04-08  Torbjorn Granlund  <tege@swox.com>

	* mpn/generic/rootrem.c: Allocate PP_ALLOC limbs also for qp.

2005-04-07  Torbjorn Granlund  <tege@swox.com>

	* mpn/powerpc32/add_n.asm: Add nc entry point.
	* mpn/powerpc32/sub_n.asm: Likewise.

	* mpn/alpha/add_n.asm: Add correct cycle/limb numbers.
	* mpn/alpha/sub_n.asm: Likewise.
	* mpn/alpha/ev5/add_n.asm: Likewise.
	* mpn/alpha/ev5/sub_n.asm: Likewise.

2005-03-31  Torbjorn Granlund  <tege@swox.com>

	* mpn/x86/k7/gmp-mparam.h: Fix typo in last change.

2005-03-19  Torbjorn Granlund  <tege@swox.com>

	* mpn/alpha/gmp-mparam.h: Update.
	* mpn/alpha/ev5/gmp-mparam.h: Update.
	* mpn/alpha/ev6/gmp-mparam.h: Update.

	* mpn/x86/p6/mmx/gmp-mparam.h: Update.
	* mpn/x86/pentium4/sse2/gmp-mparam.h: Update.
	* mpn/x86/k7/gmp-mparam.h: Update.

	* tests/mpz/t-gcd.c (main): Honor command line reps argument.

	* tune/speed.h (SPEED_ROUTINE_MPN_GCD_CALL): Simplify and correct code
	for generating test operands.

2005-01-13  Torbjorn Granlund  <tege@swox.com>

	* gmp-impl.h (MPN_SIZEINBASE): Count bits in type size_t.
	(MPN_SIZEINBASE_16): Likewise.

2004-12-17  Torbjorn Granlund  <tege@swox.com>

	* tune/speed.c (run_gnuplot): Use lines, not linespoints.
	Output a reset gnuplot command initially.

2004-12-04  Torbjorn Granlund  <tege@swox.com>

	* mpn/generic/random2.c (gmp_rrandomb): Rework again.
	* mpz/rrandomb.c (gmp_rrandomb): Likewise.

2004-11-24  Torbjorn Granlund  <tege@swox.com>

	* mpn/alpha/diveby3.asm: Use correct prefetch instruction.

2004-11-19  Torbjorn Granlund  <tege@swox.com>

	* mpn/alpha/diveby3.asm: Add ",gp" glue in PROLOGUE.
	Add r31 dummy operand to `br' instruction.

2004-11-17  Torbjorn Granlund  <tege@swox.com>

	* configure.in: Invoke AC_C_RESTRICT.

2004-11-16  Torbjorn Granlund  <tege@swox.com>

	* mpn/alpha/diveby3.asm: New file.

2004-11-10  Torbjorn Granlund  <tege@swox.com>

	* mpn/generic/popham.c: Add comment.

2004-11-05  Torbjorn Granlund  <tege@swox.com>

	* config.guess: Strip any PPC string in /proc/cpuinfo.
	Recognize 970 in that code.

2004-10-25  Torbjorn Granlund  <tege@swox.com>

	* mpn/powerpc64/README: Update POWER5/PPC970 pipeline information.

	* mpn/generic/mul_basecase.c (MAX_LEFT): Add comment.

	* doc/gmp.texi: Consistently use "x86" denotation.
	(Assembler SIMD Instructions): Mention SSE2 usage.

	* demos/pexpr.c (main): Handle "negative" base in mpz_sizeinbase call.

2004-10-16  Torbjorn Granlund  <tege@swox.com>

	* configure.in: Support icc under x86.
	(ia64-*-linux*): Pass -no-gcc to icc.

2004-10-15  Torbjorn Granlund  <tege@swox.com>

	* longlong.h (ia64 umul_ppmm): Add version for icc.

	* configure.in: Support icc under ia64-*-linux*.

	* acinclude.m4: New "compiler works" test for icc 8.1 bug.
	(GMP_PROG_CC_IS_GNU): Don't let Intel's icc fool us it is GCC.

2004-10-14  Torbjorn Granlund  <tege@swox.com>

	* acinclude.m4 (GMP_ASM_W32): Try also "data4".

	* longlong.h: Exclude masquerading __INTEL_COMPILER from ia64 asm.
	* gmp-impl.h: Likewise.

2004-10-12  Torbjorn Granlund  <tege@swox.com>

	* tests/devel/try.c: Handle mpn_mul_2 like mpn_addmul_2.

	* tune/speed.c (routine): Make R parameter optional for mpn_mul_2.

2004-10-11  Torbjorn Granlund  <tege@swox.com>

	* mpn/sparc64/addmul_1.asm: Update a comment.

	* tests/devel/aors_n.c: #include tests.h.
	* tests/devel/anymul_1.c: Likewise.
	* tests/devel/shift.c: Likewise.
	* tests/devel/copy.c: Likewise.

	* tests/devel/aors_n.c: Handle also mpn_addlsh1_n, mpn_sublsh1_n,
	mpn_rsh1add_n, and mpn_rsh1sub_n.

	* tests/devel/Makefile.am (EXTRA_PROGRAMS): Updates for yesterday's
	file removals and additions.

2004-10-10  Torbjorn Granlund  <tege@swox.com>

	* tests/devel/copy.c: Handle both MPN_COPY_INCR and MPN_COPY_DECR.

	* tests/devel/logops_n.c: New file, handle all logical operations.

	* tests/devel/anymul_1.c: New file, handle mpn_mul_1, mpn_addmul_1, and
	mpn_submul_1
	* tests/devel/mul_1.c: Remove.
	* tests/devel/addmul_1.c: Remove.
	* tests/devel/submul_1.c: Remove.

	* tests/devel/shift.c: New file, handle mpn_lshift and mpn_rshift.
	* tests/devel/lshift.c: Remove.
	* tests/devel/rshift.c: Remove.

	* tests/devel/aors_n.c: New file, handle mpn_add_n and mpn_sub_n.
	* tests/devel/add_n.c: Remove.
	* tests/devel/sub_n.c: Remove.

2004-10-09  Torbjorn Granlund  <tege@swox.com>

	* mpn/powerpc64/linux64.m4: Define DEF_OBJECT, END_OBJECT, and TOCREF.
	* mpn/powerpc64/aix.m4: Likewise.

2004-10-08  Torbjorn Granlund  <tege@swox.com>

	* mpn/powerpc64/copyi.asm: New file.
	* mpn/powerpc64/copyd.asm: New file.
	* gmp-h.in: Remove PPC MPN_COPY variants.
	* gmp-impl.h: Likewise.

2004-10-07  Torbjorn Granlund  <tege@swox.com>

	* configfsf.guess: Patch HP-UX code to accommodate HP compiler's new
	inability to read from stdin.

	* mpn/powerpc64/mode64/addsub_n.asm: Remove accidentally added file.

2004-09-29  Torbjorn Granlund  <tege@swox.com>

	* gmp-impl.h (x86 ULONG_PARITY): Work around GCC change of "q" register
	flag.

2004-09-28  Paul Zimmermann  <Paul.Zimmermann@loria.fr>

	* mpn/generic/mul_fft.c (mpn_mul_fft): Fix a bug in the choice of the
	recursive fft parameters.

2004-09-20  Torbjorn Granlund  <tege@swox.com>

	* tests/misc.c (tests_rand_start): Default to strtoul for re-seeding.

	* tests/mpz/t-mul.c (ref_mpn_mul): Fudge tmp allocation for toom3.

2004-09-19  Torbjorn Granlund  <tege@swox.com>

	* tests/misc.c (tests_rand_start): Shift tv_usec for better seeding.

2004-09-18  Torbjorn Granlund  <tege@swox.com>

	* tests/misc.c (tests_rand_start): Invoke fflush after printing seed.

	* tests/mpz/t-mul.c (main): Check environment for GMP_CHECK_FFT, run
	extra FFT tests if set.
	(ref_mpn_mul): Use library code for kara and toom, but skewded so that
	we never use the same algorithm that we're testing.
	(mul_kara): Delete.
	(debug_mp): Print just one line of large numbers.
	(ref_mpn_mul): Rework usage of tp temporary space.

2004-09-11  Torbjorn Granlund  <tege@swox.com>

	* mpn/generic/sqr_basecase.c: In variant for HAVE_NATIVE_mpn_addmul_2,
	accumulate carry also for when HAVE_NATIVE_mpn_addlsh1_n.

2004-08-29  Torbjorn Granlund  <tege@swox.com>

	* tests/mpz/t-sizeinbase.c: Disable mpz_fake_bits and check_sample.

2004-06-17  Kevin Ryde  <kevin@swox.se>

	* doc/gmp.texi: Use @. when sentence ends with a capital, for good
	spacing in tex.
	(Language Bindings): Add gmp-d, reported by Ben Hinkle.  Update SWI
	Prolog URL, reported by Jan Wielemaker.

2004-06-09  Torbjorn Granlund  <tege@swox.com>

	* configure.in: Handle --enable-fat.  Use that to enable x86 fat
	builds, remove magic meaning of i386-*-*.

2004-06-03  Kevin Ryde  <kevin@swox.se>

	* gmp-impl.h (memset): Use a local char* pointer, in case parameter is
	something else (eg. tune/common.c).  Reported by Emmanuel Thomé.

2004-06-01  Kevin Ryde  <kevin@swox.se>

	* config.guess (i?86-*-*): Avoid "Illegal instruction" message which
	goes to stdout on 80386 freebsd4.9.

2004-05-23  Torbjorn Granlund  <tege@swox.com>

	* mpn/generic/gcdext.c (gcdext_1_odd): Use masking to avoid jumps.

2004-05-22  Torbjorn Granlund  <tege@swox.com>

	* mpn/x86/pentium4/sse2/addmul_1.asm: Add Prescott cycle numbers.

	* mpn/powerpc32/lshift.asm: Add more cycle numbers.
	* mpn/powerpc32/rshift.asm: Likewise.

2004-05-21  Torbjorn Granlund  <tege@swox.com>

	* gmp-impl.h (mpn_mullow_n, mpn_mullow_basecase): Declare.

	* tune/Makefile.am: Compile gcdext.c.

	* gmp-impl.h (GET_STR_THRESHOLD_LIMIT): Lower outrageous value to 150.

2004-05-21  Niels Möller  <nisse@lysator.liu.se>

	* tune/speed.h (SPEED_ROUTINE_MPN_GCD_CALL): Ensure first operand is
	not smaller than 2nd operand.

2004-05-17  Kevin Ryde  <kevin@swox.se>

	* gmp-h.in (mpz_get_ui): Use #if instead of plain if, and for nails
	use ?: same as normal case, to avoid warnings from Borland C++ 6.0.
	Reported by delta trinity.

2004-05-15  Kevin Ryde  <kevin@swox.se>

	* tune/time.c (getrusage_backwards_p): New function
	(speed_time_init): Use it to exclude broken netbsd1.4.1 getrusage.
	* configure.in (m68*-*-netbsd1.4*): Remove code pretending getrusage
	doesn't exist.
	* tune/README (NetBSD 1.4.1 m68k): Update notes.

	* configure.in (mips*-*-* ABI=n32): Remove gcc_n32_ldflags and
	cc_n32_ldflags, libtool knows to put the linker in n32 mode.

2004-05-15  Torbjorn Granlund  <tege@swox.com>

	* config.guess (powerpc*-*-*): Add more processor types to mfpvr code.
	* configure.in: Generalize powerpc subtype matching code.

	* mpz/fac_ui.c: Misc cleanups, spelling corrections.

2004-05-14  Kevin Ryde  <kevin@swox.se>

	* mpf/sub.c: When one operand cancels high limbs of the other, strip
	high zeros on the balance before truncating to destination precision.
	Truncating first loses accuracy and can lead to a result 0 despite
	operands being not equal.  Reported by John Abbott.
	Also, ensure exponent is zero when result is zero, for instance if
	operands are exactly equal.
	* tests/mpf/t-sub.c (check_data): New function, exercising these.

2004-05-12  Kevin Ryde  <kevin@swox.se>

	* configure.in (AC_PROG_RANLIB): New macro, supposedly required by
	automake, though it doesn't complain.

	* demos/expr/Makefile.am (ARFLAGS): Add a default setting, to
	workaround an automake bug.

2004-05-10  Kevin Ryde  <kevin@swox.se>

	* */Makefile.in, install-sh, aclocal.m4: Update to automake 1.8.4.

	* doc/gmp.texi (Demonstration Programs): Add a remark about expression
	evaluation in the main gmp library.

	* demos/expr/exprfa.c (mpf_expr_a): Correction to mpX_init, use
	mpf_init2 to follow requested precision.
	* demos/expr/exprza.c, demos/expr/exprqa.c: Use wrappers for mpX_init,
	to make parameters match.

	* demos/expr/run-expr.c: Don't use getopt, to avoid needing configury
	for optarg declaration.  Remove TRY macro, rename foo and bar to var_a
	and var_b, for clarity.
	* demos/expr/expr-impl.h: Don't use expr-config.h.
	* configure.in (demos/expr/expr-config.h): Remove.
	* demos/expr/expr-config.in: Remove file.

2004-05-08  Kevin Ryde  <kevin@swox.se>

	* doc/configuration (Configure): Update for current automake not
	copying acinclude.m4 into aclocal.m4.

	* configure.in, Makefile.am, doc/gmp.texi, doc/configuration,
	tests/cxx/Makefile.am, demos/expr/Makefile.am, demos/expr/README,
	demos/expr/expr.c, demos/expr/expr.h, demos/expr/expr-config-h.in,
	demos/expr/expr-impl.h, demos/expr/run-expr.c, demos/expr/t-expr.c:
	MPFR now published separately, remove various bits.
	* mpfr/*, tests/cxx/t-headfr.cc, demos/expr/exprfr.c,
	demos/expr/exprfra.c: Remove.

2004-05-07  Kevin Ryde  <kevin@swox.se>

	* tests/cxx/Makefile.am (TESTS_ENVIRONMENT): Amend c++ shared library
	path hack, on k62-unknown-dragonfly1.0 /usr/bin/make runs its commands
	"set -e", so we need an "|| true" in case there's nothing to copy (for
	instance in a static build).

2004-05-06  Kevin Ryde  <kevin@swox.se>

	* mpn/alpha/mode1o.c: Remove, in favour of ...
	* mpn/alpha/mode1o.asm: New file.
	* mpn/alpha/alpha-defs.m4 (bwx_available_p): New macro.

	* tune/amd64.asm: Save rbx in r10 rather than on the stack.

	* configure.in (x86_64-*-*): Try also "-march=k8 -mno-sse2", in case
	we're in ABI=32 on an old OS not supporting xmm regs.
	(GMP_GCC_PENTIUM4_SSE2, GMP_OS_X86_XMM): Run these tests under
	-march=k8 too, and not under ABI=64.

	* doc/gmp.texi (Converting Integers): For mpz_get_d, note truncation
	and overflows.  For mpz_get_d_2exp note truncation, note result if
	OP==0, and cross reference libc frexp.
	(Rational Conversions): For mpq_get_d, note truncation and overflows.
	(Converting Floats): For mpf_get_d, note truncation and overflows.
	For mpf_get_d_2exp, note truncation, note result if OP==0.
	(Assembler Code Organisation): Note nails subdirectories.
	Clarification of get_d_2exp OP==0 reported by Sylvain Pion.

2004-05-05  Torbjorn Granlund  <tege@swox.com>

	* mpn/generic/mullow_n.c, mpn/generic/mullow_basecase.c: New files
	(mainly by Niels Möller).
	* configure.in, mpn/Makefile.am: Add them.

	* gmp-impl.h (MULLOW_BASECASE_THRESHOLD, MULLOW_DC_THRESHOLD,
	MULLOW_MUL_N_THRESHOLD): Override for TUNE_PROGRAM_BUILD.

	* tune/Makefile.am: Compile mullow_n.c.
	* tune/common.c (speed_mpn_mullow_n, speed_mpn_mullow_basecase):
	New functions.
	* tune/speed.c (routine): Add entries for mpn_mullow_n and
	mpn_mullow_basecase.
	* tune/speed.h (SPEED_ROUTINE_MPN_MULLOW_N_CALL,
	SPEED_ROUTINE_MPN_MULLOW_BASECASE): New #defines.
	* tune/tuneup.c (tune_mullow): New function.

	* gmp-impl.h (invert_limb): Compute branch-freely.

2004-05-02  Kevin Ryde  <kevin@swox.se>

	* mpn/amd64/mode1o.asm: Use movabsq to support large model non-PIC.
	Use 32-bit insns to save code bytes, and to save a couple of cycles on
	the initial setup multiplies.

2004-05-01  Kevin Ryde  <kevin@swox.se>

	* doc/gmp.texi (References): Update gcc online docs url to
	gcc.gnu.org.

	* configure.in (mips*-*-irix[6789]*): Correction to m4 quoting of this
	pattern.  (Believe the mips64*-*-* part also used picks up all current
	irix6 tuples anyway.)  Reported by Rainer Orth.

2004-04-30  Kevin Ryde  <kevin@swox.se>

	* acinclude.m4 (GMP_PROG_CC_X86_GOT_EAX_EMITTED,
	GMP_ASM_X86_GOT_EAX_OK): New macros.
	(GMP_PROG_CC_WORKS): Use them to detect an old gas bug tickled by
	recent gcc.  Reported by David Newman.

	* doc/gmp.texi (Reentrancy): Note also gmp_randinit_default as an
	alternative to gmp_randinit.

2004-04-29  Torbjorn Granlund  <tege@swox.com>

	* configfsf.guess: Update to 2004-03-12.
	* configfsf.sub: Likewise.

2004-04-27  Torbjorn Granlund  <tege@swox.com>

	* mpz/rrandomb.c (gmp_rrandomb): Rework to avoid extra limb allocation
	and to generate even numbers.
	* mpn/generic/random2.c (gmp_rrandomb): Likewise.

2004-04-25  Kevin Ryde  <kevin@swox.se>

	* gmp-impl.h (FORCE_DOUBLE): Don't use an asm with a match constraint
	on a memory output, apparently not supported and provokes a warning
	from gcc 3.4.

2004-04-24  Kevin Ryde  <kevin@swox.se>

	* longlong.h (count_leading_zeros_gcc_clz,
	count_trailing_zeros_gcc_ctz): New macros.
	(count_leading_zeros, count_trailing_zeros) [x86]: Use them on gcc
	3.4.

	* configure.in (x86-*-* gcc_cflags_cpu): Give a -mtune at the start of
	each option list, for use by gcc 3.4 to avoid deprecation warnings
	about -mcpu.

	* mpz/aorsmul.c, mpz/aorsmul_i.c, mpz/cfdiv_q_2exp.c,
	mpz/cfdiv_r_2exp.c, mpq/aors.c, mpf/ceilfloor.c: Give REGPARM_ATTR()
	on function definition too, as demanded by gcc 3.4.

2004-04-22  Kevin Ryde  <kevin@swox.se>

	* tests/rand/t-lc2exp.c (check_bigc1): New test.

	* doc/fdl.texi: Tweak @appendixsubsec -> @appendixsec to match our
	preference for this in an @appendix, and because texi2pdf doesn't
	support @appendixsubsec directly within an @appendix.

2004-04-20  Kevin Ryde  <kevin@swox.se>

	* doc/texinfo.tex: Update to 2004-04-07.08 from texinfo 4.7.
	* doc/gmp.texi, mpfr/mpfr.texi (@copying): Don't put a line break in
	@ref within @copying, recent texinfo.tex doesn't like that.

	* demos/perl/GMP.xs (static_functable): Treat cygwin the same as mingw
	DLLs.

	* */Makefile.in, install-sh: Update to automake 1.8.3.
	* ltmain.sh, aclocal.m4, configure: Update to libtool 1.5.6.

	* gmp-impl.h (LIMB_HIGHBIT_TO_MASK): Use a compile-time constant
	expression, rather than a configure test.
	* acinclude.m4, configure.in (GMP_C_RIGHT_SHIFT): Remove, no longer
	needed.
	* tests/t-hightomask.c: New file.
	* tests/Makefile.am (check_PROGRAMS): Add it.

	* macos/configure (parse_top_configure): Look for PACKAGE_NAME and
	PACKAGE_VERSION now used by autoconf.
	(what_objects): Only demand 9 object files, as for instance occurs in
	the scanf directory.
	(asm files): Transform labels L(foo) -> Lfoo.  Take func name from
	PROLOGUE to support empty "EPILOGUE()".  Recognise and subsitute
	register name "define()"s.
	* macos/Makefile.in (CmnObjs): Add tal-notreent.o.

2004-04-19  Torbjorn Granlund  <tege@swox.com>

	* tune/speed.h (SPEED_ROUTINE_MPN_ROOTREM): New #define.
	(speed_mpn_rootrem): Declare.
	* tune/common.c (speed_mpn_rootrem): New function.
	* tune/speed.c (routine): Add entry for mpn_rootrem.

2004-04-16  Kevin Ryde  <kevin@swox.se>

	* doc/fdl.texi: Update from FSF, just fixing a couple of typos.

	* macos/configure, macos/Makefile.in: Add printf and scanf directories.

	* tests/mpz/t-gcd.c (check_data): New function, exercising K6
	gcd_finda bug.

2004-04-14  Kevin Ryde  <kevin@swox.se>

	* doc/gmp.texi (Reentrancy, Random State Initialization): Note
	gmp_randinit use of gmp_errno is not thread safe.  Reported by Vincent
	Lefèvre.

	* doc/gmp.texi (Random State Initialization): Add index entries for
	gmp_errno and constants.

	* mpn/m68k/README: Update _SHORT_LIMB -> __GMP_SHORT_LIMB.

	* configure.in (--enable-mpbsd): Typo Berkley -> Berkeley in help msg.

2004-04-12  Kevin Ryde  <kevin@swox.se>

	* demos/perl/GMP.xs (static_functable): New macro, use it for all
	function tables, to support mingw DLL builds.
	* demos/perl/INSTALL (NOTES FOR PARTICULAR SYSTEMS): Remove note on
	DLLs, should be ok now.

	* demos/perl/sample.pl: Print the module and library versions in use.

	* demos/perl/GMP.pm, Makefile.PL (VERSION): Set to '2.00'.
	* demos/perl/GMP.pm (COPYRIGHT): New in the doc section.

	* Makefile.am: Note 4.1.3 libtool versioning info, and REVISION policy.

	* tal-debug.c: Add <stdlib.h> for abort.

2004-04-07  Torbjorn Granlund  <tege@swox.com>

	* tests/refmpf.c (refmpf_add_ulp): Adjust exponent when needed.

	* mpn/generic/random2.c: Rewrite (clone mpz/rrandomb.c).

2004-04-07  Kevin Ryde  <kevin@swox.se>

	* mpn/x86/k6/gcd_finda.asm: Correction jbe -> jb in initial setups.
	Zero flag is wrong here, it relects only the high limb of the compare,
	leading to n1>=n2 not satisfied and wrong results.  cp[1]==0x7FFFFFFF
	with cp[0]>=0x80000001 provokes this.

	* doc/gmp.texi (BSD Compatible Functions): Note "pow" name clash under
	the pow function description too.
	(Language Bindings): Add XEmacs (betas at this stage).  Reported by
	Jerry James.

	* tests/refmpn.c (refmpn_mod2): Correction to ASSERTs, r==a is allowed.

	* gen-psqr.c (generate_mod): Cast mpz_invert_ui_2exp args, for K&R.
	* gen-bases.c, gen-fib.c, gen-psqr.c: For mpz_out_str, use stdout
	instead of 0, in case a K&R treats int and FILE* params differently.

2004-04-04  Kevin Ryde  <kevin@swox.se>

	* gmp-impl.h (BSWAP_LIMB) [amd64]: New macro.
	(FORCE_DOUBLE): Use this for amd64 too.

	* tests/amd64check.c, tests/amd64call.asm: New files, derived in part
	from x86check.c and x86call.asm.
	* tests/Makefile.am (EXTRA_libtests_la_SOURCES): Add them.
	* configure.in (x86_64-*-* ABI=64): Use them.

2004-04-03  Kevin Ryde  <kevin@swox.se>

	* mpn/amd64/mode1o.asm: New file.
	* mpn/amd64/amd64-defs.m4 (ASSERT): New macro.

	* mpn/x86/k7/mmx/divrem_1.asm, mpn/x86/pentium4/sse2/divrem_1.asm: Add
	note on how "dr" part of algorithm is handled.

	* mpn/x86/k7/dive_1.asm, mpn/x86/k7/mod_34lsub1.asm,
	mpn/x86/k7/mode1o.asm: Note Hammer (32-bit mode) speeds.

2004-03-31  Kevin Ryde  <kevin@swox.se>

	* doc/gmp.texi (Language Bindings): Add GOO, MLGMP and Numerix.

	* mpf/mul_2exp.c, mpf/div_2exp.c: Rate u==0 as UNLIKELY.

2004-03-27  Torbjorn Granlund  <tege@swox.com>

	* mpn/generic/divrem_1.c: Fix typo.

	* mpn/generic/sqr_basecase.c: Fix typo.

2004-03-20  Kevin Ryde  <kevin@swox.se>

	* longlong.h (power, powerpc): Add comments on how we select this code.

	* gmp-h.in (mpz_get_ui): Use ?: instead of mask style, gcc treats the
	two identically but ?: is a bit clearer.

	* insert-dbl.c: Remove file, no longer used, scaling is now integrated
	in mpn_get_d.
	* Makefile.am (libgmp_la_SOURCES): Remove insert-dbl.c.
	* gmp-impl.h (__gmp_scale2): Remove prototype.

2004-03-17  Kevin Ryde  <kevin@swox.se>

	* mpn/x86/fat/fat.c (__gmpn_cpuvec_init, fake_cpuid_table): Add x86_64.

	* mpq/get_d.c: Use mpn_tdiv_qr, demand den>0 per canonical form.

2004-03-16  Torbjorn Granlund  <tege@swox.com>

	* mpn/generic/sqr_basecase.c: Add versions using mpn_addmul_2 and
	mpn_addmul_2s.

2004-03-14  Kevin Ryde  <kevin@swox.se>

	* mpf/mul_ui.c: Incorporate carry from low limbs, for exactness.
	* tests/mpf/t-mul_ui.c: New file.
	* tests/mpf/Makefile.am (check_PROGRAMS): Add it.

	* mpf/div.c: Use mpn_tdiv_qr.  Use just one TMP_ALLOC.  Use full
	divisor, since truncating can lose accuracy.
	* tests/mpf/t-div.c: New file.
	* tests/mpf/Makefile.am (check_PROGRAMS): Add it.

	* tests/mpf/t-set_q.c, tests/mpf/t-ui_div.c (check_various): Amend
	bogus 99/4 test.
	* tests/mpf/t-ui_div.c (check_rand): Exercise r==v overlap.

	* tests/refmpf.c, tests/tests.h (refmpf_set_overlap): New function.

	* mpf/cmp_si.c [nails]: Correction, cast vval in exp comparisons, for
	when vval=-0x800..00 and limb==longlong.

	* mpf/cmp_si.c [nails]: Correction, return usign instead of 1 when
	uexp==2 but value bigger than an mp_limb_t.
	* tests/mpf/t-cmp_si.c (check_data): Add test cases.

	* tests/trace.c (mpf_trace): Use ABS(mp_trace_base) to allow for
	negative bases used for upper case hex in integer traces.

2004-03-12  Torbjorn Granlund  <tege@swox.com>

	* mpn/generic/sb_divrem_mn.c: Correct header comment.

2004-03-11  Kevin Ryde  <kevin@swox.se>

	* aclocal.m4, configure, ltmain.sh: Downgrade to libtool 1.5, version
	1.5.2 doesn't remove .libs/*.a files when rebuilding, which is bad for
	development when changing contents or with duplicate named files like
	we have.

	Revert this, ie restore AR_FLAGS=cq:
	* acinclude.m4 (GMP_PROG_AR): Remove AR_FLAGS=cq, libtool 1.5.2 now
	does this itself on detecting duplicate object filenames in piecewise
	linking mode.

	* randbui.c, randmui.c [longlong+nails]: Correction to conditionals
	for second limb.

	* mpz/aors_ui.h, mpz/cdiv_q_ui.c, mpz/cdiv_qr_ui.c, mpz/cdiv_r_ui.c,
	mpz/cdiv_ui.c, mpz/fdiv_q_ui.c, mpz/fdiv_qr_ui.c, mpz/fdiv_r_ui.c,
	mpz/fdiv_ui.c, mpz/gcd_ui.c, mpz/iset_ui.c, mpz/lcm_ui.c,
	mpz/set_ui.c, mpz/tdiv_q_ui.c, mpz/tdiv_qr_ui.c, mpz/tdiv_r_ui.c,
	mpz/tdiv_ui.c, mpz/ui_sub.c, mpf/div_ui.c, mpf/mul_ui.c
	[longlong+nails]: Amend #if to avoid warnings about shift amount.

2004-03-07  Kevin Ryde  <kevin@swox.se>

	* mpf/reldiff.c: Use rprec+ysize limbs for d, to ensure accurate
	result.  Inline mpf_abs(d,d) and mpf_cmp_ui(x,0), and rate the latter
	UNLIKELY.

	* mpf/ui_div.c: Use mpn_tdiv_qr.  Use just one TMP_ALLOC.  Use full
	divisor, since truncating can lose accuracy.
	* tests/mpf/t-ui_div.c: New file.
	* tests/mpf/Makefile.am (check_PROGRAMS): Add it.

	* mpf/set_q.c: Expand TMP_ALLOC_LIMBS_2, to make conditional clearer
	and avoid 1 limb alloc when not wanted.

	* gmp-impl.h (WANT_TMP_DEBUG): Define to 0 if not defined.
	(TMP_ALLOC_LIMBS_2): Use "if" within macro rather than "#if", for less
	preprocessor conditionals.

	* mpf/mul_2exp.c, mpf/div_2exp.c: Add some comments.

	* tests/refmpn.c (refmpn_sb_divrem_mn, refmpn_tdiv_qr): Nailify.

2004-03-04  Kevin Ryde  <kevin@swox.se>

	* gen-psqr.c (print): Add CNST_LIMB in PERFSQR_MOD_TEST, for benefit
	of K&R.
	* tests/mpn/t-perfsqr.c (PERFSQR_MOD_1): Use CNST_LIMB for K&R.

	* doc/configuration (Configure): Remove mkinstalldirs, no longer used.

	* acinclude.m4 (GMP_PROG_AR): Remove AR_FLAGS=cq, libtool 1.5.2 now
	does this itself on detecting duplicate object filenames in piecewise
	linking mode.

	* configure.in (hppa2.0*-*-*): Test sizeof(long) == 4 or 8 to verify
	ABI=2.0n versus ABI=2.0w.  In particular this lets CC=cc_bundled
	correctly fall back to ABI=2.0n (we don't automatically add CC=+DD64
	to that compiler, currently).

	* doc/gmp.texi (Reentrancy): Note C++ mpf_class constructors using
	global default precision.
	(Random State Miscellaneous): Describe gmp_urandomb_ui as giving N
	bits.
	(C++ Interface Floats): Describe operator= copying the value, not the
	precision, and what this can mean about copy constructor versus
	default constructor plus assignment.

	* mpf/set_q.c: Use mpn_tdiv_qr rather than mpn_divrem, so no shifting.
	Don't truncate the divisor, it can make the result inaccurate.
	* tests/mpf/t-set_q.c: New file.
	* tests/mpf/Makefile.am (check_PROGRAMS): Add it.

	* mpf/set.c: Use MPN_COPY_INCR, in case r==u and ABSIZ(u) > PREC(r)+1.
	No actual bug here, because MPN_COPY has thusfar been an alias for
	MPN_COPY_INCR, only an ASSERT failure.
	* tests/mpf/t-set.c: New file.
	* tests/mpf/Makefile.am (check_PROGRAMS): Add it.

	* mpf/set.c, mpf/iset.c: Do MPN_COPY last, for possible tail call.

	* mpf/set_d.c: Rate d==0 as UNLIKELY.  Store size before extract call,
	to shorten lifespan of "negative".

	* mpf/init.c, mpf/init2.c, mpf/iset_d.c, mpf/iset_si.c,
	mpf/iset_str.c, mpf/iset_ui.c: Store prec before alloc call, for one
	less live quantity across that call.
	* mpf/init.c, mpf/init2.c, mpf/iset_str.c: Store size and exp before
	alloc call, to overlap with other operations.

	* tests/refmpf.c, tests/tests.h (refmpf_fill, refmpf_normalize,
	refmpf_validate, refmpf_validate_division): New functions.

	* tests/refmpn.c, tests/tests.h (refmpn_copy_extend,
	refmpn_lshift_or_copy_any, refmpn_rshift_or_copy_any): New functions.

	* tal-debug.c: Add <string.h> for strcmp.

	* tests/cxx/t-istream.cc (check_mpz, check_mpq, check_mpf): Use size_t
	for loop index, to quieten g++ warning.

2004-03-01  Torbjorn Granlund  <tege@swox.com>

	With Karl Hasselström:
	* mpn/generic/dc_divrem_n.c (mpn_dc_div_2_by_1): New function, with
	meat from old mpn_dc_divrem_n.  Accept scratch parameter.  Rewrite to
	avoid a recursive call.
	(mpn_dc_div_3_by_2): New function, with meat from old
	mpn_dc_div_3_halves_by_2.  Accept scratch parameter.
	(mpn_dc_divrem_n): Now just allocate scratch space and call new
	mpn_dc_div_2_by_1.

2004-02-29  Kevin Ryde  <kevin@swox.se>

	* longlong.h (count_leading_zeros) [alpha gcc]: New version, inlining
	mpn/alpha/cntlz.asm cmpbge technique.

	* aclocal.m4, configure, install-sh, missing, ltmain.sh,
	*/Makefile.in: Update to automake 1.8.2 and libtool 1.5.2.

	* doc/gmp.texi (C++ Interface Integers): Note / and % rounding follows
	C99 / and %.
	(Exact Remainder): Index entries for divisibility testing algorithm.

	* tune/time.c (speed_endtime): Return 0.0 for negative time measured.
	Revise usage comments for clarity.
	* tune/common.c (speed_measure): Recognise speed_endtime 0.0 for
	failed measurement.

	* tests/mpn/t-get_d.c (check_rand): Correction to nhigh_mask setup.

2004-02-27  Torbjorn Granlund  <tege@swox.com>

	* tune/tuneup.c (tune_dc, tune_set_str): Up param.step_factor.

	* tests/mpz/t-gcd.c: Decrease # of tests to 50.

2004-02-27  Kevin Ryde  <kevin@swox.se>

	* tests/devel/try.c: Add a comment that this is not for Cray systems.

	* mpf/set_q.c: Don't support den(q)<0, demand canonical form in the
	usual way.

2004-02-24  Torbjorn Granlund  <tege@swox.com>

	From Kevin:
	* mpn/generic/mul_fft.c (mpn_fft_add_modF): Loop until normalization
	criterion met.

2004-02-22  Kevin Ryde  <kevin@swox.se>

	* acinclude.m4 (GMP_PROG_CC_WORKS, GMP_OS_X86_XMM, GMP_PROG_CXX_WORKS):
	Remove files that might look like compiler output, so our "||"
	alternatives are not fooled.

	* acinclude.m4 (GMP_PROG_CC_WORKS): Add test for lshift_com code
	mis-compiled by certain IA-64 HP cc at +O3.

	* gmp-impl.h (USE_LEADING_REGPARM): Disable under prof or gprof, for
	the benefit of freebsd where .mcount clobbers registers.  Spotted by
	Torbjorn.
	* configure.in (WANT_PROFILING_PROF, WANT_PROFILING_GPROF): New
	AC_DEFINEs.

2004-02-21  Kevin Ryde  <kevin@swox.se>

	* configure.in (sparc64-*-*bsd*): Amend -m32 setup for ABI=32, so it's
	not used in ABI=64 on the BSD systems.

2004-02-18  Niels Möller  <nisse@lysator.liu.se>

	* tests/mpz/t-gcd.c (gcdext_valid_p): New function.
	(ref_mpz_gcd): Deleted function.
	(one_test): Rearranged to call mpz_gcdext first, so that the
	returned value can be validated.
	(main): Don't use ref_mpz_gcd.

2004-02-18  Torbjorn Granlund  <tege@swox.com>

	* gmp-impl.h (MPN_TOOM3_MAX_N): Move to !WANT_FFT section.

	* tests/mpz/t-mul.c: Exclude special huge operands unless WANT_FFT.

	* mpz/rrandomb.c (gmp_rrandomb): Rewrite.

	* mpn/generic/mul_n.c (mpn_toom3_sqr_n): Remove write-only variable c5.

2004-02-18  Kevin Ryde  <kevin@swox.se>

	* mpf/iset_si.c, mpf/iset_ui.c, mpf/set_si.c, mpf/set_ui.c [nails]:
	Always store second limb, to avoid a conditional.

	* tests/mpf/t-get_ui.c: New file.
	* tests/mpf/Makefile.am (check_PROGRAMS): Add it.
	* tests/mpf/t-get_si.c (check_limbdata): Further tests.
	* gmp-impl.h (MP_EXP_T_MAX, MP_EXP_T_MIN): New defines.

	* mpf/get_ui.c, mpf/get_si.c: Remove size==0 test, it's covered by
	other conditions.  Attempt greater clarity by expressing conditions as
	based on available data range.
	* mpf/get_si.c [nails]: Correction, don't bail on exp > abs_size,
	since may still have second limb above radix point available.
	* mpf/get_ui.c: Nailify.

2004-02-16  Kevin Ryde  <kevin@swox.se>

	* mpz/scan0.c, mpz/scan1.c: Use count_trailing_zeros, instead of
	count_leading_zeros on limb&-limb.

	* mpf/sqrt.c: Use "/ 2" for exp, avoiding C undefined behaviour on
	">>" of negatives.  Correction to comment, exp is rounded upwards.
	SIZ(r) always prec now, no need for tsize expression.  Store EXP(r)
	and SIZ(r) where calculated to reduce variable lifespans.  Make tsize
	mp_size_t not mp_exp_t, though of course those are currently the same.

	* gmp-h.in (GMP_ERROR_ALLOCATE, GMP_ERROR_BAD_STRING,
	GMP_ERROR_UNUSED_ERROR): Remove, never used or documented, and we
	don't want to use globals for communicating error information.

	* mpz/gcd_ui.c [nails]: Correction, actually return a value.

	* mpn/generic/addmul_1.c, mpn/generic/submul_1.c [nails==1]: Add code.

2004-02-15  Kevin Ryde  <kevin@swox.se>

	* tests/mpz/t-jac.c (check_data): Remove unnecessary variable
	"answer".

2004-02-14  Kevin Ryde  <kevin@swox.se>

	* acinclude.m4 (GMP_C_RIGHT_SHIFT): Note that it's "long"s which we're
	concerned about.

	* mpn/generic/mul_n.c: Add some remarks about toom3 high zero
	stripping.

	* mpn/generic/scan0.c, mpn/generic/scan1.c: Remove design issue
	remarks.  What to do about going outside `up' space is a problem, but
	anything to address it would be an incompatible change.

2004-02-11  Kevin Ryde  <kevin@swox.se>

	* longlong.h (power, powerpc): Use HAVE_HOST_CPU_FAMILY_power and
	HAVE_HOST_CPU_FAMILY_powerpc rather than various cpp defines.

	* gmp-impl.h: Add remarks about limits.h and Cray etc.

	* dumbmp.c (mpz_mul): Set ALLOC(r) for new data block used.  Reported
	by Jason Moxham.

	* mpn/pa32/README, mpn/pa64/README (REFERENCES): New sections.

2004-02-10  Torbjorn Granlund  <tege@swox.com>

	* tests/mpz/t-gcd.c: Decrease # of tests run.

	* mpn/*/gmp-mparam.h: Add HGCD values, update TOOM values.

2004-02-01  Torbjorn Granlund  <tege@swox.com>

	From Kevin:
	* config.guess: Recognize AMD's hammer processors, return x86_64.

2004-01-24  Kevin Ryde  <kevin@swox.se>

	* tests/mpf/t-sqrt.c (check_rand1): Further diagnostic printouts.

	* mpn/generic/sqrtrem.c (mpn_sqrtrem): Add ASSERT_MPN.
	(mpn_dc_sqrtrem): Add casts for K&R.

	* mpf/sqrt_ui.c: Nailify.

	* mpf/set_z.c: Do MPN_COPY last, for possible tail call.

	* doc/gmp.texi (Miscellaneous Float Functions): For mpf_random2, note
	exponent is in limbs.

2004-01-22  Kevin Ryde  <kevin@swox.se>

	* mpf/sqrt.c: Change tsize calculation to get prec limbs result
	always, previously got prec+1 when exp was odd.
	* tests/mpf/t-sqrt.c (check_rand1): New function, code from main.
	(check_rand2): New function.

	* mpf/sqrt_ui.c: Change rsize calculation to get prec limbs result,
	previously got prec+1.
	* tests/mpf/t-sqrt_ui.c: New file.
	* tests/mpf/Makefile.am (check_PROGRAMS): Add it.

	* tests/refmpf.c, tests/tests.h (refmpf_add_ulp,
	refmpf_set_prec_limbs): New functions.

	* mpz/get_d_2exp.c, mpf/get_d_2exp.c: Remove x86+m68k force to double,
	mpn_get_d now does this.  Remove res==1.0 check for round upwards,
	mpn_get_d now rounds towards zero.  Move exp store to make mpn_get_d a
	tail call.

	* configure.in (x86-*-*): Use ABI=32 rather than ABI=standard.
	Use gcc -m32 when available, to force mode on bi-arch amd64 gcc.
	* configure.in, acinclude.m4 (x86_64-*-*): Merge into plain x86 setups
	as ABI=64.  Support ABI=32, using athlon code.  Use gcc -mcpu=k8,
	-march=k8.
	(amd64-*-*): Remove pattern, config.sub only gives x86_64.
	* doc/gmp.texi (ABI and ISA): Add x86_64 dual ABIs.

	* mpn/amd64/README: Add reference to ABI spec.

2004-01-17  Kevin Ryde  <kevin@swox.se>

	* tune/README: Remove open/mpn versions of toom3, no longer exist.
	* tune/powerpc64.asm: Remove unused L(again).
	* tune/time.c (mftb): Note single mftb possible for powerpc64.

	* mpn/generic/mode1o.c: Use "c<s" to do underflow detection in last
	step, for better parallelism.

	* mpn/generic/get_d.c: Preserve comments about hppa fcnv,udw,dbl from
	previous mpz_get_d code.

	* tune/freq.c: Add some comments about systems not covered.

	* gmp-h.in (_GMP_H_HAVE_FILE): Add _MSL_STDIO_H for Metrowerks.
	Reported by Tomas Zahradnicky.

2004-01-16  Kevin Ryde  <kevin@swox.se>

	* configure.in (powerpc64-*-linux*): Try gcc64.  Try -m64 with
	"cflags_maybe" to get it used in all probing.  Add sizeof-long-8 test
	to check the mode is right if -m64 is not applicable.

2004-01-15  Kevin Ryde  <kevin@swox.se>

	* configure.in (--with-readline=detect): Check for readline/readline.h
	and readline/history.h.  Report result of detection.

2004-01-12  Niels Möller  <nisse@lysator.liu.se>

	* tests/tests.h: Added refmpn_free_limbs prototype.
	* tests/refmpn.c (refmpn_free_limbs): New function.

2004-01-11  Kevin Ryde  <kevin@swox.se>

	* mpn/alpha/ev6/slot.pl: New file, derived in part from
	mpn/x86/k6/cross.pl.

	* mpn/alpha/alpha-defs.m4 (ASSERT): New macro.

	* mpn/asm-defs.m4 (m4_ifdef): New macro, avoiding OSF 4.0 m4 bug.
	(m4_assert_defined): Use it.

	* mpn/alpha/default.m4, mpn/alpha/unicos.m4 (LDGP): New macro.
	* mpn/alpha/ev67/gcd_1.asm: Use it to re-establish gp after jsr.

	* configure.in, demos/calc/Makefile.am: Use -lcurses or -lncurses with
	readline, when available.

	* longlong.h (sub_ddmmss) [generic]: Use al<bl for the borrow rather
	than __x>al, since the former can be done without waiting for __x,
	helping superscalar chips, in particular alpha ev5 and ev6.

	* longlong.h (sub_ddmmss) [ia64]: New macro.

	* tests/t-sub.c: New file.
	* tests/Makefile.am (check_PROGRAMS): Add it.
	* tests/refmpn.c, tests/tests.h (refmpn_sub_ddmmss): New function.

2004-01-09  Kevin Ryde  <kevin@swox.se>

	* mpn/x86/p6/mod_34lsub1.asm: New file, derived in part from
	mpn/x86/mod_34lsub1.asm.

	* configure.in (IA64_PATTERN): Use -mtune on gcc 3.4.

2004-01-07  Kevin Ryde  <kevin@swox.se>

	* gmp-h.in, mp-h.in (__GMP_SHORT_LIMB): Renamed from _SHORT_LIMB, to
	keep in our namespace.  (Not actually used anywhere currently.)
	Reported by Patrick Pelissier.

	* mp-h.in: Use "! defined (__GMP_WITHIN_CONFIGURE)" in the same style
	as gmp-h.in (though mp-h.in is not actually used during configure).

	* mp-h.in (__GMP_DECLSPEC_EXPORT, __GMP_DECLSPEC_IMPORT) [__GNUC__]:
	Use __dllexport__ and __dllimport__ to keep out of application
	namespace.  Same previously done in gmp-h.in.

2004-01-06  Kevin Ryde  <kevin@swox.se>

	* configfsf.sub, configfsf.guess: Update to 2004-01-05.
	* configure.in (amd64-*-* | x86_64-*-*): Update comments on what
	configfsf.sub does.

2004-01-04  Kevin Ryde  <kevin@swox.se>

	* mpn/alpha/README (REFERENCES): Add tru64 assembly manuals.
	(ASSEMBLY RULES): Note what gcc says about !literal! etc.

2004-01-03  Kevin Ryde  <kevin@swox.se>

	* mpn/alpha/ev67/gcd_1.asm: New file.

	* mpn/x86/pentium4/sse2/rsh1add_n.asm: New file, derived in part from
	mpn/x86/pentium4/sse2/addlsh1_n.asm.

	* mpn/x86/p6/p3mmx/popham.asm: Note measured speeds.

	* mpn/x86/pentium4/sse2/addlsh1_n.asm (PARAM_CARRY): Remove macro, not
	used, no such parameter.

	* mpn/generic/gcd.c: Use <stdio.h> for NULL.

	* doc/gmp.texi (Single Limb Division): Correction to tex expression
	for (1/2)x1.  And minor wording tweaks elsewhere.

	* gmp-impl.h (mpn_rsh1add_n, mpn_rsh1sub_n): Correction to comments
	about how carries returned.

	* longlong.h (umul_ppmm) [generic]: Add comments about squaring
	(dropped from tasks list)

2003-12-31  Kevin Ryde  <kevin@swox.se>

	* demos/perl/GMP.xs (scan0, scan1): Return ~0 for not-found.
	* demos/perl/GMP.pm: Describe this, remove the note about ULONG_MAX
	being the same as ~0 (which is not true in old perl).
	* demos/perl/test.pl: Update tests.
	* demos/perl/typemap (gmp_UV): New type.

	* demos/perl/test.pl (fits_slong_p): Comment out uv_max test, it won't
	necessarily exceed a long.

	* demos/perl/GMP.pm: Add a remark about get_str to the bugs section.

	* mpn/generic/sqrtrem.c, mpz/fac_ui.c, tests/mpf/reuse.c: Add casts
	for K&R.
	* tests/mpf/t-muldiv.c: Make ulimb, vlimb into ulongs, which is how
	they're used, for the benefit of K&R calling.

	* doc/gmp.texi (Square Root Algorithm): Add a summary of the algorithm.
	And add further index entries in various places.

	* mpz/lucnum_ui.c, mpz/lucnum2_ui.c: Use mpn_addlsh1_n when available.

	* gmp-impl.h, mpn/generic/mul_n.c (mpn_addlsh1_n, mpn_sublsh1_n,
	mpn_rsh1add_n, mpn_rsh1sub_n): Move descriptions to gmp-impl.h with
	the prototypes, for ease of locating.

2003-12-29  Torbjorn Granlund  <tege@swox.com>

	* tests/mpz/t-gcd.c: Rewrite, based on suggestions by Kevin.

	* mpn/sparc64/README: Remove mpn_Xmul_2, done.
	Add blurb about L1 cache conflicts.

2003-12-29  Kevin Ryde  <kevin@swox.se>

	* mpn/generic/mul_fft.c, mpz/root.c, mpq/cmp_ui.c: Add casts for K&R.

2003-12-27  Kevin Ryde  <kevin@swox.se>

	* tests/mpz/t-mul.c (mul_kara, mul_basecase): Use __GMP_PROTO.

	* Makefile.am (AUTOMAKE_OPTIONS): Restore this, giving no directory on
	ansi2knr to avoid a circular build rule.
	* configure.in (AM_INIT_AUTOMAKE): Note options also in Makefile.am.

	* configure.in (cflags_maybe): Don't loop adding cflags_maybe if the
	user has set CFLAGS.

2003-12-23  Kevin Ryde  <kevin@swox.se>

	* configure.in (*sparc*-*-*): Test sizeof(long)==4 or 8 for ABIs, to
	get the right mode when the user sets the CFLAGS.
	(testlist): Introduce "any_<abi>_testlist" to apply to all compilers.

	* demos/perl/typemap (MPZ_ASSUME, MPQ_ASSUME, MPF_ASSUME): Remove
	output rules, these are only meant for inputs.
	(MPZ_MUTATE): Remove, not used since changes for magic.

	* demos/perl/GMP.xs (mpz_class_hv, mpq_class_hv, mpf_class_hv): New
	variables, initialized in BOOT.
	* demos/perl/GMP.xs, demos/perl/typemap: Use them and explicit
	sv_bless, to save a gv_stashpv for every new object.

2003-12-22  Kevin Ryde  <kevin@swox.se>

	* mpn/alpha/mode1o.c, mpn/alpha/dive_1.c: Moved from ev5/mode1o.c and
	ev5/dive_1.c, these are good for ev4, and would like them in a generic
	alpha build.

2003-12-21  Kevin Ryde  <kevin@swox.se>

	* doc/gmp.texi (Integer Logic and Bit Fiddling): Say "bitwise" in
	mpz_and, mpz_ior and mpz_xor, to avoid any confusion with what C means
	by "logical".  Reported by Rüdiger Schütz.

	* gmp-h.in (_GMP_H_HAVE_FILE): Note why defined(EOF) is not good.

2003-12-20  Kevin Ryde  <kevin@swox.se>

	* tune/speed.h (SPEED_TMP_ALLOC_LIMBS): Correction to last change,
	don't want "- 1" on the TMP_ALLOC_LIMBS.

	* demos/expr/expr.h: Test #ifdef MPFR_VERSION_MAJOR for when mpfr.h is
	included, not GMP_RNDZ which is now an enum.

	* demos/expr/exprfra.c (e_mpfr_ulong_p): Use mpfr_integer_p and
	mpfr_fits_ulong_p.
	(e_mpfr_get_ui_fits): Use mpfr_get_ui.

	* mpfr/*: Update to mpfr cvs head 2003-12-20.

	* configure, config.in: Update to autoconf 2.59.
	* */Makefile.in, configure, aclocal.m4, ansi2knr.c, install-sh,
	doc/mdate-sh: Update to automake 1.8.

	* mkinstalldirs: Remove, not required by automake 1.8.
	* doc/gmp.texi (Build Options): HTML is a usual target in automake 1.8.

	* configure.in (AC_PREREQ): Require autoconf 2.59.
	(AM_INIT_AUTOMAKE): Require automake 1.8.
	(AC_C_INLINE): Use rather than GMP_C_INLINE, now has #ifndef
	__cplusplus we want.
	(gettimeofday): Use AC_CHECK_FUNCS rather than our workaround code,
	autoconf now ok.

	* acinclude.m4 (GMP_C_INLINE): Remove.
	(GMP_H_EXTERN_INLINE): Use AC_C_INLINE.
	(GMP_PROG_AR): Comment on automake $ARFLAGS.

2003-12-19  Torbjorn Granlund  <tege@swox.com>

	* tests/mpf/t-get_d.c: Print message before aborting.

	* mpn/generic/get_d.c: Make ONE_LIMB case actually work for nails.

2003-12-18  Torbjorn Granlund  <tege@swox.com>

	* mpz/get_d.c: Don't include longlong.h.

	* tests/mpz/t-mul.c (ref_mpn_mul): Handle un == vn specially, to avoid
	a dummy r/w outside of allocated area.

2003-12-18  Kevin Ryde  <kevin@swox.se>

	* mpn/alpha/unicos.m4 (ALIGN): Add comments on what GCC does.

	* configure.in (fat setups), acinclude.m4 (GMP_INIT): Obscure
	include() from automake 1.8 aclocal.
	* acinclude.m4: Quote names in AC_DEFUN, for automake 1.8 aclocal.

2003-12-13  Kevin Ryde  <kevin@swox.se>

	* mpq/get_d.c: Amend comments per mpn_get_d change.
	(limb2dbl): Remove, no longer used.

	* gmp-impl.h (DIVREM_1_NORM_THRESHOLD etc) [nails]: Correction to
	comments, MP_SIZE_T_MAX means preinv never.

	* gmp-impl.h (DIVEXACT_1_THRESHOLD, MODEXACT_1_ODD_THRESHOLD) [nails]:
	Remove overrides, divexact_1 and modexact_1 have been nailified.

	* mpz/inp_str.c (mpz_inp_str_nowhite): Use ASSERT_ALWAYS for EOF value
	requirement.

	* tests/refmpn.c (refmpn_rsh1add_n, refmpn_rsh1sub_n): Parens around
	GMP_NUMB_BITS - 1 with ">>", to quieten gcc -Wall.
	* tests/t-constants.c (main), tests/t-count_zeros.c (check_clz),
	tests/t-modlinv.c (one), tests/mpz/t-jac.c (try_si_zi),
	tests/mpq/t-get_d.c (check_onebit): : Correction to printfs.
	* tests/mpn/t-fat.c: Add <string.h> for memcpy.
	* tests/mpz/t-scan.c (check_ref): Remove unused variable "isigned".
	* tests/mpq/t-get_d.c (check_onebit): Remove unused variable "limit".
	* tests/mpf/t-set_si.c, tests/mpf/t-set_ui.c (check_data): Braces for
	initializers.
	* tests/devel/try.c (mpn_divexact_by3_fun, mpn_modexact_1_odd_fun):
	Correction to return values.

	* doc/gmp.texi (Miscellaneous Integer Functions): Note mpz_sizeinbase
	can be used to locate the most significant bit.  Reword a bit for
	clarity.

2003-12-11  Torbjorn Granlund  <tege@swox.com>

	* gmp-impl.h: Change asm => __asm__, tabify.
	* mpz/get_d_2exp.c: Likewise.
	* mpf/get_d_2exp.c: Likewise.

	* tests/cxx/t-ops.cc: #if .. #endif out tests that cause ambiguities.

2003-12-10  Torbjorn Granlund  <tege@swox.com>

	* tests/mpz/t-gcd.c: Generate operands with sizes as a geometric
	progression, to allow for larger operands and less varying timing.

2003-12-10  Kevin Ryde  <kevin@swox.se>

	* demos/perl/test.pl: Should be $] for perl version in old perl.

	* configure.in (sparc64-*-*): Single block of gcc configs for all
	systems, on unknown systems try both ABI 32 and 64.

	* configure.in (LIBGMP_LDFLAGS, LIBGMPXX_LDFLAGS): New AC_SUBSTs with
	options to generate .def files with windows DLLs.
	* Makefile.am (libgmp_la_LDFLAGS, libgmpxx_la_LDFLAGS): Use them.

	* mpn/generic/gcd.c: Use ABOVE_THRESHOLD / BELOW_THRESHOLD, to follow
	convention and cooperate with tune/tuneup.c.

	* tune/common.c, tune/speed.c, tune/speed.h, tune/speed-ext.c,
	tune/tuneup.c (SPEED_TMP_ALLOC_LIMBS): Take variable as parameter
	rather than returning a value, avoids alloca in a function call.
	* tune/common.c, tune/speed.h (speed_tmp_alloc_adjust): Remove, now
	inline in SPEED_TMP_ALLOC_LIMBS, and using ptr-NULL for alignment
	extraction.

	* gmpxx.h (__gmp_binary_equal, __gmp_binary_not_equal,
	__gmp_binary_less, __gmp_binary_less_equal, __gmp_binary_greater,
	__gmp_binary_greater_equal, __gmp_cmp_function): Use mpfr_cmp_si and
	mpfr_cmp_d.
	* tests/cxx/t-ops.cc: Exercise this.

	* demos/perl/Makefile.PL: Don't install sample.pl and test2.pl.

	* demos/perl/GMP.xs (use_sv): Prefer PV over IV or NV to avoid any
	rounding.
	* demos/perl/test.pl: Exercise this.

	* demos/perl/GMP/Mpf.pm (overload_string): Corrections to $# usage.
	* demos/perl/test.pl: Exercise this.

2003-12-08  Kevin Ryde  <kevin@swox.se>

	* demos/perl/GMP.pm: Correction to canonicalize example.

	* demos/perl/GMP.xs: New type check scheme, support magic scalars,
	support UV when available.  Remove some unused local variables.
	(coerce_long): Check range of double.
	(get_d_2exp): Remove stray printf.

	* demos/perl/test.pl: Exercise magic, rearrange to make it clearer
	what's being tested.

2003-12-07  Kevin Ryde  <kevin@swox.se>

	* tune/tuneup.c (mul_toom3_threshold): Use MUL_TOOM3_THRESHOLD_LIMIT,
	for the benefit of ASSERT in mpn_mul_n.

	* tune/tuneup.c (tune_mul): Correction to toom3 param.min_size, should
	use MPN_TOOM3_MUL_N_MINSIZE.

	* tune/speed.c (check_align_option): Correction to printf format.
	* tune/freq.c (freq_sysctl_hw_model): Remove unused "i" variable.

	* scanf/doscan.c: Correction to a couple of trace printfs.
	Add <stdlib.h> for strtol.

	* tests/misc/t-scanf.c (test_sscanf_eof_ok): New function.
	(check_misc): Use it to suppress tests broken by libc.
	And should be EOF rather than -1 in various places.

2003-12-06  Torbjorn Granlund  <tege@swox.com>

	* mpn/generic/get_str.c (mpn_get_str, POW2_P case):
	Don't append extra '\0' byte.

2003-12-05  Niels Möller  <niels@lysator.liu.se>

	* tune/speed.h (mpn_gcd_accel): Added prototype.

2003-12-05  Torbjorn Granlund  <tege@swox.com>

	* randmt.c (__gmp_mt_recalc_buffer): Put parens around "&" expressions
	inside "!=".

	* mpf/get_str.c: Remove unused variable "fracn".

2003-12-03  Kevin Ryde  <kevin@swox.se>

	* configure.in, Makefile.am (LIBGMP_LDFLAGS, LIBGMPXX_LDFLAGS): New
	AC_SUBSTs, use them to create .def files with Windows DLLs.
	* doc/gmp.texi (Notes for Particular Systems): Update notes on mingw
	DLL with MS C.

	* mpz/export.c: Allow NULL for countp.
	* doc/gmp.texi (Integer Import and Export): Describe this.
	Suggested by Jack Lloyd.

	* mpn/x86/p6/aors_n.asm: New file, grabbing the K7 code.
	Superiority of this reported by Patrick Pelissier.

2003-11-30  Kevin Ryde  <kevin@swox.se>

	* mpn/alpha/ev67/popcount.asm, mpn/alpha/ev67/hamdist.asm: New files.

	* mpn/alpha/ev67: New directory.
	* configure.in (alphaev67, alphaev68, alphaev7*): Use it.

	* doc/gmp.texi (GMPrefu, GMPpxrefu): Change back to plain ref and
	pxref, remove macros.
	(GMPreftopu, GMPpxreftopu): Remove URL parameter, rename to GMPreftop
	and GMPpxreftop.
	(Debugging): Remove debauch, seems to have disappeared.
	(Language Bindings): Corrections to URLs for CLN, Omni F77, Pike.

2003-11-29  Kevin Ryde  <kevin@swox.se>

	* demos/perl/GMP/Mpf.pm (overload_string): Use $OFMT to avoid warnings
	about $#.

	* demos/perl/GMP.xs (fits_slong_p): Use LONG_MAX+1 to avoid possible
	rounding of 0x7F..FF in a double on 64-bit systems.

	* configure.in (ppc601-*-*): Remove this case, it never matched
	anything, the name adopted is powerpc601.
	(powerpc601-*-*): Use gcc -mcpu=601, xlc -qarch=601.

	* configure.in: Introduce ${cc}_cflags_maybe, used if they work.
	(*sparc*-*-*) [ABI=32]: Add gcc_cflags_maybe=-m32 to force that mode.

	* doc/gmp.texi (Introduction to GMP): Add AMD64 to optimizations list.
	(Build Options): Add cpu types alphaev7 and amd64.  Update texinfo
	html cross reference.

2003-11-28  Niels Möller  <nisse@lysator.liu.se>

	* mpn/generic/gcd.c (MPN_LEQ_P): Copied macro definition (needed
	for compilation with --enable-assert).

2003-11-27  Niels Möller  <nisse@lysator.liu.se>

	* tests/mpz/t-gcd.c (gcd_values): Moved definition, so that we
	don't need to forward declare the array.

2003-11-26  Torbjorn Granlund  <tege@swox.com>

	* tests/mpz/t-gcd.c: Generate random operands up to 32767 bits;
	decrease # of test to 1000.
	(gcd_values): Remove oversize test case.

2003-11-26  Niels Möller  <niels@lysator.liu.se>

	* tests/mpz/t-gcd.c (main): Added some tests with non-random
	input.

2003-11-25  Niels Möller  <nisse@lysator.liu.se>

	* gmp-impl.h (MPN_LEQ_P, MPN_EXTRACT_LIMB): New macros.

2003-11-25  Kevin Ryde  <kevin@swox.se>

	* doc/gmp.texi (Language Bindings): Add Axiom.

2003-11-22  Kevin Ryde  <kevin@swox.se>

	* mpn/alpha/README: More notes on assembler syntax variations.

	* mpn/alpha/alpha-defs.m4, mpn/alpha/unicos.m4 (unop): Should be ldq_u
	not bis, and move to alpha-defs.m4 since it can be happily used
	everywhere.

	* mpn/alpha/alpha-defs.m4, mpn/alpha/default.m4, mpn/alpha/unicos.m4
	(bigend): Move to alpha-defs.m4 and base it on HAVE_LIMB_BIG_ENDIAN or
	HAVE_LIMB_LITTLE_ENDIAN, so as not to hard code system endianness.

	* mpn/alpha/alpha-defs.m4: New file.
	* configure.in (alpha*-*-*): Use it.

2003-11-21  Kevin Ryde  <kevin@swox.se>

	* mpfr/*: Update to mpfr-2-0-2-branch 2003-11-21.

	* mpn/alpha/ev5/com_n.asm: Change "not" to "ornot r31", since "not"
	isn't recognised by on Cray Unicos.  Add missing "gp" to PROLOGUE.
	* mpn/alpha/README: Add a note on "not".

2003-11-19  Torbjorn Granlund  <tege@swox.com>

	* mpn/alpha/aorslsh1_n.asm: Slightly rework feed-in code, avoiding
	spurious reads beyond operand limits.

	* mpn/alpha/ev5/com_n.asm: Add ASM_START/ASM_END.

	* mpn/generic/mul_fft.c (mpn_fft_zero_p): Remove unused function.
	(mpn_lshift_com): Make static, nailify properly.

2003-11-19  Kevin Ryde  <kevin@swox.se>

	* mpn/generic/diveby3.c: Use a "q" variable to make it clearer what
	the code is doing.

	* mpn/powerpc32/750/lshift.asm, mpn/powerpc32/750/rshift.asm: New
	files.

	* mpn/alpha/ev5/com_n.asm: New file.

	* doc/gmp.texi (Assembler Functional Units, Assembler Writing Guide):
	New sections by Torbjorn, tweaked by me.

2003-11-17  Torbjorn Granlund  <tege@swox.com>

	* mpn/powerpc32: Add power4/powerpc970 cycle counts.
	Use cmpwi instead of cmpi to placate darwin.

2003-11-15  Kevin Ryde  <kevin@swox.se>

	* config.guess: Add comments on MacOS "machine" command.

	* tests/devel/try.c (main): Use gmp_randinit_default explicitly on
	__gmp_rands, since RANDS doesn't allow seeding.

	* doc/gmp.texi (Assigning Integers): Remove notes on possible change
	to disallow whitespace, this would be an incompatible change and
	really can't be made.
	(Toom 3-Way Multiplication): Updates for Paul's new code.

	* mpn/generic/mul_n.c (toom3_interpolate, mpn_toom3_mul_n): Put
	if/else braces around whole of #if code, for readability.

	* tests/refmpn.c (refmpn_addlsh1_n, refmpn_sublsh1_n,
	refmpn_rsh1add_n, refmpn_rsh1sub_n): Add ASSERTs for operand overlaps
	etc.

	* mpfr/*: Update to mpfr-2-0-2-branch 2003-11-15.

2003-11-14  Torbjorn Granlund  <tege@swox.com>

	* mpn/alpha/aorslsh1_n.asm: Use Cray-friendly syntax for "br".

2003-11-13  Torbjorn Granlund  <tege@swox.com>

	* mpn/alpha/aorslsh1_n.asm: New file.

2003-11-12  Kevin Ryde  <kevin@swox.se>

	* acinclude.m4 (GMP_PROG_CC_WORKS): Add case provoking AIX power2
	assembler, test code by Torbjorn.
	* configure.in (power*-*-*): Add a comment about -mcpu=rios2 fallback.

	* tune/speed.c (main): Use gmp_randinit_default explicitly on
	__gmp_rands, since RANDS doesn't allow seeding.

	* mpfr/*: Update to mpfr-2-0-2-branch 2003-11-12.

	* gmp-impl.h, randmt.h (__gmp_randinit_mt_noseed): Move prototype to
	gmp-impl.h, for use by RANDS.

	* mpn/Makeasm.am (.s, .S, .asm): Quote $< in test -f, per automake.
	(.obj): Use test -f and $(CYGPATH_W) as per automake.

2003-11-11  Kevin Ryde  <kevin@swox.se>

	* configure.in: Make umul and udiv standard-optional objects, rather
	than under various extra_functions.

	* mpn/pa32/hppa1_1/pa7100/add_n.asm,
	mpn/pa32/hppa1_1/pa7100/addmul_1.asm,
	mpn/pa32/hppa1_1/pa7100/lshift.asm,
	mpn/pa32/hppa1_1/pa7100/rshift.asm,
	mpn/pa32/hppa1_1/pa7100/sub_n.asm,
	mpn/pa32/hppa1_1/pa7100/submul_1.asm: Use LDEF for labels.

	* mpf/set_str.c: Don't use memcmp for decimal point testing, just a
	loop is enough and avoids any chance of memcmp reading past the end of
	the given string.

	* randmts.c, randmt.h: New files.
	* Makefile.am (libgmp_la_SOURCES): Add them.
	* randmt.c: Move seeding to randmts.c, common defines in randmt.h.
	* gmp-impl.h (RANDS): Use __gmp_randinit_mt_noseed.
	* tests/misc.c (tests_rand_start): Use gmp_randinit_default
	explicitly, not RANDS.

	* mpn/ia64/ia64-defs.m4 (PROLOGUE_cpu): Use 32-byte alignment, for the
	benefit of itanium 2.
	* mpn/ia64/gcd_1.asm: Remove own .align 32.

	* mpn/ia64/ia64-defs.m4 (ALIGN): New define, using IA64_ALIGN_OK.

	* acinclude.m4 (GMP_ASM_IA64_ALIGN_OK): New macro.
	* configure.in (IA64_PATTERN): Use it.
	* mpn/ia64/README: Add notes on gas big endian align problem.

2003-11-08  Torbjorn Granlund  <tege@swox.com>

	* mpn/x86/aors_n.asm: Align loop to a multiple of 16.  Also align
	M4_function_n to a multiple of 16, to minimize alignment padding.
	Update P6 cycle counts reflecting improvements with new alignment.

2003-11-07  Kevin Ryde  <kevin@swox.se>

	* gmp-impl.h (HAVE_HOST_CPU_alpha_CIX): New define.
	(ULONG_PARITY, popc_limb): Use it, to pick up ev7 as well as 67 and 68.
	* longlong.h (count_leading_zeros, count_trailing_zeros): Ditto.

	* doc/gmp.texi (Notes for Package Builds): Add notes on multi-ABI
	system packaging.
	(ABI and ISA): Add GNU/Linux ABI=64.
	(Binary GCD): Add notes on 1x1 GCD algorithms.

	* mpn/alpha/README: Add some literature references.

	* mpn/ia64/mode1o.asm: Various corrections to initial checkin.
	* mpn/ia64/ia64-defs.m4 (ASSERT): Correction to arg quoting.

2003-11-05  Torbjorn Granlund  <tege@swox.com>

	* mpn/powerpc64/linux64.m4: New file.
	* configure.in (POWERPC64_PATTERN): Handle *-*-linux*.
	Use linux64.m4.

2003-11-05  Kevin Ryde  <kevin@swox.se>

	* tune/freq.c (freq_sysctl_hw_model): Relax to just look for "%u MHz",
	for the benefit of sparc cypress under netbsd 1.6.1.

	* mpfr/*: Update to mpfr-2-0-2-branch 2003-11-05.

	* mpn/alpha/ev5/dive_1.c: New file.

	* configure.in (x86_64-*-*): Accept together with amd64-*-*.

	* tune/speed.c: Check range of -x,-y,-w,-W alignment specifiers.
	* tune/speed.h (CACHE_LINE_SIZE): Amend comments.

2003-11-04  Torbjorn Granlund  <tege@swox.com>

	* tune/speed.c: Fix typo in testing HAVE_NATIVE_mpn_modexact_1_odd.

2003-11-03  Kevin Ryde  <kevin@swox.se>

	* mpn/ia64/mode1o.asm: New file.
	* mpn/ia64/ia64-defs.m4 (ASSERT): New macro.

	* tests/mpz/t-set_d.c (check_2n_plus_1): New test.

2003-11-01  Kevin Ryde  <kevin@swox.se>

	* mpz/fac_ui.c (BSWAP_ULONG) [limb==2*long]: Remove this case, it
	provokes code gen problems on HP cc.
	(BSWAP_ULONG) [generic]: Rename __dst variable to avoid conflicts with
	BITREV_ULONG.
	Fix by Jason Moxham.

	* mpn/powerpc32/mode1o.asm: Use 16-bit i*i for early out, no need to
	truncate divisor.  Amend stated 750/7400 speeds, and note operands
	that give the extremes.

	* mpz/set_d.c: Don't use a special case for d < MP_BASE_AS_DOUBLE, gcc
	3.3 -mpowerpc64 on darwin gets ulonglong->double casts wrong.

	* mpn/generic/diveby3.c: Show a better style carry handling in the
	alternative pipelined sample code.

	Revert this, the longlong.h macros need -mpowerpc64:
	* acinclude.m4 (GMP_GCC_POWERPC64): New macro.
	* configure.in (powerpc64-*-darwin*): Use it to exclude -mpowerpc64
	when bad.

2003-10-31  Kevin Ryde  <kevin@swox.se>

	* mpfr/*: Update to mpfr-2-0-2-branch 2003-10-31.

	* mpn/powerpc64/README: Add subdirectory organisation notes.

	* tests/mpn/t-get_d.c: Don't use limits.h, LONG_MIN is wrong on gcc
	2.95 with -mcpu=ultrasparc.

	* acinclude.m4 (GMP_GCC_POWERPC64): New macro.
	* configure.in (powerpc64-*-darwin*): Use it to exclude -mpowerpc64
	when bad.

	* configure.in (powerpc64-*-darwin*) [ABI=mode32]: Use gcc -mcpu flags.

	* mpn/ia64/gcd_1.asm: Use "C" for comments.
	* mpn/ia64/README, mpn/ia64/ia64-defs.m4: Note this.

	* mpn/ia64/ia64-defs.m4: Renamed from default.m4, per other defs files.
	* configure.in (IA64_PATTERN): Update GMP_INCLUDE_MPN.

	* doc/gmp.texi (Notes for Particular Systems): Remove m68k ABI notes
	for -mshort and PalmOS, now works.
	(References): Correction, GMP Square Root proof already there, just
	wanting URL from RRRR 4475.

2003-10-29  Kevin Ryde  <kevin@swox.se>

	* configure.in (sparc*-*-*): Use gcc -m32 when that option works, to
	force 32-bit mode on dual 32/64 configurations like GNU/Linux.
	(sparc64-*-linux*): Add support for ABI=64.

	* mpn/generic/pre_divrem_1.c: In fraction part, use CNST_LIMB(0) with
	udiv_qrnnd_preinv to avoid warning about shift > type.

	* mpfr/*: Update to mpfr-2-0-2-branch 2003-10-29.

	* tests/cxx/t-istream.cc: Avoid tellg() checks if putback() doesn't
	update that, avoids certain g++ 2.96 problems.

	* tests/mpn/t-fat.c: New file.
	* tests/mpn/Makefile.am (check_PROGRAMS): Add it.

	* configure.in (CPUVEC_INSTALL, ITERATE_FAT_THRESHOLDS): New macros
	for fat.h.
	* mpn/x86/fat/fat.c (__gmpn_cpuvec_init): Use CPUVEC_INSTALL instead
	of memcpy.  Correction to location of "initialized" set.  Improve
	various comments.

2003-10-27  Torbjorn Granlund  <tege@swox.com>

	* mpn/sparc64/mul_1.asm: Change addcc => add in a few places.
	* mpn/sparc64/addmul_1.asm: Likewise.

	* mpn/sparc32/v9/mul_1.asm: Apply cross-jumping.
	* mpn/sparc32/v9/addmul_1.asm: Likewise.
	* mpn/sparc32/v9/submul_1.asm: Likewise.
	* mpn/sparc32/v9/sqr_diagonal.asm: Likewise.

2003-10-27  Kevin Ryde  <kevin@swox.se>

	* tests/cxx/t-misc.cc: Don't use <climits>, on g++ 2.95.4 (debian 3.0)
	-mcpu=ultrasparc LONG_MIN is wrong and kills the compile.

	* tests/cxx/t-istream.cc: Correction to tellg tests, don't assume
	streampos is zero based.

	* configure.in (HAVE_HOST_CPU_FAMILY_alpha): New define for config.h.
	* mpn/generic/get_d.c: Use it instead of __alpha for alpha workaround,
	since Cray cc doesn't define __alpha.

	* mpn/x86/README: Revise PIC coding notes a bit, add gcc visibility
	attribute.

2003-10-25  Kevin Ryde  <kevin@swox.se>

	* mpn/ia64/gcd_1.asm: New file.

	* tune/many.pl: Allow for PROLOGUE(fun,...), as used on alpha.

	* doc/gmp.texi (C++ Formatted Input): Describe base indicator handling.

	* tests/cxx/t-istream.cc: New file.
	* tests/cxx/Makefile.am: Add it.

	* cxx/ismpznw.cc: New file, integer input without whitespace ...
	* cxx/ismpz.cc: ... from here.
	* gmp-impl.h (__gmpz_operator_in_nowhite): Add prototype.
	* cxx/ismpq.cc: Rewrite using mpz input routines.  Change to accept a
	separate base indicator on numerator and denominator.  Fix base
	indicator case where "123/0456" would stop at "123/0".
	* Makefile.am, cxx/Makefile.am: Add cxx/ismpznw.cc.

	* tests/mpz/t-set_d.c: New file, derived from tests/mpz/t-set_si.c
	* tests/mpz/Makefile.am (check_PROGRAMS): Add it.

	* mpn/m68k/lshift.asm, mpn/m68k/rshift.asm: Support 16-bit int and
	stack alignment.
	* mpn/m68k/README: Add notes on this.
	* configure.in (SIZEOF_UNSIGNED): New define in config.m4.
	* mpn/m68k/m68k-defs.m4 (m68k_definsn): Add cmpw, movew.
	Reported by Patrick Pelissier.

	* mpn/m68k/t-m68k-defs.pl: Don't use -> with hashes, to avoid
	deprecation warnings from perl 5.8.

	* configure.in (viac3-*-*): Use just x86/pentium in $path not x86/p6.
	If gcc is to be believed the old C3s don't have cmov.

	* Makefile.am: Amend comments about not building from libtool
	convenience libraries.

	* mpn/asm-defs.m4 (PROLOGUE): Use m4_file_seen, for correct filename
	in missing EPILOGUE error messages.
	(m4_file_seen): Amend comments about where used.

	* Makefile.am (CXX_OBJECTS): Remove $U, C++ files are not subject to
	ansi2knr rules.

	* gmp-h.in (mpn_divmod_1): Use __GMP_CAST, to avoid warnings in
	applications using g++ -Wold-style-cast.

	* mpn/z8000/README: New file.

2003-10-22  Kevin Ryde  <kevin@swox.se>

	* mpn/generic/get_d.c (CONST_1024, CONST_NEG_1023,
	CONST_NEG_1022_SUB_53): Replace ALPHA_WORKAROUND with a non-gcc-ism,
	and use on Cray Unicos alpha too, which has the same problem.

	* configure.in (powerpc64-*-darwin*): Make ABI=32 available as the
	final fallback, remove mode64 until we know how it will work.

	* doc/gmp.texi (Build Options): Add powerpc970 to available CPUs.
	(ABI and ISA): Add mode32 for Darwin.

	* configure.in (gettimeofday): Use an explicit AC_TRY_LINK, to avoid
	known autoconf 2.57 problems with gettimeofday in AC_CHECK_FUNCS on
	HP-UX.

	* configure.in (powerpc*-*-*): Use ABI=32 instead of ABI=standard for
	the default 32-bit ABI.  Fixes powerpc64-*-aix* which is documented as
	choices "aix64 32" but had "aix64 standard".

	* mpfr/*: Update to mpfr-2-0-2-branch 2003-10-22.

	* doc/gmp.texi (Notes for Particular Systems): Note m68k gcc -mshort
	and PalmOS calling conventions not supported.  Reported by Patrick
	Pelissier.
	(References): Add Paul Zimmermann's Inria 4475 paper.

2003-10-21  Kevin Ryde  <kevin@swox.se>

	* tests/mpn/t-instrument.c: Add mpn_addlsh1_n, mpn_rsh1add_n,
	mpn_rsh1sub_n, mpn_sub_nc, mpn_sublsh1_n.  Typo in mpn_preinv_divrem_1
	conditional.

2003-10-20  Torbjorn Granlund  <tege@swox.com>

	* mpn/powerpc64/mode32/add_n.asm: New file.
	* mpn/powerpc64/mode32/sub_n.asm: New file.
	* mpn/powerpc64/mode32/mul_1.asm: New file.
	* mpn/powerpc64/mode32/addmul_1.asm: New file.
	* mpn/powerpc64/mode32/submul_1.asm: New file.

2003-10-19  Torbjorn Granlund  <tege@swox.com>

	* longlong.h (AMD64): __x86_64__ => __amd64__.
	(64-bit powerpc): Only define carry-dependent macros if
	!_LONG_LONG_LIMB.

	* acinclude.m4 (POWERPC64_PATTERN): Add powerpc970-*-*.

	* configure.in (POWERPC64_PATTERN): Handle *-*-darwin*.
	(POWERPC64_PATTERN, *-*-aix*): Prepend powerpc64/mode64 to path_aix64.

	* mpn/powerpc64/mode64/mul_1.asm: Change cal => addi.
	* mpn/powerpc64/mode64/addmul_1.asm: Likewise.
	* mpn/powerpc64/mode64/submul_1.asm: Likewise.
	* mpn/powerpc64/sqr_diagonal.asm: Likewise.

	* mpn/powerpc64/mode64/mul_1.asm: Move from "..".
	* mpn/powerpc64/mode64/addmul_1.asm: Likewise.
	* mpn/powerpc64/mode64/submul_1.asm: Likewise.
	* mpn/powerpc64/mode64/divrem_1.asm: Likewise.
	* mpn/powerpc64/mode64/rsh1sub_n.asm: Likewise.
	* mpn/powerpc64/mode64/add_n.asm: Likewise.
	* mpn/powerpc64/mode64/addsub_n.asm: Likewise.
	* mpn/powerpc64/mode64/sub_n.asm: Likewise.
	* mpn/powerpc64/mode64/addlsh1_n.asm: Likewise.
	* mpn/powerpc64/mode64/diveby3.asm: Likewise.
	* mpn/powerpc64/mode64/rsh1add_n.asm: Likewise.
	* mpn/powerpc64/mode64/sublsh1_n.asm: Likewise.

	* mpn/powerpc64/lshift.asm: Handle mode32 ABI.
	* mpn/powerpc64/rshift.asm: Likewise.
	* mpn/powerpc64/umul.asm: Likewise.

	* tune/powerpc64.asm: Make it actually work.

2003-10-19  Kevin Ryde  <kevin@swox.se>

	* mpn/generic/get_d.c: Add a workaround for alpha gcc signed constant
	comparison bug.

	* gmpxx.h (gmp_randclass gmp_randinit_lc_2exp_size constructor): Throw
	std::length_error if size is too big.
	* tests/cxx/t-rand.cc (check_randinit): Exercise this.

	* mpn/x86/pentium4/sse2/addlsh1_n.asm: New file, derived in part from
	mpn/x86/pentium4/sse2/add_n.asm.

	* doc/gmp.texi (C++ Interface Integers, C++ Interface Rationals, C++
	Interface Floats): Note std::invalid_argument exception for invalid
	strings to constructors and operator=.
	(C++ Interface Random Numbers): Note std::length_error exception for
	size too big in gmp_randinit_lc_2exp_size.

2003-10-18  Kevin Ryde  <kevin@swox.se>

	* mpfr/*: Update to mpfr-2-0-2-branch 2003-10-18.

	* gmpxx.h (mpz_class, mpq_class, mpf_class, mpfr_class constructors
	and operator= taking string or char*): Throw std::invalid_argument if
	string cannot be converted.
	* tests/cxx/t-constr.cc, tests/cxx/t-assign.cc: Exercise this.

	* cxx/ismpz.cc, cxx/ismpq.cc, cxx/ismpf.cc: Use istream std::locale
	ctype facet for isspace when available.  Only accept space at the
	start of the input, same as g++ libstdc++.  Use ASSERT_NOCARRY to
	check result of mpz_set_str etc.
	* cxx/ismpf.cc: Don't accept "@" for exponent indicator.

	* tune/speed.c, tune/speed.h, tune/common.c, tune/Makefile.am: Remove
	_open and _mpn variants of mpn_toom3_mul_n, only one style now.
	* tune/mul_n_open.c, tune/mul_n_mpn.c: Remove files.

	* gmp-impl.h (LIMB_HIGHBIT_TO_MASK): New macro.
	(udiv_qrnnd_preinv2, udiv_qrnnd_preinv2gen): Use it.

	* tests/mpz/t-import.c, tests/mpz/t-export.c: Use octal for character
	constants, hex is an ANSI-ism.

	* mpn/alpha/ev5/mode1o.c: Corrections to ASSERTs, as per
	mpn/generic/mode1o.c.

	* mpn/generic/diveby3.c: Add commented out alternative code and notes
	for taking the multiply off the dependent chain.  Amend/clarify some
	of the other comments.

	* configure.in (powerpc970-*-*): Use gcc -mcpu=970 when available.
	(powerpc7400-*-*): Fallback on gcc -mcpu=750 if -mcpu=7400 not
	available.

	* doc/gmp.texi (C++ Formatted Input): Note locale digit grouping not
	supported.
	(C++ Formatted Input, C++ Formatted Output): Cross reference class
	interface on overloading.

	* mpn/m68k/README: Add various ideas from doc/tasks.html.

	* mpn/m88k/README: New file.

2003-10-16  Torbjorn Granlund  <tege@swox.com>

	* config.sub: Recognize powerpc970.

2003-10-15  Torbjorn Granlund  <tege@swox.com>

	* config.guess: Recognize powerpc970 under MacOS.

2003-10-15  Kevin Ryde  <kevin@swox.se>

	* configure.in, acinclude.m4 (GMP_C_RIGHT_SHIFT): New test.
	* gmp-impl.h (LIMB_HIGHBIT_TO_MASK): New macro.
	(udiv_qrnnd_preinv2, udiv_qrnnd_preinv2gen): Use it.

	* mpn/amd64/amd64-defs.m4: New file, with a non-aligning PROLOGUE.
	* configure.in (amd64-*-*): Use it.

	* mpfr/*: Update to mpfr cvs 2003-10-15.

	* mpn/generic/get_d.c: Rewrite, simplifying and truncating towards
	zero unconditionally.
	* tests/mpn/t-get_d.c: Add various further tests.
	* gmp-impl.h (FORCE_DOUBLE): New macro.

	* gmp-h.in (__mpz_struct): Add comment on __mpz_struct getting into
	C++ mangled function names.

	* doc/gmp.texi (Build Options): Update notes for new doc subdir.
	(Low-level Functions): Note mpn functions don't check for zero limbs
	etc, it's up to an application to strip.

	* doc/configuration (Configure): mdate-sh now in doc subdir, add
	generated fat.h.

2003-10-13  Kevin Ryde  <kevin@swox.se>

	* mpn/powerpc32/mod_34lsub1.asm: New file.

	* mpn/powerpc32/diveby3.asm, mpn/powerpc64/diveby3.asm: src[] in
	second operand of mullw, to allow possible early-out, which the
	0xAA..AB inverse cannot give.  This improvement noticed by Torbjorn.

	* acinclude.m4 (GMP_ASM_LSYM_PREFIX): Print to config.log whether
	local label is purely temporary or appears in object files, for
	development purposes.

	* doc/gmp.texi, doc/fdl.texi, doc/texinfo.tex, doc/mdate-sh: Moved
	from top-level.
	* doc/Makefile.am: New file.
	* configure.in (AC_OUTPUT): Add doc/Makefile.
	* Makefile.am (SUBDIRS): Move doc subdirectory from EXTRA_DIST.
	(info_TEXINFOS, gmp_TEXINFOS): Moved to doc/Makefile.am.
	* mpfr/Makefile.am (mpfr_TEXINFOS): fdl.texi now in doc subdir.
	(TEXINFO_TEX): texinfo.tex now in doc subdir.
	(AM_MAKEINFOFLAGS): Set -I to doc subdir.

	* mpz/and.c: For positive/positive, use mpn_and_n, rate a realloc as
	UNLIKELY.

	* mpn/generic/mul_n.c (mpn_toom3_mul_n, mpn_toom3_sqr_n): Don't test
	for high zero limbs.

2003-10-12  Torbjorn Granlund  <tege@swox.com>

	* mpn/powerpc64/diveby3.asm: New file (trivial edits of
	powerpc32/diveby3.asm).

	* mpn/powerpc32/diveby3.asm: Update cycle counts with more processors.
	* mpn/powerpc32/sqr_diagonal.asm: Likewise.

	* mpn/pa64/add_n.asm: Correct PA8500 cycle counts.
	* mpn/pa64/sub_n.asm: Likewise.

	* mpn/m68k/aors_n.asm (INPUT PARAMETERS): Fix typo.
	* mpn/m68k/lshift.asm: Likewise.
	* mpn/m68k/rshift.asm: Likewise.

	* mpn/m68k/README: Correct an URL; add some STATUS comments.

	* mpn/powerpc32/addlsh1_n.asm: New file.
	* mpn/powerpc32/sublsh1_n.asm: New file.

2003-10-12  Kevin Ryde  <kevin@swox.se>

	* mpn/sparc64/divrem_1.c, mpn/sparc64/mod_1.c: New files.
	* mpn/sparc64/sparc64.h (HALF_ENDIAN_ADJ, count_leading_zeros_32,
	invert_half_limb, udiv_qrnnd_half_preinv): New macros.

	* gmp-impl.h (udiv_qrnnd_preinv2): Use a ? : for getting the n1 bit,
	so as not to depend on signed right shifts being arithmetic.

	* mpn/powerpc32/diveby3.asm: New file.

	* mpn/generic/divrem_1.c: Use CNST_LIMB(0) to avoid warnings from
	udiv_qrnnd_preinv about shift count when int<long.  Do the same with
	udiv_qrnnd, for consistency.

	* Makefile.am (install-data-hook): Print a warning recommending "make
	check" to watch out for compiler bugs.  Proposed by Torbjorn.

2003-10-11  Torbjorn Granlund  <tege@swox.com>

	* mpn/asm-defs.m4: Handle rsh1aors_n.

	* configure.in (tmp_mulfunc): Handle rsh1aors_n.

2003-10-11  Kevin Ryde  <kevin@swox.se>

	* mpn/x86/pentium4/sse2/diveby3.asm: Remove non-PIC RODATA memory
	access for 0xAAAAAAAB constant.

	* gmp-impl.h (popc_limb, ULONG_PARITY) [ev67, ev68]: Add gcc asm
	versions using ctpop.

	* mpn/x86/k6/aorsmul_1.asm: Tweak some comments, remove M4_description
	and M4_desc_retval used only in comments.

	* mpn/x86/k6/mul_basecase.asm: Add comment on using mpn_mul_1.

2003-10-09  Torbjorn Granlund  <tege@swox.com>

	* mpn/powerpc64/addlsh1_n.asm: Tweak for 0.25 c/l better loop speed.
	* mpn/powerpc64/sublsh1_n.asm: Likewise.

2003-10-09  Kevin Ryde  <kevin@swox.se>

	* mpfr/*: Update to mpfr cvs 2003-10-09.

	* tests/devel/try.c (_SC_PAGESIZE): Define from _SC_PAGE_SIZE on
	systems which use that, eg. hpux 9.

2003-10-07  Kevin Ryde  <kevin@swox.se>

	* tune/freq.c (freq_sysctl_hw_model): Correction to last sscanf	change.

	* configure.in: Check for psp_iticksperclktick in struct pst_processor.
	* tune/freq.c (freq_pstat_getprocessor): Use this.

	* tests/devel/try.c (divisor_array): Add a couple of half-limb values.

	* acinclude.m4 (GMP_PROG_CC_WORKS): Correction to last change, need to
	set result "yes" when cross compiling.

2003-10-06  Torbjorn Granlund  <tege@swox.com>

	* mpn/generic/mul_n.c: Use __GMPN_ADD_1/_GMPN_SUB_1 instead of
	mpn_add_1 and mpn_sub_1.

	* mpn/pa64/aorslsh1_n.asm: Schedule register save and restore code.

2003-10-05  Torbjorn Granlund  <tege@swox.com>

	* mpn/pa64/mul_1.asm: Misc comment cleanups.
	* mpn/pa64/addmul_1.asm: Likewise.
	* mpn/pa64/submul_1.asm: Likewise.

	* mpn/pa64/README: Correct cycle counts.

	* mpn/pa64/aorslsh1_n.asm: New file.

2003-10-04  Kevin Ryde  <kevin@swox.se>

	* tune/freq.c (freq_sysctl_hw_model, freq_sunos_sysinfo,
	freq_sco_etchw, freq_bsd_dmesg, freq_irix_hinv): Demand matching of
	MHz etc at end of sscanf format string.  In particular need this for
	freq_bsd_dmesg on i486-pc-freebsd4.7 to avoid the 486 cpu being used
	for the frequency.

	* tests/misc.c, tests/tests.h (tests_setjmp_sigfpe,
	tests_sigfpe_handler, tests_sigfpe_done, tests_sigfpe_target,
	tests_dbl_mant_bits): New.

	* configure.in (viac3*-*-*): Add gcc VIA c3 options.

	* mpfr/*: Update to mpfr cvs 2003-10-04.

	* tests/refmpn.c (refmpn_addlsh1_n, refmpn_sublsh1_n,
	refmpn_rsh1add_n, refmpn_rsh1sub_n): Add ASSERTs for operand overlaps.
	* tests/tests.h (refmpn_addlsh1_n, refmpn_sublsh1_n, refmpn_rsh1add_n,
	refmpn_rsh1sub_n): Add prototypes.

	* tests/devel/try.c, tune/many.pl: Add mpn_addlsh1_n, mpn_sublsh1_n,
	mpn_rsh1add_n, mpn_rsh1sub_n.

2003-10-03  Torbjorn Granlund  <tege@swox.com>

	* tests/refmpn.c (refmpn_addlsh1_n, refmpn_sublsh1_n, refmpn_rsh1add_n,
	refmpn_rsh1sub_n): New functions.

2003-10-03  Paul Zimmermann  <Paul.Zimmermann@loria.fr>

	* mpn/generic/mul_n.c (toom3_interpolate): Use mpn_add_1/mpn_sub_1
	instead of MPN_INCR_/MPN_DECR_U.

2003-10-02  Torbjorn Granlund  <tege@swox.com>

	* configure.in (ia64*-*-hpux*): Fall back to +O1, not +O.

2003-10-02  Kevin Ryde  <kevin@swox.se>

	* configure.in (ia64*-*-hpux*): For cc, let +O optimization level
	fallback if +O3 doesn't work.

	* acinclude.m4 (GMP_PROG_CC_WORKS): Add a test of __builtin_alloca
	when available, to pick up Itanium HP-UX cc internal errors in +O2.
	Provoking code by Torbjorn.

2003-10-01  Torbjorn Granlund  <tege@swox.com>

	* mpn/asm-defs.m4: Handle aorslsh1_n.

	* configure.in (tmp_mulfunc): Handle aorslsh1_n.

2003-10-01  Kevin Ryde  <kevin@swox.se>

	* acinclude.m4 (GMP_C_DOUBLE_FORMAT): Make bad ARM last byte into a
	separate case and consider it non-IEEE, since it looks like this is
	due to some sort of restricted or incorrect software floats.

	* demos/calc/Makefile.am: Use automake yacc/lex support, seems fine in
	separate objdir now.

	* cxx/dummy.cc: Moved from top-level dummy.cc.
	* Makefile.am (libgmpxx_la_SOURCES): Update to cxx/dummy.cc,
	correction to comment about this.

2003-09-30  Torbjorn Granlund  <tege@swox.com>

	* demos/pexpr.c: Correct documentation of -split.
	(TIME): Remove cast of result to double.
	(main): Change timing variables to int.
	(main): #ifdef LIMIT_RESOURCE_USAGE, don't convert numbers of more than
	100000 digits.

2003-09-28  Torbjorn Granlund  <tege@swox.com>

	* mpn/*/*.asm: Clean up spacing, tabify.

	* mpn/alpha/rshift.asm: Table cycle counts.
	* mpn/alpha/lshift.asm: Likewise.
	* mpn/alpha/ev5/rshift.asm: Likewise.
	* mpn/alpha/ev5/lshift.asm: Likewise.
	* mpn/alpha/ev6/add_n.asm: Likewise.
	* mpn/alpha/ev6/sub_n.asm: Likewise.

	* mpn/pa64/mul_1.asm: Fix comment typo.
	* mpn/pa64/addmul_1.asm: Likewise.
	* mpn/pa64/submul_1.asm: Likewise.

2003-09-27  Torbjorn Granlund  <tege@swox.com>

	* mpn/powerpc64/README: Update with POWER4/PPC970 pipeline info.

	* mpn/powerpc64/rshift.asm: Rewrite.
	* mpn/powerpc64/lshift.asm: Rewrite.

2003-09-25  Torbjorn Granlund  <tege@swox.com>

	* tune/common.c (speed_mpn_addlsh1_n, speed_mpn_sublsh1_n,
	speed_mpn_rsh1add_n, speed_mpn_rsh1sub_n): Conditionalize on
	corresponding HAVE_NATIVE_*.

2003-09-25  Kevin Ryde  <kevin@swox.se>

	* mpz/combit.c: Use GMP_NUMB_BITS not BITS_PER_MP_LIMB.

	* demos/expr/exprfr.c: Allow for mpfr_inf_p, mpfr_nan_p and
	mpfr_number_p merely returning non-zero, rather than 1 or 0.

	* demos/expr/exprfr.c, demos/expr/t-expr.c: Add erf, integer_p, zeta.

	* demos/expr/Makefile.am (LDADD): Update comments on $(LIBM).

2003-09-24  Torbjorn Granlund  <tege@swox.com>

	* tune/speed.c (routine): Add entires for mpn_addlsh1_n, mpn_sublsh1_n,
	mpn_rsh1add_n, and mpn_rsh1sub_n.

	* tune/speed.h: Declare speed_mpn_addlsh1_n, speed_mpn_sublsh1_n,
	speed_mpn_rsh1add_n, and speed_mpn_rsh1sub_n.

	* tune/common.c (speed_mpn_addlsh1_n, speed_mpn_sublsh1_n,
	speed_mpn_rsh1add_n, speed_mpn_rsh1sub_n): New functions.

	* gmp-impl.h: Declare mpn_addlsh1_n, mpn_sublsh1_n, mpn_rsh1add_n, and
	mpn_rsh1sub_n.

	* mpn/asm-defs.m4: Add define_mpn's for addlsh1_n, sublsh1_n,
	rsh1add_n, and rsh1sub_n.

	* mpn/powerpc64/*.asm: Add cycle counts in consistent style.  Misc
	styling edits.

	* configure.in: Add #undefs for HAVE_NATIVE_mpn_addlsh1_n,
	HAVE_NATIVE_mpn_sublsh1_n, HAVE_NATIVE_mpn_rsh1add_n,
	HAVE_NATIVE_mpn_rsh1sub_n.
	(gmp_mpn_functions_optional): List addlsh1_n, sublsh1_n, rsh1add_n,
	and rsh1sub_n.

2003-09-24  Kevin Ryde  <kevin@swox.se>

	* mpfr/*: Update to mpfr cvs 2003-09-24.

	* acinclude.m4 (GMP_C_DOUBLE_FORMAT): Remove conftest* temporary files.

2003-09-23  Torbjorn Granlund  <tege@swox.com>

	* gmp-impl.h (MUL_TOOM3_THRESHOLD, SQR_TOOM3_THRESHOLD): Now 128.

2003-09-23  Kevin Ryde  <kevin@swox.se>

	* gmp-h.in (gmp_randinit_set): Use __gmp_const rather than const.

2003-09-22  Torbjorn Granlund  <tege@swox.com>

	* tune/mul_n_mpn.c: (__gmpn_sqr_n): New #define.
	* tune/mul_n_open.c (__gmpn_sqr_n): New #define.

	* mpn/generic/mul.c (mpn_sqr_n): Move from here...
	* mpn/generic/mul_n.c (mpn_sqr_n): ...to here.
	(mpn_sqr_n): Allocate workspace for toom3 using	TMP_* mechanism except
	for very large operands when !WANT_FFT.

	* mpn/generic/mul_n.c: Add a missing ";". Misc comment fixes.

	* mpn/generic/mul.c: Remove spurious #include <stdio.h>.

	* mpn/x86/k7/gmp-mparam.h: Retune.

	* mpn/generic/mul_n.c (mpn_mul_n): Allocate workspace for toom3 using
	TMP_* mechanism except for very large operands when !WANT_FFT.

	* gmp-impl.h (MPN_TOOM3_MUL_N_TSIZE, MPN_TOOM3_SQR_N_TSIZE):
	Define conditionally on WANT_FFT and HAVE_NATIVE_mpn_sublsh1_n.
	(MPN_TOOM3_MAX_N): New #define.

	* mpn/generic/sqr_basecase.c: Use mpn_addlsh1_n when available.

	* mpn/generic/mul_n.c: Use proper form for HAVE_NATIVE macros.

2003-09-22  Kevin Ryde  <kevin@swox.se>

	* mpfr/*: Update to mpfr cvs 2003-09-22.

2003-09-21  Kevin Ryde  <kevin@swox.se>

	* mpn/x86/pentium4/sse2/gmp-mparam.h (USE_PREINV_DIVREM_1,
	USE_PREINV_MOD_1): Set to 1 for new asm versions.

	* mpfr/*: Update to mpfr cvs 2003-09-21.

2003-09-21  Paul Zimmermann  <Paul.Zimmermann@loria.fr>

	* mpn/generic/mul_n.c (mpn_toom3_mul_n): Conditionally use
	mpn_sublsh1_n, mpn_rsh1add_n and mpn_rsh1sub_n, in addition to
	mpn_addlsh1_n.  Avoid all copying, at the expense of some additional
	workspace.

	* gmp-impl.h (MPN_TOOM3_MUL_N_TSIZE, MPN_TOOM3_SQR_N_TSIZE): Accomodate
	latest toom3 code.

2003-09-19  Kevin Ryde  <kevin@swox.se>

	* mpn/x86/pentium4/sse2/divrem_1.asm, mpn/x86/pentium4/sse2/mod_1.asm:
	New files.

2003-09-16  Kevin Ryde  <kevin@swox.se>

	* tune/speed.c (run_one): Don't scale the -1.0 not-available return.
	Print "n/a" for times not-available.

2003-09-13  Paul Zimmermann  <Paul.Zimmermann@loria.fr>

	* mpn/generic/mul_n.c (toom3_interpolate): New function.
	(mpn_toom3_mul_n, mpn_toom3_sqr_n): Call toom3_interpolate.

2003-09-12  Torbjorn Granlund  <tege@swox.com>

	* mpn/generic/mul_n.c (mpn_toom3_mul_n, mpn_toom3_sqr_n): Remove unused
	variables.
	(mpn_toom3_mul_n, mpn_toom3_sqr_n): Use offset `+ 1', not `+ 2' in last
	MPN_DECR_U calls.

2003-09-12  Paul Zimmermann  <Paul.Zimmermann@loria.fr>

	* mpn/generic/mul_n.c (mpn_toom3_mul_n, mpn_toom3_sqr_n): Rewrite.

2003-09-12  Torbjorn Granlund  <tege@swox.com>

	* gmp-impl.h (MPN_KARA_MUL_N_TSIZE, MPN_KARA_SQR_N_TSIZE): Reformulate
	to use the same form as MPN_TOOM3_MUL_N_TSIZE.
	(MPN_TOOM3_MUL_N_TSIZE, MPN_TOOM3_SQR_N_TSIZE): Update for new Toom3
	code requirements.
	* mpn/generic/mul_n.c (evaluate3, interpolate3, add2Times): Remove.
	(USE_MORE_MPN): Remove.

2003-08-31  Kevin Ryde  <kevin@swox.se>

	* mpfr/*: Update to mpfr cvs 2003-08-31.

2003-08-30  Kevin Ryde  <kevin@swox.se>

	* mpfr/*: Update to mpfr cvs 2003-08-30.

2003-08-29  Torbjorn Granlund  <tege@swox.com>

	* mpn/amd64/README: New file.

2003-08-23  Kevin Ryde  <kevin@swox.se>

	* tune/freq.c (freq_getsysinfo): Correction to speed_cycletime value
	established.

	* mpz/rootrem.c, gmp-h.in, gmp.texi (mpz_rootrem): Don't return
	exactness indication, can get that from testing the remainder.

	* mpn/x86/k7/aors_n.asm, mpn/x86/k7/mmx/copyi.asm: Amend to comments
	about loads and stores and what speed should be possible.

2003-08-19  Kevin Ryde  <kevin@swox.se>

	* longlong.h (add_ssaaaa, sub_ddmmss) [hppa 64]: Move down into main
	__GNUC__ block.  Exclude for _LONG_LONG_LIMB (ie. ABI=2.0n) since
	these forms are only for ABI=2.0w.

	* longlong.h (count_leading_zeros) [__mcpu32__]: Check __mcpu32__ to
	avoid bfffo on GCC 3.4 in CPU32 mode.  Reported by Bernardo Innocenti.

	* longlong.h (count_trailing_zeros) [x86_64]: Use "%q0" to force
	64-bit register destination.  Pointed out by Torbjorn.

	* mpz/combit.c: Correction to carry handling when extending a
	negative, and use __GMPN_ADD_1.  Correction to complement limb for a
	negative when there's a non-zero low limb.
	* tests/mpz/bit.c (check_clr_extend, check_com_negs): Exercise these.

	* demos/perl/GMP.xs, demos/perl/GMP.pm, demos/perl/test.pl: Add
	get_d_2exp.
	* demos/perl/GMP.xs, demos/perl/GMP.pm, demos/perl/GMP/Rand.pm,
	demos/perl/test.pl: Add gmp_urandomb_ui, gmp_urandomm_ui.
	(GMP::Rand::randstate): Accept a randstate object to copy.
	* demos/perl/GMP.xs, demos/perl/GMP.pm, demos/perl/GMP/Mpz.pm,
	demos/perl/test.pl: Add combit, rootrem.

2003-08-19  Torbjorn Granlund  <tege@swox.com>

	* tune/Makefile.am (EXTRA_DIST): Add amd64.asm.

2003-08-17  Kevin Ryde  <kevin@swox.se>

	* gmpxx.h [__MPFR_H]: Include full <iostream> for inlines.
	* tests/cxx/t-headfr.cc: New file, exercising this.
	* tests/cxx/Makefile.am: Add it.

	* tests/cxx/t-constr.cc: Include config.h for WANT_MPFR.

	* gmpxx.h: Correction to temp variable type in mpf -> mpfr assignment.
	Reported by Derrick Bass.
	* tests/cxx/t-assign.cc (check_mpfr): Exercise this.

	* configure.in (WANT_MPFR): AC_DEFINE this, for the benefit of
	tests/cxx/t-*.cc.  (Was always meant to have been defined.)
	* tests/cxx/Makefile.am (INCLUDES): Add -I$(top_srcdir)/mpfr.

	* gmpxx.h: __gmp_default_rounding_mode -> __gmpfr_default_rounding_mode
	(struct __gmp_hypot_function): Correction to mpfr_hypot addition.
	* tests/cxx/t-misc.cc (check_mpfr_hypot): Corrections to mpfr/long
	tests.

2003-08-16  Torbjorn Granlund  <tege@swox.com>

	* configure.in (amd64): New.

	* mpn/amd64/gmp-mparam.h: New file.

	* tune/amd64.asm: New file, derived in part from tune/pentium.asm.

2003-08-15  Kevin Ryde  <kevin@swox.se>

	* tune/freq.c (freq_irix_hinv): Reinstate, for the benefit of IRIX 6.2.
	(freq_attr_get_invent): Conditionalize on INFO_LBL_DETAIL_INVENT too.

2003-08-14  Kevin Ryde  <kevin@swox.se>

	* mpq/get_d.c: Use mpn_get_d.
	* tests/mpq/t-get_d.c (check_onebit): New test.

	* gmp.texi (Notes for Particular Systems): Under x86 cpu types, note
	i386 is a fat binary, remove pentium4 recommendation since i386 is now
	quite reasonable for p4.
	(Notes for Particular Systems): Under Windows DLLs, remove caveat
	about --enable-cxx now ok, update .lib creation for new libtool,
	remove .exp not needed for MS C.
	(Notes for Package Builds): i386 is a fat binary.
	(Reentrancy): Remove SCO ctype.h note, don't want to list every system
	misfeature, and was quite possibly for non-threading mode anyway.
	(Autoconf): Remove notes on gmp 2 detection, too old to want to
	encourage anyone to use.
	(Karatsuba Multiplication): Correction to threshold increase/decrease
	for a and b terms.  Reported by Richard Brent and Paul Zimmermann.
	Also add various further index entries.

	* tune/freq.c (freq_attr_get_invent): New function.
	(freq_irix_hinv): Remove, in favour or freq_attr_get_invent.
	* configure.in (AC_CHECK_FUNCS): Add attr_get.
	(AC_CHECK_HEADERS): Add invent.h, sys/attributes.h, sys/iograph.h.

2003-08-03  Kevin Ryde  <kevin@swox.se>

	* tune/tuneup.c (tune_mul): Use MUL_KARATSUBA_THRESHOLD_LIMIT.

2003-08-02  Kevin Ryde  <kevin@swox.se>

	* mpn/asm-defs.m4: Tweak some comments, add hpux11 to m4wrap 0xFF
	problem systems.

	* configure.in (*-*-sco3.2v5*): Remove lt_cv_archive_cmds_need_lc=no,
	since libtool no longer uses it.  This was a workaround fixing ctype.h
	in SCO 5 shared libraries; not sure if libtool now gets it right on
	its own, let's hope so.

	* configure.in, acinclude.m4 (GMP_PROG_HOST_CC): Remove, libtool no
	longer demands HOST_CC.

	* configure.in: When C or C++ compiler not found, refer user to
	config.log.

	* configure.in (i386-*-*): Turn i386 into a fat binary build.
	* mpn/x86/fat/fat.c, mpn/x86/fat/fat_entry.asm,
	mpn/x86/fat/gmp-mparam.h, mpn/x86/fat/gcd_1.c, mpn/x86/fat/mode1o.c:
	New files.
	* gmp-impl.h (struct cpuvec_t) [x86 fat]: New structure.
	* longlong.h (COUNT_LEADING_ZEROS_NEED_CLZ_TAB) [x86 fat]: Define.
	* mpn/asm-defs.m4 (foreach): New macro.
	* mpn/x86/x86-defs.m4 (CPUVEC_FUNCS_LIST): New define.
	* mpn/x86/sqr_basecase.asm: New file, primarily as a fallback for fat
	binaries.
	* mpn/x86/p6/gmp-mparam.h, mpn/x86/p6/mmx/gmp-mparam.h: Add comments
	about fat binary SQR_KARATSUBA_THRESHOLD for p6 and p6/mmx.

	* configure.in: Add various supports for fat binaries, via fat_path,
	fat_functions and fat_thresholds variables.
	* acinclude.m4 (GMP_STRIP_PATH): Mung $fat_path too.
	(GMP_FAT_SUFFIX, GMP_REMOVE_FROM_LIST): New macros.
	* gmp-impl.h: Add various supports for fat binaries.
	(DECL_add_n etc): New macros.
	(mpn_mul_basecase etc): Define only if not already defined.
	* mpn/asm-defs.m4 (m4_config_gmp_mparam): Mention fat binary.
	(MPN): Use m4_unquote, for the benefit of fat binary name expansion.
	* doc/configuration: Notes on fat binaries.
	* gmp-impl.h (MUL_TOOM3_THRESHOLD_LIMIT): Define always.
	(MUL_KARATSUBA_THRESHOLD_LIMIT): New define.
	* mpn/generic/mul.c, mpn/generic/mul_n.c: Use these.
	* tune/divrem1div.c, tune/divrem1inv.c, tune/mod_1_div.c,
	tune/mod_1_inv.c: Define OPERATION_divrem_1 and OPERATION_mod_1, to
	tell fat.h what's being done.

	* config.guess (alpha-*-*): Update comments on what configfsf.guess
	does and doesn't do for us.

2003-07-31  Kevin Ryde  <kevin@swox.se>

	* config.guess: Remove $dummy.o files everywhere, in case vendor
	compilers produce that even when not asked.

	* demos/perl/GMP.xs (class_or_croak): Rename "class" parameter to
	avoid C++ keyword.
	(coerce_ulong, coerce_long): Move croaks to stop g++ 3.3 complaining
	about uninitialized variables.

	* demos/perl/INSTALL: Add notes on building with a DLL.

	* longlong.h (count_trailing_zeros) [x86_64]: Ensure bsfq destination
	is a 64-bit register.  Diagnosed by Francois G. Dorais.

2003-07-31  Torbjorn Granlund  <tege@swox.com>

	* longlong.h [ppc]: Remove nested test for vxworks.

2003-07-24  Kevin Ryde  <kevin@swox.se>

	* gmpxx.h (struct __gmp_binary_multiplies): Use mpz_mul_si for
	mpz*long and long*mpz.
	* tests/cxx/t-ops.cc (check_mpz): Exercise mpz*long and mpz*ulong.

	* cxx/ismpf.cc: Use std::locale decimal point when available.  Expect
	localeconv available always.
	* tests/cxx/t-locale.cc: Enable check_input tests.

	* gmpxx.h (struct __gmp_hypot_function): Use mpfr_hypot.
	* tests/cxx/t-misc.cc (check_mpfr_hypot): New tests.

	* tests/cxx/t-assign.cc, tests/cxx/t-binary.cc, tests/cxx/t-ops.cc,
	tests/cxx/t-prec.cc, tests/cxx/t-ternary.cc, tests/cxx/t-unary.cc:
	Include config.h for WANT_MPFR.

	* tests/mpz/bit.c (check_single): Correction to a diagnostic print.

2003-07-24  Niels Möller  <nisse@lysator.liu.se>

	* mpz/combit.c: New file.
	* Makefile.am, mpz/Makefile.am: Add it.
	* gmp-h.in (mpz_combit): Add prototype.
	* tests/mpz/bit.c (check_single): Exercise mpz_combit.

2003-07-16  Kevin Ryde  <kevin@swox.se>

	* mpn/generic/get_d.c: Correction to infinity handling for large exp.

2003-07-14  Kevin Ryde  <kevin@swox.se>

	* mpz/get_d.c, mpz/get_d_2exp.c, mpf/get_d.c, mpf/get_d_2exp.c: Use
	mpn_get_d.

	* mpn/generic/get_d.c: New file, based on mpz/get_d.c and insert-dbl.c.
	* configure.in, mpn/Makefile.am: Add it.
	* gmp-impl.h (mpn_get_d): Add prototype.

	* tests/mpn/t-get_d.c: New file.
	* tests/mpn/Makefile.am: Add it.

	* tests/mpz/t-get_d_2exp.c (check_onebit, check_round): Test negatives.
	(check_onebit): Add a few more bit sizes.

	* tests/misc.c, tests/tests.h (tests_isinf): New function.

2003-07-12  Kevin Ryde  <kevin@swox.se>

	* configure.in (GMP_PROG_CXX_WORKS): Include $CPPFLAGS, same as
	automake does in the actual build.

	* acinclude.m4 (GMP_PROG_CXX_WORKS): In the namespace test, declare
	namespace before trying to use.  In std iostream test, provoke a
	failure from Compaq C++ in pre-standard mode.

2003-07-08  Kevin Ryde  <kevin@swox.se>

	* acinclude.m4 (GMP_PROG_CC_WORKS): Use separate compiles for various
	known problems, and indicate to the user the reason for rejecting.
	(GMP_PROG_CXX_WORKS): Ditto, and insist on being able to execute each
	compiled program.

2003-07-05  Kevin Ryde  <kevin@swox.se>

	* config.sub: Add comments to our alias transformations.

	* configfsf.sub, configfsf.guess: Update to 2003-07-04.

	* acinclude.m4 (GMP_PROG_CC_WORKS, GMP_PROG_CC_WORKS_LONGLONG): Show
	failing program in config.log, per other autoconf tests.

	* configure.in (i786-*-*): Recognise as pentium4, per configfsf.sub.

2003-06-28  Kevin Ryde  <kevin@swox.se>

	* mpz/get_d_2exp.c, mpf/get_d_2exp.c: Avoid res==1.0 when floats round
	upwards.

	* tests/mpz/t-get_d_2exp.c: New file.
	* tests/mpz/Makefile.am (check_PROGRAMS): Add it.
	* tests/mpf/t-get_d_2exp.c: New file.
	* tests/mpf/Makefile.am (check_PROGRAMS): Add it.
	* tests/x86call.asm, test/tests.h (x86_fldcw, x86_fstcw): New
	functions.
	* tests/misc.c, tests/tests.h (tests_hardware_getround,
	tests_hardware_setround): New functions.

2003-06-25  Kevin Ryde  <kevin@swox.se>

	* mpn/sparc64/dive_1.c: New file.

	* mpn/sparc64/sparc64.h: New file.
	* mpn/sparc64/mode1o.c: Remove things now in sparc64.h.

	* mpfr/*: Update to mpfr cvs 2003-06-25.

	* acinclude.m4 (GMP_PROG_CC_WORKS): In last change provoking gnupro
	gcc, don't use ANSI style function definition.

2003-06-22  Kevin Ryde  <kevin@swox.se>

	* mpn/pa32/hppa1_1/udiv.asm: Remove .proc, .entry, .exit and .procend,
	handled by PROLOGUE and EPILOGUE.  Comment out .callinfo, per other
	asm files.

	* gmpxx.h (mpz_class __gmp_binary_divides, __gmp_binary_modulus): Fix
	long/mpz and long%mpz for dividend==LONG_MIN divisor==-LONG_MIN.
	(mpz_class __gmp_binary_modulus): Fix mpz%long for negative dividend.
	* tests/cxx/t-ops.cc (check_mpz): Add test cases for these, merging
	operator/ and operator% sections for clarity.

2003-06-21  Kevin Ryde  <kevin@swox.se>

	* mpfr/*: Update to mpfr cvs 2003-06-21.

	* acinclude.m4 (GMP_PROG_CC_WORKS): Add code by Torbjorn provoking an
	ICE from gcc 2.9-gnupro-99r1 under -O2 -mcpu=ev6.
	* configure.in (alpha*-*-* gcc_cflags_cpu): Fallback on -mcpu=ev56 for
	this compiler.

	* gmpxx.h (get_d): Remove comments about long double, double is
	correct for get_d, a future long double form would be get_ld.

2003-06-19  Kevin Ryde  <kevin@swox.se>

	* mpfr/*: Update to mpfr cvs 2003-06-19.

	* mpn/generic/dive_1.c: Share src[0] fetch among all cases.  No need
	for separate final umul_ppmm in even case, make it part of the loop.

	* mpz/get_d_2exp.c, mpq/set_si.c, mpq/set_ui.c: Nailify.

	* mpf/iset_si.c: Rewrite using mpf/set_si.c code, in particular this
	nailifies it.
	* tests/mpf/t-set_si.c: Nailify tests.

	* mpf/iset_ui.c: Nailify, as per mpf/set_ui.c
	* tests/mpf/t-set_ui.c: New file.
	* tests/mpf/Makefile.am (check_PROGRAMS): Add it.

2003-06-15  Kevin Ryde  <kevin@swox.se>

	* mpfr/*: Update to mpfr cvs 2003-06-15.

	* mpn/x86/k6/mode1o.asm: Remove a bogus ASSERT.

2003-06-12  Kevin Ryde  <kevin@swox.se>

	* configure.in (--enable-assert): Emit WANT_ASSERT to config.m4.
	* mpn/powerpc32/powerpc-defs.m4, mpn/x86/x86-defs.m4 (ASSERT): Check
	WANT_ASSERT is defined.

	* mpn/sparc32/v9/udiv.asm: Amend heading, this file is for sparc v9.

	* tests/cxx/Makefile.am (TESTS_ENVIRONMENT): In libtool openbsd hack,
	disard error messages from cp, for the benefit of --disable-shared or
	systems not using names libgmp.so.*.

	* tests/devel/try.c (try_one): When overlapping, copy source data
	after filling dst.  Previously probably used only DEADVAL in
	overlapping cases.

2003-06-11  Torbjorn Granlund  <tege@swox.com>

	* mpf/random2.c: Rewrite.  Ignore sign of exp parameter.

2003-06-10  Kevin Ryde  <kevin@swox.se>

	* mpn/sparc64/mode1o.c: New file.

2003-06-09  Torbjorn Granlund  <tege@swox.com>

	* mpn/powerpc32/lshift.asm: Add more cycle counts.
	* mpn/powerpc32/rshift.asm: Add more cycle counts.

	* gmp-impl.h (udiv_qrnnd_preinv1): New name for udiv_qrnnd_preinv.
	(udiv_qrnnd_preinv2): New name for udiv_qrnnd_preinv2norm.
	(udiv_qrnnd_preinv): New #define, making udiv_qrnnd_preinv2
	the default.
	* tune/speed.c: Corresponding changes.
	* tune/speed.h: Likewise.
	* tune/common.c: Likewise.

	* mpf/get_str.c: Simplify `off' computation.

	* longlong.h: Tabify.

2003-06-09  Kevin Ryde  <kevin@swox.se>

	* gmp.texi (ABI and ISA): FreeBSD has sparc64 too, just say "BSD" to
	cover all flavours.
	* configure.in: Ditto in some comments.

	* mpfr/*: Update to mpfr cvs 2003-06-09.

	* tests/cxx/Makefile.am (LDADD): Add -L$(top_builddir)/$(LIBS), for
	the benefit of gcc 3.2 on itanium2-hp-hpux11.22.

	* tune/many.pl (mul_2): Add speed routine settings.
	(MAKEFILE): Close when done, for the benefit of development hackery.

2003-06-08  Kevin Ryde  <kevin@swox.se>

	* mpfr/*: Update to mpfr cvs 2003-06-08.

	* mpn/x86/x86-defs.m4 (femms): Remove fallback to emms.
	(cmovCC, psadbw): Remove simulated versions.
	(cmov_available_p, psadbw_available_p): Remove.
	This trickery was only ever for development purposes on machines
	without those instructions.  Removing it simplifies gmp and in
	particular avoids complications for fat binary builds.  Development
	can be done with a wrapper around "as" if really needed.

	* mpn/x86/divrem_1.asm: Don't use loop_or_decljnz, now K6 has its own
	mpn/x86/k6/divrem_1.asm.  Amend K6 comments now moved to there.
	* mpn/x86/x86-defs.m4 (loop_or_decljnz): Remove, no longer used.

	* mpn/x86/k6/divrem_1.asm: New file, derived from mpn/x86/divrem_1.asm.

	* mpn/x86/k6/pre_mod_1.asm: Remove comments now in mpn/x86/mod_1.asm.

	* mpn/x86/mod_1.asm: Put mpn_mod_1c after mpn_mod_1 for better branch
	prediction.  Put done_zero at end for less wastage in alignment.  Use
	decl+jnz unconditionally since in fact it's ok on k6.  Amend comments.

2003-06-07  Kevin Ryde  <kevin@swox.se>

	* mpn/generic/mode1o.c: Fix ASSERTs on return value.

	* gmp.texi (Build Options): Add viac3 and viac32 cpu types.
	(ABI and ISA): Note on sparcv9 ABI=32 vs ABI=64 speed.  More indexing.

	* configfsf.guess, configfsf.sub: Update to 2003-06-06.
	* config.guess: Remove $RANDOM hack supporting netbsd 1.4, not needed
	by new configfsf.guess.


2003-06-05  Torbjorn Granlund  <tege@swox.com>

	* longlong.h (add_ssaaaa) [pa64]: Output zero operand as register 0.
	Allow more immediate operands.
	(sub_ddmmss) [pa64]: Likewise.
	(add_ssaaaa) [pa32]: Likewise.
	(sub_ddmmss) [pa32]: Likewise.

	* mpn/pa64: Change ".level 2.0W" to ".level 2.0w" to please
	picky GNU assembler.

2003-06-05  Kevin Ryde  <kevin@swox.se>

	* gmp.texi (Integer Special Functions): In mpz_array_init, fix type
	shown for integer_array and give an example use.

2003-06-04  Torbjorn Granlund  <tege@swox.com>

	* mpf/set_str.c (mpf_set_str): Work around gcc 2 bug triggered on
	alpha.

2003-06-03  Kevin Ryde  <kevin@swox.se>

	* mpn/x86/pentium/README: Add 7 c/l mmx mul_1, tweak wordings.

	* acinclude.m4 (GMP_C_DOUBLE_FORMAT): Use octal char constants in test
	program, hex is not supported by K&R.

2003-06-02  Torbjorn Granlund  <tege@swox.com>

	* mpn/mips64/divrem_1.asm: New file.

2003-06-01  Torbjorn Granlund  <tege@swox.com>

	* mpn/powerpc32/lshift.asm: Reformat code.
	* mpn/powerpc32/rshift.asm: Reformat code.

2003-05-30  Kevin Ryde  <kevin@swox.se>

	* tests/misc.c (tests_start): Set stdout and stderr to unbuffered, to
	avoid any chance of losing output on segv etc.

2003-05-28  Torbjorn Granlund  <tege@swox.com>

	* mpf/get_str.c: Move label `done' to match TMP_MARK and TMP_FREE.
	Remove redundant variable prec.

2003-05-26  Torbjorn Granlund  <tege@swox.com>

	* tests/mpz/convert.c: Test bases up to 62.

	* tests/mpf/t-conv.c: Test bases up to 62.

	* demos/pexpr.c: Don't iterate to get accurate timing.

	* mpf/set_str.c (mpn_pow_1_highpart): Cleanup.

	* mp_dv_tab.c: Fix typo.

	* mpf/get_str.c: Rewrite (now sub-quadratic).

2003-05-22  Kevin Ryde  <kevin@swox.se>

	* tests/mpn/t-divrem_1.c: New file.
	* tests/mpn/Makefile.am: Add it.

2003-05-22  Torbjorn Granlund  <tege@swox.com>

	* config.sub: Recognize viac3* processors.

2003-05-20  Torbjorn Granlund  <tege@swox.com>

	* mpn/sparc64/addmul_2.asm: New file.

2003-05-19  Torbjorn Granlund  <tege@swox.com>

	* configure.in: Recognize alphaev7* as alphaev67.

	* config.guess: Recognize viac3* processors.
	* configure.in: Set up path for viac3* processors.
	* acinclude.m4 (X86_PATTERN): Include viac3* processors.

2003-05-19  Kevin Ryde  <kevin@swox.se>

	* tune/freq.c (freq_pstat_getprocessor): New function.
	(freq_all): Use it.
	* configure.in (AC_CHECK_HEADERS): Add sys/pstat.h.
	(AC_CHECK_FUNCS): Add pstat_getprocessor.

2003-05-15  Kevin Ryde  <kevin@swox.se>

	* mpn/generic/mul_fft.c (mpn_mul_fft_decompose): Remove "inline",
	since the code is a bit too big.  gcc doesn't actually inline when
	alloca (TMP_ALLOC) is used anyway.

2003-05-13  Kevin Ryde  <kevin@swox.se>

	* gmp.texi (Notes for Particular Systems): Libtool directory is .libs
	not _libs for mingw dll.  Reported by Andreas Fabri.

2003-05-07  Kevin Ryde  <kevin@swox.se>

	* acinclude.m4 (GMP_PROG_CC_WORKS): Add code to generate sse2/xmm code
	from gcc -march=pentium4, to check the assembler supports that.
	(GMP_GCC_PENTIUM4_SSE2, GMP_OS_X86_XMM): New macros.
	* configure.in (pentium4-*-*): Use them to see if gcc -march=pentium4
	(with sse2) is ok.

2003-05-06  Kevin Ryde  <kevin@swox.se>

	* mpz/com.c: Rate size==0 as UNLIKELY, fix comment to mpn_add_1.

	* tune/freq.c (<sys/sysinfo.h>): Include only when needed for
	getsysinfo(), to avoid a problem with this file on AIX 5.1.

2003-05-03  Torbjorn Granlund  <tege@swox.com>

	* mpf/set_str.c: Do not ignore supposedly superfluous digits (in part
	reverting last change).

2003-05-03  Kevin Ryde  <kevin@swox.se>

	* gmp.texi: Use @code for files in @cindex entries, it looks nicer
	than @file.

	* Makefile.am: Note gmp 4.1.1 and 4.1.2 version info.

	* configure.in, acinclude.m4 (GMP_CRAY_OPTIONS): New macro for Cray
	system setups, letting AC_REQUIRE do its job instead of a hard coded
	AC_PROG_EGREP.

	* config.guess: Amend fake RANDOM to avoid ". configfsf.guess" which
	segfaults on Debian "ash" 0.4.16.

2003-05-01  Kevin Ryde  <kevin@swox.se>

	* configure.in (AC_CHECK_FUNCS): Add getsysinfo.
	(AC_CHECK_HEADERS): Add sys/sysinfo.h and machine/hal_sysinfo.h.
	* tune/freq.c (freq_getsysinfo): New function.
	(freq_all): Use it.
	(freq_sysctlbyname_i586_freq, freq_sysctlbyname_tsc_freq,
	freq_sysctl_hw_cpufrequency, freq_sysctl_hw_model): Set
	speed_cycletime before trying to print it, when verbose.

2003-04-28  Torbjorn Granlund  <tege@swox.com>

	* mpf/set_str.c: Major overhaul.
	(mpn_pow_1_highpart): New helper function, meat extracted from
	mpf_set_str.

2003-04-24  Kevin Ryde  <kevin@swox.se>

	* acinclude.m4 (GMP_GCC_ARM_UMODSI): Quote result string against m4.

	* configure, ltmain.sh, aclocal.m4: Update to libtool 1.5.

	* longlong.h (add_ssaaaa) [all]: Remove first "%" commutative in each,
	since gcc only supports one per asm.

	* printf/doprnt.c: Add M for mp_limb_t.
	* tests/misc/t-printf.c: Exercise this.

	* tests/mpz/t-cmp_d.c: Test infinities.
	* tests/mpf/t-cmp_d.c: New file.
	* tests/mpf/Makefile.am: Add it.

	* mpz/cmp_d.c, mpz/cmpabs_d.c, mpf/cmp_d.c: NaN invalid, Inf bigger
	than any value.
	* mpz/set_d.c, mpq/set_d.c, mpf/set_d.c: Nan or Inf invalid.

	* configure.in (AC_CHECK_FUNCS): Add raise.
	* invalid.c: New file.
	* Makefile.am: Add it.
	* gmp-impl.h (__gmp_invalid_operation): Add prototype.
	(DOUBLE_NAN_INF_ACTION): New macro.

	* tests/trace.c, tests/tests.h (d_trace): New function.
	* tests/misc.c, tests/tests.h (tests_infinity_d): New function.
	* tests/misc.c (mpz_erandomb, mpz_errandomb): Use gmp_urandomm_ui.

	* tune/tuneup.c, tune/common.c, tests/devel/try.c: Cast various
	mp_size_t values for printf %ld in case mp_size_t==int.  Use
	gmp_printf for mp_limb_t values.

	* gmp.texi (Nomenclature and Types): Add mp_exp_t, mp_size_t,
	gmp_randstate_t.  Note ulong for bit counts and size_t for byte
	counts.  Don't bother with @noindent.
	(Debugging): New valgrind is getting MMX/SSE.
	(Integer Comparisons): mpz_cmp_d and mpz_cmpabs_d on NaNs and Infs.
	(Float Comparison): mpf_cmp_d behaviour on NaNs and Infs.
	(Low-level Functions): Note with mpn_hamdist what hamming distance is.
	(Formatted Output Strings): Add type M.
	(Internals): Remove remarks on ulong bits and size_t bytes.  Move int
	field remarks to ...
	(Integer Internals, Float Internals): ... here.

2003-04-19  Kevin Ryde  <kevin@swox.se>

	* configure.in (*sparc*-*-* ABI=32): Add umul to extra_functions.

	* mpn/x86/p6/mul_basecase.asm: New file.

2003-04-18  Kevin Ryde  <kevin@swox.se>

	* configure.in (m68060-*-*): Fallback to gcc -m68000 when -m68060 not
	available, and don't use mpn/m68k/mc68020 asm routines.  (Avoids 32x32
	mul and 64/32 div which trap to the kernel on 68060.  Advice by
	Richard Zidlicky.)
	* mpn/m68k/README: Update notes on directory usage.

	* tests/cxx/Makefile.am (TESTS_ENVIRONMENT): Add a hack to let the
	test programs run with a shared libgmpxx on openbsd 3.2.

	* gmp.texi (Language Bindings): Add Guile.

2003-04-12  Kevin Ryde  <kevin@swox.se>

	* configure.in (cygwin*, mingw*, pw32*, os2*): Add
	-Wl,--export-all-symbols to GMP_LDFLAGS, no longer the default in
	latest mingw and libtool.

	* acinclude.m4 (GMP_ASM_COFF_TYPE): New macro.
	* configure.in (x86s): Use it.
	* mpn/x86/x86-defs.m4 (COFF_TYPE): New macro.
	(PROLOGUE_cpu): Use it, for the benefit of mingw DLLs.

	* gmp-impl.h (mpn_copyi, mpn_copyd): Add __GMP_DECLSPEC.

	* gmp.texi (Known Build Problems): Remove windows test program .exe
	repeated built, fixed by new libtool.  Remove MacOS C++ shared library
	creation, fixed by new libtool.
	(Notes for Package Builds, Known Build Problems): Remove DESTDIR notes
	on libgmpxx, fixed in new libtool.

2003-04-10  Torbjorn Granlund  <tege@swox.com>

	* configure.in: Match turbosparc.
	* config.guess: Recognize turbosparc (just for *bsd for now).

2003-04-09  Kevin Ryde  <kevin@swox.se>

	* mpf/mul_ui.c [nails]: Call mpf_mul to handle v > GMP_NUMB_MAX.

	* tests/mpz/t-mul.c (main): Don't try FFT sizes when FFT disabled via
	MP_SIZE_T_MAX, eg. for nails.

	* tests/cxx/t-ternary.cc: Split up tests to help compile speed and
	memory usage.

	* tests/devel/try.c: Print seed under -R, add -E to reseed, use ulong
	for seed not uint.

	* gmp.texi: Add @: after various abbreviations, more index entries.
	(leftarrow): New macro, for non-tex.
	(Random State Initialization): Remove commented gmp_randinit_lc, not
	going to be implemented.
	(Random Number Algorithms): New section.
	(References): Add Matsumoto and Nishimura on Mersenne Twister, add
	Bertot, Magaud and Zimmermann on GMP Square Root.

2003-04-06  Kevin Ryde  <kevin@swox.se>

	* tests/mpz/t-gcd_ui.c: New file.
	* tests/mpz/Makefile.am: Add it.

	* mpz/gcd_ui.c: Correction to return value on longlong limb systems,
	limb might not fit a ulong.

2003-04-04  Kevin Ryde  <kevin@swox.se>

	* configure, aclocal.m4, ltmain.sh: Update to libtool cvs snapshot
	2003-04-02.

2003-04-02  Kevin Ryde  <kevin@swox.se>

	* configure.in (*-*-cygwin*): No longer force lt_cv_sys_max_cmd_len,
	libtool has addressed this now.
	(AC_PROVIDE_AC_LIBTOOL_WIN32_DLL): Remove this, libtool _LT_AC_LOCK
	no longer needs it.

	* acinclude.m4 (GMP_PROG_AR): Also set ac_cv_prog_AR and
	ac_cv_prog_ac_ct_AR when adding flags to AR, so they're not lost by
	libtool's call to AC_CHECK_TOOL.

2003-04-01  Kevin Ryde  <kevin@swox.se>

	* configure, aclocal.m4, ltmain.sh: Update to libtool cvs snapshot
	2003-03-31.

	* configure.in (AC_PROG_F77): Add a dummy AC_PROVIDE to stop libtool
	running F77 probes.

	* randlc2x.c (gmp_rand_lc_struct): Add comments about what exactly is
	in each field.
	(randseed_lc): Rename seedp to seedz to avoid confusion with seedp in
	the lc function.  Suggested by Pedro Gimeno.
	(gmp_randinit_lc_2exp): Use __GMP_ALLOCATE_FUNC_TYPE.  No need for
	"+1" in mpz_init2 of _mp_seed.  Don't bother with mpz_init2 for _mp_a.

2003-03-29  Kevin Ryde  <kevin@swox.se>

	* configure.in (m68k-*-*): Use -O2, no longer need to fallback to -O.
	* acinclude.m4 (GMP_GCC_M68K_OPTIMIZE): Remove macro.

	* configure.in (AC_CHECK_TYPES): Add notes on why tested.

	* gmp.texi (GMPrefu, GMPpxrefu, GMPreftopu, GMPpxreftopu): New macros,
	use them for all external references to get URLs into HTML output.
	(Random State Initialization): Add gmp_randinit_set.
	(Random State Miscellaneous): New section.

2003-03-29  Kevin Ryde  <kevin@swox.se>

	* randbui.c, randmui.c: New files.
	* Makefile.am: Add them.
	* gmp-h.in (gmp_urandomb_ui, gmp_urandomm_ui): Add prototypes.
	* tests/rand/t-urbui.c, tests/rand/t-urmui.c: New files.
	* tests/rand/Makefile.am: Add them.

	* gmp-impl.h (gmp_randstate_srcptr): New typedef.
	(gmp_randfnptr_t): Add randiset_fn.
	* randiset.c: New file.
	* Makefile.am: Add it.
	* gmp-h.in (gmp_randinit_set): Add prototype.
	* randlc2x.c, randmt.c: Add gmp_randinit_set support.
	* tests/rand/t-iset.c: New file.
	* tests/rand/Makefile.am: Add it.

	* tests/misc.c, tests/tests.h (call_rand_algs): New function.

2003-03-27  Kevin Ryde  <kevin@swox.se>

	* mpz/bin_uiui.c: Use plain "*" for kacc products rather than
	umul_ppmm since high not needed, except for an ASSERT now amended.

2003-03-26  Kevin Ryde  <kevin@swox.se>

	* demos/expr/exprfr.c (cbrt, cmpabs, exp2, gamma, nextabove,
	nextbelow, nexttoward): New functions.
	* demos/expr/t-expr.c: Exercise these.

	* mpfr/*: Update to mpfr cvs 2003-03-26.

	* gmp-impl.h (MPZ_REALLOC): Use UNLIKELY, to expect no realloc.

	* tune/time.c (cycles_works_p): Scope variables down to relevant part
	to avoid warnings about unused.

	* configfsf.guess, configfsf.sub: Update to 2003-02-22.
	* config.guess: Fake a $RANDOM variable when running configfsf.guess,
	to workaround a problem on m68k NetBSD 1.4.1.

	* mpz/fac_ui.c: Remove unused variable "z1".

	* tune/freq.c (freq_irix_hinv): Allow "Processor 0" line from IRIX 6.5.

2003-03-24  Torbjorn Granlund  <tege@swox.com>

	* randlc2x.c (randget_lc): Remove write-only variable rn.
	* mpf/eq.c: Remove write-only variable usign.
	* gen-psqr.c (main): Remove write-only variable numb_bits.

2003-03-17  Torbjorn Granlund  <tege@swox.com>

	* Makefile.am (libgmp_la_SOURCES): Add mp_dv_tab.c.
	(libmp_la_SOURCES): Add mp_dv_tab.c.

	* mpn/alpha/invert_limb.asm: Add a few comments.

	* mp_dv_tab.c: New file, defining __gmp_digit_value_tab.

	* mpz/set_str.c: Get rid of function digit_value_in_base and use table
	__gmp_digit_value_tab instead.
	* mpz/inp_str.c: Likewise.
	* mpf/set_str.c: Likewise.
	* mpbsd/min.c: Likewise.
	* mpbsd/xtom.c: Likewise.

	* mpz/set_str.c: Allow bases <= 62.  Return error for invalid bases.
	* mpz/inp_str.c: Likewise.
	* mpf/set_str.c: Likewise.
	* mpz/out_str.c: Likewise.
	* mpz/get_str.c: Likewise.
	* mpf/get_str.c: Likewise.

	* mpz/inp_str.c: Restucture to allocate more string space just
	before needed.
	* mpbsd/min.c: Likewise.

	* longlong.h (__udiv_qrnnd_c): Remove redundant casts.
	(32-bit sparc): Test HAVE_HOST_CPU_supersparc in addition to various
	sparc_v8 spellings.

2003-03-17  Kevin Ryde  <kevin@swox.se>

	* mpfr/*: Update to mpfr cvs 2003-03-17.

2003-03-15  Kevin Ryde  <kevin@swox.se>

	* Makefile.am (EXTRA_libgmp_la_SOURCES): Use this for TMP_ALLOC
	sources, instead of a libdummy.la.

2003-03-16  Torbjorn Granlund  <tege@swox.com>

	* config.guess: Recognize supersparc and microsparc for *BSD systems.
	Generalize some superscalar recognition patterns.

2003-03-14  Torbjorn Granlund  <tege@swox.com>

	* mpn/sparc64/udiv.asm: New file.

2003-03-13  Torbjorn Granlund  <tege@swox.com>

	* mpn/sparc64: Table cycle counts.  Update some comments.

2003-03-10  Torbjorn Granlund  <tege@swox.com>

	* mpn/generic/mul.c (mpn_mul): Don't blindly expect
	MUL_KARATSUBA_THRESHOLD to be a constant.

2003-03-07  Torbjorn Granlund  <tege@swox.com>

	* mpn/generic/mul.c (mpn_mul): New operand splitting code for
	avoiding cache misses when un >> MUL_KARATSUBA_THRESHOLD > vn.
	(MUL_BASECASE_MAX_UN): New #define, default to 500 for now.

2003-03-07  Kevin Ryde  <kevin@swox.se>

	* Makefile.am: Put gmp.h and mp.h under $(exec_prefix)/include.
	* gmp.texi (Build Options): Add notes on this.
	Reported by Vincent Lefèvre.

2003-03-06  Kevin Ryde  <kevin@swox.se>

	* configure.in (alpha*-*-* gcc): Add asm option before testing -mcpu,
	for the benefit of gcc 2.9-gnupro-99r1 on alphaev68-dec-osf5.1 which
	doesn't otherwise put the assembler in the right mode for -mcpu=ev6.

2003-03-05  Torbjorn Granlund  <tege@swox.com>

	* mpn/powerpc32/powerpc-defs.m4: Set up renaming for v registers.

	* mpz/powm.c (redc): Instead of repeated mpn_incr_u invocations,
	accumulate carries and add at the end.
	(mpz_powm): Trim tp allocation, now as redc doesn't need carry guard.

2003-02-25  Torbjorn Granlund  <tege@swox.com>

	* mpn/x86/pentium4/copyd.asm: Correct header comment.

	* mpn/arm/addmul_1.asm: Correct cycle counts.
	* mpn/arm/submul_1.asm: Likewise.

2003-02-20  Kevin Ryde  <kevin@swox.se>

	* demos/factorize.c (factor_using_pollard_rho): Test k>0 to avoid
	infinite loop if k=0 and gcd!=1 reveals a factor.  Reported by John
	Pongsajapan.

	* gmp.texi, fdl.texi: Update to FDL version 1.2.

2003-02-18  Torbjorn Granlund  <tege@swox.com>

	* mpn/arm/mul_1.asm: Fix typo introduced in last change.

2003-02-17  Torbjorn Granlund  <tege@swox.com>

	* mpn/sparc64/copyi.asm: Add some header comments.
	* mpn/sparc64/copyd.asm: Likewise.

	* mpn/arm/mul_1.asm: Put vl operand last for umull/umlal.
	Add some header comments.
	* mpn/arm/addmul_1.asm: Rewrite.
	* mpn/arm/submul_1.asm: Rewrite.
	* mpn/arm/gmp-mparam.h: Retune.

2003-02-16  Torbjorn Granlund  <tege@swox.com>

	* mpn/arm/copyi.asm: New file.
	* mpn/arm/copyd.asm: New file.

2003-02-16  Kevin Ryde  <kevin@swox.se>

	* acinclude.m4 (GMP_C_DOUBLE_FORMAT): Tolerate incorrect last data
	byte seen on an arm system.

2003-02-15  Torbjorn Granlund  <tege@swox.com>

	* mpn/arm/gmp-mparam.h: Retune.

2003-02-13  Torbjorn Granlund  <tege@swox.com>

	* mpn/powerpc32/750/com_n.asm: Add more cycle counts.

2003-02-13  Kevin Ryde  <kevin@swox.se>

	* configure.in (AC_PREREQ): Bump to 2.57.

	* configure.in, acinclude.m4 (GMP_GCC_WA_OLDAS): New macro, applying
	-Wa,-oldas only when necessary.

	* configure.in (powerpc*-*-*): Don't use -Wa,-mppc with gcc, it
	overrides options recent gcc adds for -mcpu, making generated code
	fail to assemble.

	* tune/tuneup.c (mpn_fft_table): Remove definition, it's in mul_fft.c.

2003-02-12  Torbjorn Granlund  <tege@swox.com>

	* mpn/x86/pentium4/sse2/gmp-mparam.h: Retune.
	* mpn/x86/k7/gmp-mparam.h: Retune.
	* mpn/x86/k6/gmp-mparam.h: Retune.
	* mpn/x86/p6/gmp-mparam.h: Retune.
	* mpn/x86/p6/mmx/gmp-mparam.h: Retune.

	* tests/mpz/t-mul.c (main): Rewrite FFT testing code.

2003-02-10  Torbjorn Granlund  <tege@swox.com>

	* config.guess: Recognize "power2" systems.

	* mpn/powerpc64/gmp-mparam.h: Fix indentation.
	* mpn/power/gmp-mparam.h: Retune.
	* mpn/alpha/ev6/nails/gmp-mparam.h: Retune.
	* mpn/sparc64/gmp-mparam.h: Retune.
	* mpn/pa64/gmp-mparam.h: Retune.
	* mpn/sparc32/v8/supersparc/gmp-mparam.h: Retune.
	* mpn/sparc32/v8/gmp-mparam.h: Retune.
	* mpn/mips64/gmp-mparam.h: Retune.
	* mpn/alpha/ev6/gmp-mparam.h: Retune.
	* mpn/powerpc32/gmp-mparam.h: Retune.
	* mpn/powerpc32/750/gmp-mparam.h: Retune.
	* mpn/alpha/ev5/gmp-mparam.h: Retune.
	* mpn/m68k/gmp-mparam.h: Retune.
	* mpn/cray/gmp-mparam.h: Set GET_STR_PRECOMPUTE_THRESHOLD.

	* configure.in: Undo this, problem doesn't happen any more:
	(mips64*-*-*): Pass just -O1 to cc, to work around compiler bug.

2003-02-03  Kevin Ryde  <kevin@swox.se>

	* gmp-impl.h (MPN_NORMALIZE, MPN_NORMALIZE_NOT_ZERO): Add parens
	around macro parameters.  Reported by Jason Moxham.

2003-02-01  Kevin Ryde  <kevin@swox.se>

	* gmp.texi (Low-level Functions): No overlap permitted by mpn_mul_n.
	Reported by Jason Moxham.
	(Formatted Input Strings): Correction to strtoul cross reference
	formatting.
	(BSD Compatible Functions): Add index entry for MINT.

2003-01-29  Torbjorn Granlund  <tege@swox.com>

	* gmp-impl.h (mpn_mul_fft): Now returns int.

2003-01-29  Paul Zimmermann  <Paul.Zimmermann@loria.fr>

	* mpn/generic/mul_fft.c: Major rewrite.

2003-01-25  Kevin Ryde  <kevin@swox.se>

	* config.guess (powerpc*-*-*): Remove $dummy.core file when mfpvr
	fails on NetBSD.
	(trap): Remove $dummy.core on abnormal termination too.

	* mpfr/*: Update to mpfr cvs 2003-01-25.

2003-01-18  Kevin Ryde  <kevin@swox.se>

	* mpfr/*: Update to mpfr cvs 2003-01-18.

2003-01-17  Torbjorn Granlund  <tege@swox.com>

	* gmp.texi: Canonicalize URLs.

2003-01-15  Kevin Ryde  <kevin@swox.se>

	* gmp.texi (Notes for Particular Systems): Add hardware floating point
	precision mode.

	* mpfr/*, configure, aclocal.m4, config.in: Update to mpfr cvs
	2003-01-15.

2003-01-11  Kevin Ryde  <kevin@swox.se>

	* mpfr/*: Update to mpfr cvs 2003-01-11.

2003-01-09  Kevin Ryde  <kevin@swox.se>

	* mpfr/get_str.c: Update to mpfr cvs 2003-01-09.

	* doc/configuration: Various updates.

2003-01-06  Torbjorn Granlund  <tege@swox.com>

	* mpn/alpha/copyi.asm: Avoid `nop' mnemonic, unsupported on Cray.
	* mpn/alpha/copyd.asm: Likewise.

2003-01-05  Kevin Ryde  <kevin@swox.se>

	* demos/expr/t-expr.c (check_r): Tolerate mpfr_set_str new return
	value.

	* configure, aclocal.m4 (*-*-osf4*, *-*-osf5*): Regenerate with
	libtool patch to avoid bash printf option problem when building shared
	libraries with cxx.

	* configure.in (pentium4-*-*): Use "-march=pentium4 -mno-sse2" since
	sse2 causes buggy code from gcc 3.2.1 and is only supported on new
	enough kernels.

	* acinclude.m4 (GMP_PROG_NM): Add some notes about failures, per
	report by Krzysztof Kozminski.

	* gmp-h.in (mpz_mdivmod_ui, mpz_mmod_ui): Add parens around "r".

	* gmp-h.in (__GMP_CAST): New macro, clean to g++ -Wold-style-cast.
	(GMP_NUMB_MASK, mpz_cmp_si, mpq_cmp_si, mpz_odd_p, mpn_divexact_by3,
	mpn_divmod): Use it.  Reported by Krzysztof Kozminski.
	(mpz_odd_p): No need for the outermost cast to "int".
	* tests/cxx/t-cast.cc: New file.
	* tests/cxx/Makefile.am: Add it.

2003-01-04  Kevin Ryde  <kevin@swox.se>

	* mpfr/set_str.c: Update to mpfr cvs 2003-01-04.

	* demos/expr/exprfra.c (e_mpfr_number): Tolerate recent mpfr_set_str
	returning count of characters accepted.

2003-01-03  Torbjorn Granlund  <tege@swox.com>

	* mpn/alpha/copyi.asm: New file.
	* mpn/alpha/copyd.asm: New file.

2003-01-03  Kevin Ryde  <kevin@swox.se>

	* demos/expr/t-expr.c: Use __gmpfr on some mpfr internals that have
	changed.

	* mpfr/*, aclocal.m4, config.in, configure: Update to mpfr cvs
	2003-01-03.

	* gmp.texi (Introduction to GMP): Mention release announcements
	mailing list, and put home page and ftp before mailing lists.

2002-12-28  Torbjorn Granlund  <tege@swox.com>

	* mpn/generic/mul_fft.c (mpn_fft_next_size): Simplify.

2002-12-28  Kevin Ryde  <kevin@swox.se>

	* acinclude.m4 (M68K_PATTERN): New macro.
	(GMP_GCC_M68K_OPTIMIZE): Use it to avoid m6811 and friends.
	* configure.in: Ditto.

	* tests/mpz/t-import.c, tests/mpz/t-export.c: Use '\xHH' to avoid
	warnings about char overflows.
	* acinclude.m4 (GMP_C_DOUBLE_FORMAT): Ditto.

2002-12-28  Pedro Gimeno  <pggimeno@wanadoo.es>

	* randmt.c (randseed_mt, default_state): Fix off-by-one bug on padding.
	(randseed_mt): Add ASSERT checking result of mpz_export.

2002-12-24  Kevin Ryde  <kevin@swox.se>

	* gmp.texi (Integer Import and Export): Clarify treatment of signs,
	reported by Kent Boortz.

	* randmt.c: Use gmp_uint_least32_t.
	(randseed_mt): Add nails to mpz_export in case mt[i] more than 32 bits.

	* gmp-impl.h (gmp_uint_least32_t): New typedef, replacing GMP_UINT32.
	* configure.in (AC_CHECK_TYPES): Add uint_least32_t.
	(AC_CHECK_SIZEOF): Add unsigned short.

2002-12-22  Kevin Ryde  <kevin@swox.se>

	* gmp-impl.h (ULONG_PARITY) [generic C]: Mask result to a single bit.
	(ULONG_PARITY) [_CRAY, __ia64]: New macros.
	* tests/t-parity.c: New test.
	* tests/Makefile.am (check_PROGRAMS): Add it.

	* longlong.h (count_trailing_zeros) [ia64]: New macro.

	* tests/t-count_zeros.c (check_various): Remove unused variable "n".

	* mpn/x86/README: Revise notes on PIC, PLT and GOT.

	* demos/perl/GMP.xs, demos/perl/GMP.pm, demos/perl/test.pl: Add "mt"
	to GMP::Rand::randstate.

2002-12-22  Pedro Gimeno  <pggimeno@wanadoo.es>

	* randmt.c (randseed_mt): Fix bug that might cause the generator to
	return all zeros with certain seeds.  Fix WARM_UP==0 case.
	(gmp_randinit_mt): Initialize to a known state by default.
	(randget_mt): Remove check for uninitialized buffer: no longer needed.
	(recalc_buffer): Use ?: instead of two-element array.

	* tests/rand/t-mt.c: New test.
	* tests/rand/Makefile.am (check_PROGRAMS): Add it.

2002-12-21  Kevin Ryde  <kevin@swox.se>

	* cxx/osdoprnti.cc: Use <cstdarg> and <cstring> rather than <stdarg.h>
	and <string.h>.  No need for <stdio.h>.

	* demos/expr/expr.c, demos/expr/exprfa.c, demos/expr/exprfra.c,
	demos/expr/exprza.c: Use mp_get_memory_functions, not
	__gmp_allocate_func etc.
	* demos/expr/t-expr.c: Don't use gmp-impl.h.
	(numberof): New macro.

	* gmp-h.in, gmp-impl.h (__gmp_allocate_func, __gmp_reallocate_func,
	__gmp_free_func): Move declarations to gmp-impl.h

	* mp_get_fns.c: New file.
	* Makefile.am (libgmp_la_SOURCES, libmp_la_SOURCES): Add it.
	* gmp-h.in (mp_get_memory_functions): Add prototype.
	* gmp.texi (Custom Allocation): Add mp_get_memory_functions, refer to
	"free" not "deallocate" function.
	* gmpxx.h (struct __gmp_alloc_cstring): Use mp_get_memory_functions,
	not __gmp_free_func.

	* gmp-impl.h [__cplusplus]: Add <cstring> for strlen.
	(gmp_allocated_string): Hold length in a field.
	* cxx/osdoprnti.cc, cxx/osmpf.cc: Use this.

2002-12-20  Torbjorn Granlund  <tege@swox.com>

	* tests/mpz/t-perfsqr.c (check_sqrt): Print more variables upon
	failure.

	* mpn/generic/rootrem.c: In Newton loop, pad qp with leading zero.

2002-12-19  Torbjorn Granlund  <tege@swox.com>

	* mpn/generic/rootrem.c: Allocate 1.585 (log2(3)) times more space
	for pp temporary to allow for worst case overestimate of root.
	Add some asserts.

	* tests/mpz/t-root.c: Generalize and speed up.

2002-12-19  Kevin Ryde  <kevin@swox.se>

	* tests/cxx/t-rand.cc (check_randinit): Add gmp_randinit_mt test.

	* gmp-h.in: Don't bother trying to support Compaq C++ in pre-standard
	I/O mode.
	* gmp.texi (Notes for Particular Systems): Compaq C++ must be used in
	"standard" iostream mode.

2002-12-18  Torbjorn Granlund  <tege@swox.com>

	* mpn/alpha/mod_34lsub1.asm: Add code for big-endian, using existing
	little-endian code only if HAVE_LIMB_LITTLE_ENDIAN is defined.

2002-12-18  Kevin Ryde  <kevin@swox.se>

	* configure.in (HAVE_LIMB_BIG_ENDIAN, HAVE_LIMB_LITTLE_ENDIAN): New
	defines in config.m4.

2002-12-17  Torbjorn Granlund  <tege@swox.com>

	* printf/printffuns.c (gmp_fprintf_reps): Make it actually work
	for padding > 256.

2002-12-17  Kevin Ryde  <kevin@swox.se>

	* tune/freq.c: Add <string.h> for memcmp.

	* mpz/pprime_p.c: Use MPN_MOD_OR_MODEXACT_1_ODD.

	* gmp.texi (Formatted Output Strings): %a and %A are C99 not glibc.
	(Formatted Input Strings): Type "l" is for double too.  Hex floats are
	accepted for mpf_t.
	(Formatted Input Functions): Describe tightened parse rule, clarify
	return value a bit.

	* scanf/doscan.c: Add hex floats, tighten matching to follow C99, for
	instance "0x" is no longer acceptable to "%Zi".
	Rename "invalid" label to avoid "invalid" variable, SunOS cc doesn't
	like them the same.
	* tests/misc/t-scanf.c: Update tests.
	* tests/misc/t-locale.c (check_input): Don't let "0x" appear from fake
	decimal point.

	* config.guess (sparc*-*-*): Look at BSD sysctl hw.model to recognise
	ultrasparcs.

	* mpfr/tests/dummy.c: New file.
	* mpfr/tests/Makefile.am (libfrtests_a_SOURCES): Add it.

2002-12-14  Kevin Ryde  <kevin@swox.se>

	* mpbsd/Makefile.am (nodist_libmpbsd_la_SOURCES): Move these mpz
	sources to libmpbsd_la_SOURCES directly, automake 1.7.2 now gets the
	ansi2knr setups right for sources in other directories.

	* mpfr/tests/Makefile.am: Add libfrtests.a in preparation for new mpfr.

2002-12-13  Kevin Ryde  <kevin@swox.se>

	* mpfr/Makefile.am (mpfr_TEXINFOS, AM_MAKEINFOFLAGS): Allow for
	fdl.texi in recent mpfr.

	* configure.in (AC_PROG_EGREP): Ensure this is run outside the Cray
	conditional AC_EGREP_CPP.

	* configure.in (alpha*-*-*): Use gcc -Wa,-oldas if it works, to avoid
	problems with new compaq "as" on OSF 5.1.

	* mpn/Makefile.am (EXTRA_DIST): Remove Makeasm.am, automake 1.7.2 does
	it automatically.

	* acinclude.m4 (AC_LANG_FUNC_LINK_TRY(C)): Remove this hack, fixed by
	autoconf 2.57.

	* configure.in (AC_CONFIG_LIBOBJ_DIR): Set to mpfr, for the benefit of
	new mpfr using LIBOBJ.

	* configure.in: (AM_INIT_AUTOMAKE): Use "gnu no-dependencies
	$(top_builddir)/ansi2knr".
	* */Makefile.am (AUTOMAKE_OPTIONS): Remove, now in configure.in.

	* configure, config.in, INSTALL.autoconf: Update to autoconf 2.57.
	* */Makefile.in, configure, aclocal.m4, install-sh, mkinstalldirs:
	Update to automake 1.7.2.

	* gmp.texi (Build Options): Add hppa64 to cpu types.
	(ABI and ISA): Add gcc to hppa 2.0.
	(Debugging): Add maximum debuggability config options.
	(Language Bindings): Add Arithmos, reported by Johan Vervloet.
	(Formatted Output Strings): 128 bits is about 40 digits, ll is only
	for long long not long double.
	(Formatted Input Strings): ll is only for long long not long double.

	* mpz/divis.c, mpz/divis_ui.c, mpz/cong.c, mpz/cong_ui.c: Allow d=0,
	under the rule n==c mod d iff exists q satisfying n=c+q*d.
	* gmp.texi (Integer Division): Describe this.
	Suggested by Jason Moxham.

2002-12-13  Pedro Gimeno  <pggimeno@wanadoo.es>

	* randlc2x.c (lc): Remove check for seedn < an, which is now
	superfluous.  Add ASSERT to ensure it's correct.  Add ASSERT to check
	precondition of __GMPN_ADD.
	(gmp_randinit_lc_2exp): Avoid reallocation by allocating one extra bit
	for both seed and a.  Simplify seedn < p->_cn case.

	* tests/rand/t-lc2exp.c (check_bigs): Test negative seeds.

2002-12-12  Torbjorn Granlund  <tege@swox.com>

	* mpn/pa32/pa-defs.m4 (PROLOGUE_cpu): Zap spurious argument to `.proc'.
	Add empty `.callinfo'.

2002-12-11  Torbjorn Granlund  <tege@swox.com>

	* mpn/x86/pentium4/sse2/addmul_1.asm: Don't reuse `ret' symbol for a
	label.

2002-12-11  Kevin Ryde  <kevin@swox.se>

	* configure.in (hppa*-*-*): Don't use gcc -mpa-risc-2-0 in ABI=1.0.

	* mpn/pa32/pa-defs.m4: New file, arranging for .proc/.procend.
	* configure.in (hppa*-*-*): Use it.

	* printf/doprnt.c: Comments on "ll" versus "L".

	* tests/mpz/t-div_2exp.c: Reduce tests, especially the random ones.

2002-12-11  Torbjorn Granlund  <tege@swox.com>

	* mpz/get_d.c (limb2dbl): New macro for conversion to `double'.
	Define it to something non-trivial for 64-bit hppa.
	* mpq/get_d.c: Likewise.
	* mpf/get_d.c: Likewise.

	* mpn/x86/pentium4/sse2/addmul_1.asm: Unroll to save one c/l.

2002-12-09  Kevin Ryde  <kevin@swox.se>

	* tune/Makefile.am: Don't use -static under --disable-static, it tends
	not to work.
	* configure.in (ENABLE_STATIC): New AM_CONDITIONAL.

	* gmp-h.in: Use <iostream> instead of <iosfwd> with Compaq C++ in
	pre-standard I/O mode.

	* tests/mpz/t-jac.c, tests/mpz/t-scan.c: Reduce tests.

2002-12-08  Kevin Ryde  <kevin@swox.se>

	* configure.in (*-*-ultrix*): Remove forcible --disable-shared,
	believe this was a generic problem with libtool, now gone.

2002-12-08  Torbjorn Granlund  <tege@swox.com>

	* gmp-impl.h (USE_LEADING_REGPARM): Disable for PIC code generation.

2002-12-07  Torbjorn Granlund  <tege@swox.com>

	* tests/cxx/t-misc.cc (check_mpq): Use 0/1 for canonical 0 in
	mpq_cmp_ui calls.

	* configure.in (hppa2.0*-*-*): Pass +O2 instead of +O3 to work around
	compiler bug with mpfr/tests/tdiv.

2002-12-07  Kevin Ryde  <kevin@swox.se>

	* configure.in (hppa2.0*-*-* ABI=2.0n): Make -mpa-risc-2-0 optional.
	New hppa-level-2.0 test using GMP_HPPA_LEVEL_20 to detect assembler
	support for 2.0n.
	* acinclude.m4 (GMP_PROG_CC_WORKS): Add code that provokes an error
	from gcc -mpa-risc-2-0 if the assembler doesn't know 2.0 instructions.
	(GMP_HPPA_LEVEL_20): New macro.

2002-12-07  Pedro Gimeno  <pggimeno@wanadoo.es>

	* gmp-impl.h (gmp_randfnptr_t.randseed_fn) Return void.
	(LIMBS_PER_ULONG, MPN_SET_UI): New macros.
	(MPZ_FAKE_UI): Rename couple of parameters.

	* randlc2x.c (gmp_rand_lc_struct): _mp_c and _mp_c_limbs replaced
	with mpn style _cp and _cn.  All callers changed.
	(randseed_lc): Fix limbs(seed) > bits_to_limbs(m2exp) case.
	Remove return value.
	(gmp_randinit_lc_2exp): Attempt to avoid redundant reallocation.

	* randmt.c (mangle_seed): New function by Kevin.
	(randseed_mt): Use it instead of mpz_powm, for performance.  Remove
	return value.  Remove commented out code (an inferior alternative to
	mpz_export).

	* randsdui.c (gmp_randseed_ui): Use MPZ_FAKE_UI.

	* tests/rand/t-lc2exp.c (check_bigm, check_bigs): New tests.
	* tests/rand/t-urndmm.c: Add L to constants in calls, for K&R.

2002-12-06  Torbjorn Granlund  <tege@swox.com>

	* configure.in: Remove -g.
	(hppa*-*-*): Pass -Wl,+vnocompatwarnings with +DA2.0.

2002-12-05  Torbjorn Granlund  <tege@swox.com>

	* mpn/pa64/sqr_diagonal.asm: Remove .entry, .proc, .procend.
	* mpn/pa64/udiv.asm: Likewise.

2002-12-05  Kevin Ryde  <kevin@swox.se>

	* mpn/pa64/sub_n.asm: Remove space in "sub, db" which gas objects to.
	* mpn/pa64/*.asm, tune/hppa2.asm: Use ".level 2.0" for 2.0n, since gas
	doesn't like ".level 2.0N".

	* configure.in (hppa*-*-*): Group path and flags choices, for clarity.
	(hppa1.0*-*-*): Use gcc -mpa-risc-1-0 when available.
	(hppa2.0*-*-*): Ditto -mpa-risc-2-0.
	(*-*-hpux*): Exclude ABI=2.0w for hpux[1-9] and hpux10, rather than
	the converse of allowing it for hpux1[1-9]; ie. list the bad systems
	rather than try to guess the good systems.
	(hppa2.0*-*-*) [ABI=2.0n ABI=2.0w]: Add gcc to likely compilers.
	(hppa*-*-*) [gcc]: Test sizeof(long) to differentiate a 32-bit or
	64-bit build of the compiler.
	(hppa64-*-*): Add this as equivalent to hppa2.0-*-*.
	* acinclude.m4 (GMP_C_TEST_SIZEOF): New macro.

	* tests/tests.h (ostringstream::str): Must null-terminate
	ostrstream::str() for the string constructor.

2002-12-04  Torbjorn Granlund  <tege@swox.com>

	* mpn/pa32/hppa1_1/udiv.asm: Don't wrap symbol to INT64 in L() stuff.

	* longlong.h (mpn_udiv_qrnnd_r based udiv_qrnnd): Fix typo.

	* mpn/powerpc32/powerpc-defs.m4: Define float registers with `f'
	prefix.

2002-12-04  Kevin Ryde  <kevin@swox.se>

	* gmp.texi (Floating-point Functions): Note the mantissa is binary and
	decimal fractions cannot be represented exactly.  Suggested by Serge
	Winitzki.
	(Known Build Problems): Note libtool stripping options when linking.
	Reported by Vincent Lefevre.

	* acinclude.m4 (GMP_ASM_LABEL_SUFFIX): Don't make an empty result a
	failure, that's a valid result.
	(GMP_ASM_GLOBL): Establish this from the host cpu type.
	(IA64_PATTERN): New macro.
	(GMP_PROG_EXEEXT_FOR_BUILD, GMP_C_FOR_BUILD_ANSI,
	GMP_CHECK_LIBM_FOR_BUILD): Remove temporary files created.
	* configure.in: Use IA64_PATTERN.

2002-12-03  Torbjorn Granlund  <tege@swox.com>

	* tune/hppa.asm: Use config.m4.
	* tune/hppa2.asm: Likewise.
	* tune/hppa2w.asm: Likewise.

	* mpn/pa64: Use LDEF.

2002-12-03  Kevin Ryde  <kevin@swox.se>

	* INSTALL: Use return rather than exit in the example programs.
	Suggested by Richard Dawe.

	* gmp.texi (Build Options): Move non-unix notes to ...
	(Notes for Particular Systems): ... here.  Mention MS Interix,
	reported by Paul Leyland.
	(C++ Interface Random Numbers): Add gmp_randinit_mt to examples.

	* acinclude.m4 (GMP_ASM_LABEL_SUFFIX): Must test empty suffix first,
	for the benefit of hppa hp-ux.
	(GMP_ASM_UNDERSCORE): Grep the output of "nm" instead of trying to
	construct an asm file, and in case of failure fallback on no
	underscore and a warning.

	* longlong.h (count_leading_zeros, count_trailing_zeros) [ev67, ev68]:
	Restrict __asm__ ctlz and cttz to __GNUC__.

	* gen-psqr.c (HAVE_CONST, const): New macros.

	* tests/cxx/t-rand.cc (check_randinit): Add gmp_randinit_mt.

2002-12-02  Torbjorn Granlund  <tege@swox.com>

	* gmp-impl.h: Split popc_limb again, combined version gives too many
	compiler warnings.

2002-12-01  Torbjorn Granlund  <tege@swox.com>

	* mpn/generic/gcdext.c (div1): Disable unused function.

	* mpz/root.c: Don't include stdlib.h or longlong.h.
	* mpz/rootrem.c: Likewise.

	* extract-dbl.c: abort => ASSERT_ALWAYS.
	* mpz/set_d.c: Likewise.
	* mpn/generic/tdiv_qr.c: Likewise.

	* gen-psqr.c (f_cmp_fraction, f_cmp_divisor): Change parameter to
	`const void *', to match qsort spec.

2002-12-01  Kevin Ryde  <kevin@swox.se>

	* gmp.texi (Integer Division): Fix a couple of @math's for tex.
	Use @dots in more places.

	* tests/cxx/t-locale.cc: Test non std::locale systems too.
	* tests/cxx/clocale.c: New file, reinstating what was localeconv.c,
	and subverting nl_langinfo too.
	* tests/cxx/Makefile.am (t_locale_SOURCES): Add it.

	* tests/tests.h (ostringstream, istringstream): Provide fakes of these
	if <sstream> not available.
	* tests/cxx/t-locale.cc, tests/cxx/t-ostream.cc: Remove <sstream>.
	* configure.in (AC_CHECK_HEADERS) [C++]: Add <sstream>.

2002-11-30  Torbjorn Granlund  <tege@swox.com>

	* printf/doprnt.c (__gmp_doprnt): Comment out a `break' to shut up
	compiler warnings.

	* longlong.h (umul_ppmm) [ia64]: Form both product parts in asm.

	* mpz/bin_uiui.c: Cast umul_ppmm operands.

	* scanf/doscan.c (gmpscan): Remove unused label store_get_digits.

	* gmp-impl.h: #undef MIN and MAX before #defining.

2002-11-30  Kevin Ryde  <kevin@swox.se>

	* configure.in (AC_CHECK_HEADERS): Add nl_types.h.
	* tests/misc/t-locale.c: Use this, for nl_item on netbsd 1.4.1.

2002-11-29  Torbjorn Granlund  <tege@swox.com>

	* tests/devel/addmul_1.c: Provide prototype for mpn_print.
	(OPS): Account for function overhead.
	* tests/devel/{submul_1.c,mul_1.c,add_n.c,sub_n.c}: Likewise.

2002-11-28  Kevin Ryde  <kevin@swox.se>

	* mpn/Makefile.am (nodist_EXTRA_libmpn_la_SOURCES): Use this rather
	than libdummy.
	* tests/Makefile.am (EXTRA_libtests_la_SOURCES): Use this for
	x86call.asm and x86check.c rather than libdummy.

2002-11-27  Torbjorn Granlund  <tege@swox.com>

	* tests/mpz/t-mul.c: Implement reference Karatsuba multiplication.
	Rewrite testing scheme to run fewer really huge tests.

2002-11-26  Torbjorn Granlund  <tege@swox.com>

	* tests: Decrease repetition count for some of the slowest tests.

2002-11-25  Torbjorn Granlund  <tege@swox.com>

	* mpfr/tests/tdiv.c: Decrease number of performed tests.

2002-11-23  Kevin Ryde  <kevin@swox.se>

	* mpn/ia64/README: Add some references.

	* gmp.texi (Build Options): Add itanium and itanium2, mention DocBook
	and XML from makeinfo, add texinfo top level cross reference.
	(Integer Division): Try to clarify 2exp functions a bit.
	(C++ Interface Floats): Giving bad string to constructor is undefined.
	(C++ Interface Integers, C++ Interface Rationals): Ditto, and show
	default base in prototype, not the description.

	* config.sub, config.guess, configure.in (itanium, itanium2): New cpu
	types.

	* tests/misc/t-printf.c, tests/misc/t-scanf.c (check_misc): Suppress
	%zd test on glibc prior to 2.1, it's not supported.

2002-11-20  Kevin Ryde  <kevin@swox.se>

	* tests/cxx/t-locale.cc: Test with locales imbued into stream, use
	<sstream>, eliminated some C-isms.  istream tests disabled, not yet
	locale-ized.
	* tests/cxx/Makefile.am (t_locale_SOURCES): Remove localeconv.c.
	* tests/cxx/localeconv.c: Remove file.

	* configure.in (AC_CHECK_TYPES) [C++]: Add std::locale.
	* printf/doprntf.c: Add decimal point parameter, remove localeconv use.
	* gmp-impl.h (__gmp_doprnt_mpf): Update prototype, bump symbol to
	__gmp_doprnt_mpf2 to protect old libgmpxx.
	* cxx/osmpf.cc: Use this with ostream locale decimal_point facet.
	* printf/doprnt.c: Ditto, with GMP_DECIMAL_POINT.

	* gmp-h.in: More comments on __declspec for windows DLLs.

	* mpf/set_str.c, scanf/doscan.c: Cast through "unsigned char" for
	decimal point string, same as input chars.

	* configure.in (AC_CHECK_HEADERS): Add langinfo.h.
	(AC_CHECK_FUNCS): Add nl_langinfo.
	* gmp-impl.h (GMP_DECIMAL_POINT): New macro.
	* mpf/out_str.c, mpf/set_str.c, scanf/doscan.c: Use it, and don't
	bother with special code for non-locale systems.
	* tests/misc/t-locale.c: Subvert nl_langinfo too.

	* configure.in, acinclude.m4 (GMP_ASM_X86_GOT_UNDERSCORE): New macro.
	* mpn/x86/x86-defs.m4 (_GLOBAL_OFFSET_TABLE_): New macro, inserting
	extra underscore for OpenBSD.
	* mpn/x86/README (_GLOBAL_OFFSET_TABLE_): Update notes.
	Reported by Christian Weisgerber.

	* tests/cxx/t-rand.cc (check_randinit): New function, collecting up
	constructor tests.

	* tests/cxx/t-ostream.cc: Use <sstream> instead of <strstream>, use
	compare instead of strcmp.

	* gmpxx.h (__gmp_randinit_lc_2exp_size_t): Return type is int.

2002-11-18  Kevin Ryde  <kevin@swox.se>

	* tune/speed.c (r_string): Use CNST_LIMB with <N>bits, spotted by
	Torbjorn.

2002-11-17  Torbjorn Granlund  <tege@swox.com>

	* mpn/generic/popham.c: New file, using new faster algorithm.
	* mpn/generic/popcount.c: Remove.
	* mpn/generic/hamdist.c: Remove.

	* mpn/ia64/addmul_1.asm: Don't clobber callee-saves register f16.
	* mpn/ia64/mul_1.asm: Likewise.

	* mpn/ia64/addmul_1.asm: Add pred.rel declarations.  Resolve RAW
	hazards for condition code registers, duplicating code as needed.  Add
	prediction to all branches.
	* mpn/ia64/mul_1.asm: Likewise.
	* mpn/ia64/add_n.asm: Likewise.
	* mpn/ia64/sub_n.asm: Likewise.
	* mpn/ia64/copyi.asm: Likewise.
	* mpn/ia64/copyd.asm: Likewise.

	* mpn/generic/random2.c: Add a cast to silence some compilers.

2002-11-16  Torbjorn Granlund  <tege@swox.com>

	* mpz/powm.c: Cap allocation by limiting k to 10 (512 precomputed
	values).

2002-11-16  Kevin Ryde  <kevin@swox.se>

	* configure.in, gmp.texi: Remove powerpc64 ABI=32L, doesn't work and
	is unlikely to ever do so.
	* configure.in: Allow ABI=32 for powerpc64.
	Reported by David Edelsohn.

2002-11-14  Kevin Ryde  <kevin@swox.se>

	* mpn/Makefile.am (nodist_libdummy_la_SOURCES): Add addmul_2.c
	addmul_3.c addmul_4.c addmul_5.c addmul_6.c addmul_7.c addmul_8.c.

	* gmp-h.in (__GMP_DECLSPEC_EXPORT, __GMP_DECLSPEC_IMPORT) [__GNUC__]:
	Use __dllexport__ and __dllimport__ to keep out of application
	namespace.

2002-11-14  Gerardo Ballabio <gerardo.ballabio@unimib.it>

	* gmpxx.h (__gmp_randinit_default_t, __gmp_randinit_lc_2exp_t,
	__gmp_randinit_lc_2exp_size_t): Use extern "C" { typedef ... }, for
	the benefit of g++ prior to 3.2.

2002-11-12  Kevin Ryde  <kevin@swox.se>

	* gmpxx.h (gmp_randclass constructors): Patch from Roberto Bagnara to
	use extern "C" on C function pointer arguments.

2002-11-09  Kevin Ryde  <kevin@swox.se>

	* configure.in, Makefile.am, printf/Makefile.am,
	printf/repl-vsnprintf.c: Handle vsnprintf replacement with C
	conditionals.

	* acinclude.m4 (AC_LANG_FUNC_LINK_TRY(C)): Workaround troubles recent
	HP cc +O3 causes for AC_CHECK_FUNCS.

	* gmp.texi (Notes for Particular Systems): Add Sparc app regs.
	(Debugging): Note gcc -fstack options to detect overflow.
	(Formatted Output Strings, Formatted Input Strings): Format strings
	are not multibyte.

2002-11-06  Torbjorn Granlund  <tege@swox.com>

	* mpn/generic/tdiv_qr.c: Remove a bogus assert.

2002-11-05  Torbjorn Granlund  <tege@swox.com>

	* mpn/generic/tdiv_qr.c: Remove two dead mpn_divrem_2 calls.

2002-11-04  Kevin Ryde  <kevin@swox.se>

	* acinclude.m4 (GMP_C_INLINE): Don't define "inline" for C++.

	* demos/expr/expr-impl.h (stdarg.h): Test __DECC same as gmp.h.

	* mpbsd/mtox.c, printf/obprintf.c, printf/obvprintf.c,
	scanf/vsscanf.c, demos/expr/expr.c, demos/expr/exprf.c,
	demos/expr/exprfa.c, demos/expr/exprfr.c, demos/expr/exprq.c,
	demos/expr/exprz.c, demos/expr/exprza.c: Add <string.h> for strlen and
	memcpy.

2002-11-02  Kevin Ryde  <kevin@swox.se>

	* longlong.h: Test __x86_64__ not __x86_64.  Reported by Andreas
	Jaeger.

	* mpz/import.c, mpz/export.c: Use char* subtract from NULL to get
	pointer alignment, for the benefit of Cray vector systems.

	* cxx/ismpf.cc: Use <clocale>.
	* tests/cxx/t-locale.cc: No need to conditionalize <clocale>.

	* scanf/doscan.c: Don't use isascii, rely on C99 ctype.h.

	* gmp.texi (Build Options): Describe CC_FOR_BUILD, cross reference
	texinfo manual.
	(ABI and ISA): Add powerpc620 and powerpc630 to powerpc64, add NetBSD
	and OpenBSD sparc64.
	(Notes for Package Builds): Cross reference libtool manual.
	(Notes for Particular Systems): Add OpenBSD to non-MMX versions of gas.
	(Known Build Problems): Add MacOS X C++ shared libraries.

2002-10-31  Kevin Ryde  <kevin@swox.se>

	* gmp-impl.h, tune/speed.c, tune/speed.h, tune/common.c, tune/many.pl,
	tests/devel/try.c, tests/tests.h, tests/refmpn.c (mpn_addmul_5,
	mpn_addmul_6, mpn_addmul_7, mpn_addmul_8): Add testing and measuring.
	* configure.in (config.in): Add #undefs of HAVE_NATIVE_mpn_addmul_5,
	HAVE_NATIVE_mpn_addmul_6, HAVE_NATIVE_mpn_addmul_7,
	HAVE_NATIVE_mpn_addmul_8.
	(gmp_mpn_functions_optional): Add addmul_5 addmul_6 addmul_7 addmul_8.

	* tests/devel/try.c (ASSERT_CARRY): Remove, now in gmp-impl.h
	(try_one): Do dest setups after sources, for benefit of
	dst0_from_src1.

2002-11-01  Torbjorn Granlund  <tege@swox.com>

	* mpn/generic/tdiv_qr.c: Avoid quadratic behaviour for
	sub-division when numerator is more than twice the size of the
	denominator.  Simplify loop logic for the same case.  Clean up a
	few comments.

2002-10-29  Torbjorn Granlund  <tege@swox.com>

	* configure.in (*-cray-unicos*): Pass -hnofastmd again.

2002-10-25  Torbjorn Granlund  <tege@swox.com>

	* tests/tadd.c: Disable test of denorms.

2002-10-23  Linus Nordberg  <linus@swox.se>

	* gmp.texi (Introduction to GMP): Update section about mailing
	lists.

2002-10-23  Kevin Ryde  <kevin@swox.se>

	* gmp-h.in (__GMP_ATTRIBUTE_PURE): Suppress this when
	__GMP_NO_ATTRIBUTE_CONST_PURE is defined.
	* gmp-impl.h (ATTRIBUTE_CONST): Ditto.
	* tune/common.c: Use __GMP_NO_ATTRIBUTE_CONST_PURE.

	* tune/speed.h, tune/many.pl: Remove ATTRIBUTEs from prototypes.
	* tune/speed.h: Remove various "dummy" variables attempting to keep
	"pure" calls live, no longer necessary.  They weren't sufficient for
	recent MacOS cc anyway.

2002-10-21  Torbjorn Granlund  <tege@swox.com>

	* mpn/cray/ieee/addmul_1.c: Handle overlap as in mul_1.c.
	* mpn/cray/ieee/submul_1.c: Likewise.

2002-10-19  Kevin Ryde  <kevin@swox.se>

	* configure.in (sparcv9 etc -*-*bsd*): Add support for NetBSD and
	OpenBSD sparc64.  Reported by Christian Weisgerber.
	(AC_CHECK_HEADERS): Add sys/param.h for sys/sysctl.h on *BSD.

	* demos/calc/calc.y: Change ={ to {, needed for bison 1.50.

	* longlong.h (count_leading_zeros, count_trailing_zeros) [x86_64]:
	Should be UDItype.

	* mpz/set_str.c, mpf/set_str.c, mpbsd/xtom.c, scanf/sscanffuns.c: Cast
	chars through "unsigned char" to zero extend, required by C99 ctype.h.

2002-10-18  Torbjorn Granlund  <tege@swox.com>

	* tests/mpz/t-root.c: Test also mpz_rootrem.

	* mpn/generic/rootrem.c: Avoid overflow problem when n is huge.

	* mpz/root.c: Avoid overflow problems in allocation computation; also
	simplify it.  Misc cleanups.

	* mpz/rootrem.c: New file.
	* Makefile.am, mpz/Makefile.am, gmp-h.in: Add them.

2002-10-17  Torbjorn Granlund  <tege@swox.com>

	* gmp-impl.h (popc_limb): Combine variants.

2002-10-14  Kevin Ryde  <kevin@swox.se>

	* configure.in (AC_CHECK_HEADERS): Add sys/time.h for sys/resource.h
	test, needed by SunOS, and next autoconf will insist headers actually
	compile.

2002-10-08  Kevin Ryde  <kevin@swox.se>

	* tune/time.c (speed_time_init): Allow for Cray times() apparently
	being a cycle counter.

	* dumbmp.c (mpz_get_str): Fix buf size allocation.

	* tests/trace.c, tests/tests.h (mp_limb_trace): New function.

	* tune/speed-ext.c (SPEED_EXTRA_PROTOS): Use __GMP_PROTO.
	* tests/devel/try.c (malloc_region): Add a cast for SunOS cc.

	* configure.in (AC_CHECK_FUNCS): Add strerror.
	(AC_CHECK_DECLS): Add sys_errlist, sys_nerr.
	* tune/time.c, tests/devel/try.c: Use them.

2002-10-05  Kevin Ryde  <kevin@swox.se>

	* configure.in (AC_CHECK_HEADERS): Test float.h, not in SunOS cc.
	* printf/repl-vsnprintf.c: Use this.

	* configure.in (*sparc*-*-*): Collect up various options for clarity,
	use gcc -mcpu=supersparc and ultrasparc3, use cc -xchip, don't use
	-xtarget=native, use cc configs with acc, merge SunOS bundled cc and
	SunPRO cc configs.

	* gmp-impl.h (gmp_randfnptr_t): Use __GMP_PROTO.
	(MPZ_REALLOC): Cast _mpz_realloc return value to mp_ptr, for the
	benefit of SunOS cc which requires pointers of the same type on the
	two legs of a ?:.

	* dumbmp.c (mpz_realloc): Add a cast to avoid a warning from SunOS cc.

	* acinclude.m4: Allow for i960 b.out default cc output.

	* gmp.texi (Random State Initialization): Add gmp_randinit_mt.
	(Perfect Square Algorithm): Describe new mpn_mod_34lsub1 use.
	(Factorial Algorithm): Describe Jason's new code.
	(Binomial Coefficients Algorithm): Ideas about improvements
	moved to doc/projects.html.
	(Contributors): Add Jason Moxham and Pedro Gimeno.

2002-10-03  Kevin Ryde  <kevin@swox.se>

	* gen-psqr.c: New file.
	* Makefile.am, mpn/Makefile.am: Use it to generate mpn/perfsqr.h.
	* mpn/generic/perfsqr.c: Use generated data, put mod 256 data into
	limbs to save space, use mpn_mod_34lsub1 when good.
	* tests/mpn/t-perfsqr.c: New file.
	* tests/mpn/Makefile.am (check_PROGRAMS): Add it.
	* tests/mpz/t-perfsqr.c (check_modulo): New test.
	(check_sqrt): New function holding current tests.

	* configure.in (AC_INIT): Modernize to package name and version here
	rather than AM_INIT_AUTOMAKE, add bug report email.
	(AC_CONFIG_SRCDIR): New macro.

	* gmp-impl.h (ROUND_UP_MULTIPLE): Fix for non-power-of-2 moduli (not
	normal in current uses), clarify the comments a bit.

2002-09-30  Kevin Ryde  <kevin@swox.se>

	* mpn/Makeasm.am (.s.lo): Add --tag=CC for the benefit of CCAS!=CC,
	same as .S.lo and .asm.lo.

	* Makefile.am (gen-fac_ui, gen-fib, gen-bases): Quote source files in
	test -f stuff to avoid Sun make rewriting them.

2002-09-28  Kevin Ryde  <kevin@swox.se>

	* tests/devel/try.c, tune/speed.c: Avoid strings longer than C99
	guarantees.

	* tests/refmpn.c, tests/tests.h (refmpn_zero_extend, refmpn_normalize,
	refmpn_sqrtrem): New functions.
	* tests/devel/try.c (TYPE_SQRTREM): Use refmpn_sqrtrem.
	(compare): Correction to tr->dst_size subscripting.

	* dumbmp.c: Add several new functions, allow for initial n<d in
	mpz_tdiv_q (now in mpz_tdiv_qr actually).

	* gen-bases.c (chars_per_limb): Get GMP_NUMB_BITS for base==2,
	similarly other powers of 2, which this was in the past.
	* tests/refmpn.c (refmpn_chars_per_limb): Ditto.
	* tests/mpn/t-mp_bases.c: Test chars_per_limb for power-of-2 bases too.

	* Makefile.am, mpz/Makefile.am: Setups for gen-fac_ui.c generating
	mpz/fac_ui.h.

2002-09-28  Jason Moxham <J.L.Moxham@maths.soton.ac.uk>

	* dumbmp.c (mpz_pow_ui, mpz_addmul_ui, mpz_root): New functions.
	* gen-fac_ui.c: New file.
	* mpz/fac_ui.c: Rewrite.

2002-09-26  Kevin Ryde  <kevin@swox.se>

	* tests/cxx/localeconv.c: New file, split from t-locale.cc.
	* tests/cxx/t-locale.cc: Use it.
	* tests/cxx/Makefile.am (t_locale_SOURCES): Add it.

	* tests/cxx/Makefile.am: Updates for Gerardo's new test programs.

2002-09-26  Gerardo Ballabio <gerardo.ballabio@unimib.it>

	* gmpxx.h (__gmp_cmp_function): Bug fixes in double/mpq and
	double/mpfr comparisons.

	* tests/cxx/t-assign.cc, tests/cxx/t-binary.cc, tests/cxx/t-constr.cc,
	tests/cxx/t-ternary.cc, tests/cxx/t-unary.cc: Revise and add various
	tests, including some for mpfr, some split from t-expr.cc.
	* tests/cxx/t-locale.cc: Modernize include files.
	* tests/cxx/t-ostream.cc: Modernize include files, use cout rather
	than printf for diagnostics.
	* tests/cxx/t-misc.cc, tests/cxx/t-rand.cc: New file, split from
	t-allfuns.cc.
	* tests/cxx/t-ops.cc: New file, some split from t-allfuns.cc.
	* tests/cxx/t-prec.cc: New file.
	* tests/cxx/t-allfuns.cc, tests/cxx/t-expr.cc: Remove files.

2002-09-25  Torbjorn Granlund  <tege@swox.com>

	* configure.in (*-cray-unicos*): Remove -hscalar0, it causes too much
	performance loss.  Let's trust Cray to fix their compilers.

2002-09-24  Torbjorn Granlund  <tege@swox.com>

	* mpn/powerpc32/add_n.asm: Rewrite.
	* mpn/powerpc32/sub_n.asm: Rewrite.

2002-09-24  Pedro Gimeno  <pggimeno@wanadoo.es>

	* randlc2x.c: Prepare for nails by changing type of _mp_c to mpz_t,
	make _mp_seed fixed-size, disallow SIZ(a)==0 to optimize comparisons
	for mpn_mul.
	* gmp-impl.h (MPZ_FAKE_UI): New macro.

	* randmt.c: Some constants made long for K&R compliance; remove UL at
	the end of other constants; use mp_size_t where appropriate; use
	mpz_export to split the seed.

	* gmp-impl.h: Remove type cast in RNG_FNPTR and RNG_STATE, to allow
	them to be used as lvalues.
	* randclr.c, randlc2x.c, randmt.c, randsd.c: All callers changed.

	* mpz/urandomm.c: Replace mpn_cmp with MPN_CMP.

	* tests/rand/gen.c: Get rid of gmp_errno.

2002-09-24  Kevin Ryde  <kevin@swox.se>

	* gmp.texi (Custom Allocation): Keep allocate_function etc out of the
	function index by using @deftypevr.
	More index entries.

2002-09-24  Gerardo Ballabio <gerardo.ballabio@unimib.it>

	* gmpxx.h (mpfr_class constructors from strings): Precision was set
	incorrectly, fixed.

2002-09-23  Torbjorn Granlund  <tege@swox.com>

	* mpf/urandomb.c: Don't crash for overlarge nbits argument.
	Let nbits==0 mean to fill number with random bits.

2002-09-21  Torbjorn Granlund  <tege@swox.com>

	* mpn/alpha/mod_34lsub1.asm: Add r31 dummy operand to `br' instruction.

2002-09-20  Gerardo Ballabio <gerardo.ballabio@unimib.it>

	* gmpxx.h (__gmp_binary_equal, __gmp_binary_not_equal): Fix broken
	mpq/double functions.

2002-09-18  Torbjorn Granlund  <tege@swox.com>

	* randmt.c (randget_mt): Fix typo.

2002-09-18  Kevin Ryde  <kevin@swox.se>

	* gmp-impl.h (_gmp_rand): Avoid evaluating "state" more than once, for
	the benefit places calling it with RANDS.

	* randmt.c (randseed_mt): Use mpz_init for mod and seed1, for safety.

	* tune/tuneup.c (sqr_karatsuba_threshold): Initialize to
	TUNE_SQR_KARATSUBA_MAX so mpn_sqr_n works for randmt initialization.

	* gmp.texi (Integer Comparisons): Remove mention of non-existant
	mpz_cmpabs_si, reported by Conrad Curry.

	* tune/speed.c, tune/speed.h, tune/common.c: Add gmp_randseed,
	gmp_randseed_ui and mpz_urandomb.

2002-09-18  Pedro Gimeno  <pggimeno@wanadoo.es>

	* tests/rand/gen.c: Add mt, remove lc and bbs.

	* Makefile.am (libgmp_la_SOURCES): Add randmt.c, remove randlc.c and
	randraw.c.

	* randmt.c: New file.
	* gmp-h.in (gmp_randinit_mt): Add prototype.
	* randdef.c: Use gmp_randinit_mt.

	* gmp-impl.h (RNG_FNPTR, RNG_STATE): New macros.
	(gmp_randfnptr_t): New structure.
	(_gmp_rand): Now a macro not a function.
	* gmp-h.in (__gmp_randata_lc): Remove, now internal to randlc2x.c.
	(__gmp_randstate_struct): Revise comments on field usage.
	* randsd.c, randclr.c: Use function pointer scheme.
	* randsdui.c: Use gmp_randseed.
	* randraw.c: Remove file.
	* randlc2x.c: Collect up lc_2exp related code from randsd.c, randclr.c
	and randraw.c, use function pointer scheme, integrate seed==0/a==0
	into main case and fix case where bits(a) < m2exp.

	* randlc.c: Remove file, never documented and never worked.
	* gmp-h.in (gmp_randinit_lc): Remove prototype.

2002-09-16  Torbjorn Granlund  <tege@swox.com>

	* mpn/alpha/mod_34lsub1.asm: New file.

2002-09-16  Kevin Ryde  <kevin@swox.se>

	* configure.in, acinclude.m4 (GMP_C_RESTRICT): Remove this, not
	currently used, and #define restrict upsets Microsoft C headers on
	win64.  Reported by David Librik.

	* configure.in (x86): Add gcc 3.2 -march and -mcpu flags, remove some
	unnecessary -march=i486 fallbacks.

	* gmp.texi (Notes for Particular Systems): Note cl /MD is required for
	Microsoft C and MINGW to cooperate on I/O.  Explained by David Librik.
	(Language Bindings): Add linbox.
	* gmp.texi (Language Bindings):

2002-09-12  Kevin Ryde  <kevin@swox.se>

	* mpz/aorsmul_i.c: Allow for w==x overlap with nails.  Test
	BITS_PER_ULONG > GMP_NUMB_BITS rather than GMP_NAIL_BITS != 0.
	* tests/mpz/t-aorsmul.c: Test this.

	* tune/common.c: mpn_mod_34lsub1 only exists for GMP_NUMB_BITS%4==0
	* tune/speed.c: Add mpn_mod_34lsub1.

2002-09-10  Pedro Gimeno  <pggimeno@wanadoo.es>

	* rand.c: Remove old disabled BBS code.
	* mpf/urandomb.c: Use BITS_TO_LIMBS.

2002-09-10  Kevin Ryde  <kevin@swox.se>

	* gmp.texi (Multiplication Algorithms): FFT is now enabled by default.

2002-09-10  Pedro Gimeno  <pggimeno@wanadoo.es>

	* mpz/urandomm.c: Use mpn level functions, avoid an infinite loop if
	_gmp_rand forever returns all "1" bits.
	* tests/rand/t-urndmm.c: New file
	* tests/rand/Makefile.am (check_PROGRAMS): Add it.

	* gmp-impl.h (BITS_TO_LIMBS): New macro.
	* mpz/urandomb.c: Use it, and use MPZ_REALLOC.

2002-09-08  Kevin Ryde  <kevin@swox.se>

	* acinclude.m4 (GMP_GCC_WA_MCPU): New macro.
	* configure.in (alpha*-*-*): Use it to avoid -Wa,-mev67 if gas isn't
	new enough to know ev67.  Reported by David Bremner.

2002-07-30  Gerardo Ballabio <gerardo.ballabio@unimib.it>

	* gmpxx.h (__gmpz_value etc): Remove, use mpz_t etc instead.
	(__gmp_expr): Reorganise specializations, use __gmp_expr<T,T> not
	mpz_class etc.
	(mpfr evals): Remove mode parameter, was always
	__gmp_default_rounding_mode anyway.

2002-09-07  Kevin Ryde  <kevin@swox.se>

	* gmp-h.in, mp-h.in: Use #ifdef for tests, for the benefit of
	applications using gcc -Wundef.

	* longlong.h: Define COUNT_LEADING_ZEROS_NEED_CLZ_TAB for all alphas,
	since mpn/alpha/cntlz.asm always goes into libgmp.so, even for ev67
	and ev68 which don't need it.  Reported by David Bremner.

	* gmp.texi (Demonstration Programs): New section, expanding on what
	was under "Build Options".
	(Converting Floats): Don't need \ for _ in @var within @math.
	Add and amend various index entries.

	* demos/qcn.c: Add -p prime limit option.

2002-08-30  Kevin Ryde  <kevin@swox.se>

	* mpz/pprime_p.c: Handle small negatives with isprime, in particular
	must do so for n==-2.
	* tests/mpz/t-pprime_p.c: New file.
	* tests/mpz/Makefile.am: Add it.

2002-08-26  Torbjorn Granlund  <tege@swox.com>

	* gmp.texi (Converting Floats): Fix typo in mpf_get_d_2exp docs,
	reported by Paul Zimmermann.

2002-08-26  Kevin Ryde  <kevin@swox.se>

	* configure.in: Echo the ABI being tried for the compilers.
	(powerpc*-*-*): Use powerpc64/aix.m4 for ABI=aix64 too.
	(AC_CHECK_FUNCS): Add strtol, for tests/rand/gen.c.

2002-08-24  Kevin Ryde  <kevin@swox.se>

	* configure.in (HAVE_HOST_CPU_, HAVE_HOST_CPU_FAMILY_, HAVE_NATIVE_):
	Setup templates for these using AH_VERBATIM rather than acconfig.h,
	preferred by latest autoconf.  Prune lists to just things used.
	* acconfig.h: Remove file.

	* mpn/powerpc32/mode1o.asm: Forgot ASM_START.

	* tune/time.c (have_cgt_id): Renamed from HAVE_CGT_ID so avoid
	confusion with autoconf outputs, and turn it into a "const" variable.

2002-08-23  Torbjorn Granlund  <tege@swox.com>

	* configure.in: Choose powerpc32/aix.m4 or powerpc64/aix.m4 based on
	ABI, not configuration triple.

	* mpz/pprime_p.c: Partially undo last change--handle small and
	negative numbers in the same test.

2002-08-22  Kevin Ryde  <kevin@swox.se>

	* gmp-impl.h (MUL_FFT_THRESHOLD, SQR_FFT_THRESHOLD): Note
	mpn/generic/mul_fft.c is not nails-capable, and don't bother setting
	other FFT data for nails.

	* configfsf.guess: Update to 2002-08-19.
	* configfsf.sub: Update to 2002-08-20.

	* config.guess (powerpc*-*-*): Use a { } construct to suppress SIGILL
	message on AIX.

2002-08-20  Kevin Ryde  <kevin@swox.se>

	* gmp.texi (Build Options): Add ia64 under cpu types.
	(ABI and ISA): Describe IRIX 6 ABI=o32.
	(Notes for Particular Systems): Remove -march=pentiumpro, now ok.
	(Known Build Problems): Binutils 2.12 is ok for libgmp.a.
	(Emacs): New section.
	(Language Bindings): Update MLton URL, reported by Stephen Weeks.
	(Prime Testing Algorithm): New section.
	Don't put a blank line after @item in @table since it can make a page
	break between the heading and the entry.
	Misc tweaks elsewhere, in particular more index entries.

	* mpz/millerrabin.c: Need x to be size+1 for change to urandomm.

	* gmp-impl.h: Comments on the use of __GMP_DECLSPEC.

	* tune/time.c (freq_measure_mftb_one): Use struct_timeval, for the
	benefit of mingw.

	* tests/refmpn.c, tests/tests.h (ref_addc_limb, ref_subc_limb):
	Renamed from add and sub, following gmp-impl.h ADDC_LIMB and SUBC_LIMB.

2002-08-17  Kevin Ryde  <kevin@swox.se>

	* mpn/powerpc32/mode1o.asm: New file.
	* configure.in, acinclude.m4 (GMP_ASM_POWERPC_PIC_ALWAYS): New macro.
	* mpn/asm-defs.m4: Use it to help setting up PIC.

	* configure.in (AC_PREREQ): Bump to 2.53.

	* mpn/powerpc32/powerpc-defs.m4	(ASSERT): New macro.
	(PROLOGUE_cpu): New macro, giving ALIGN(4) not 8.

2002-08-16  Torbjorn Granlund  <tege@swox.com>

	* mpn/m68k/lshift.asm: Fix typo in !scale_available_p code.
	* mpn/m68k/rshift.asm: Likewise.

2002-08-16  Kevin Ryde  <kevin@swox.se>

	* configure.in (--enable-profiling=instrument): New option.
	* gmp.texi (Profiling): Describe it.
	* mpn/x86/x86-defs.m4 (PROLOGUE_cpu, call_instrument, ret_internal):
	Add support.
	(call_mcount): Share PIC setups with call_instrument.
	* mpn/x86/*.asm: Use ret_internal.
	* mpn/asm-defs.m4 (m4_unquote): New macro.
	* tests/mpn/t-instrument.c: New file.
	* tests/mpn/Makefile.am: Add it.

	* mpn/alpha/umul.asm: Add ASM_END.

2002-08-12  Kevin Ryde  <kevin@swox.se>

	* mpz/pprime_p.c: Fake up a local mpz_t to take abs(n), rather than
	using mpz_init etc.

	* mpz/millerrabin.c: Use mpz_urandomm for uniform selection of x,
	reported by Jason Moxham.  Exclude x==n-1, ie. -1 mod n.  Use
	gmp_randinit_default.

	* mpn/alpha/umul.asm: Use "r" registers, for the benefit of Unicos.

	* tests/devel/try.c: Add mpn_copyi and mpn_copyd.

2002-08-09  Kevin Ryde  <kevin@swox.se>

	* Makefile.am: Remove configure.lineno from DISTCLEANFILES and gmp.tmp
	from MOSTLYCLEANFILES, automake does these itself now.

	* */Makefile.in, aclocal.m4, configure, install-sh, missing,
	mkinstalldirs: Update to automake 1.6.3.

	* mpn/ia64/README: Some notes on assembler syntax.

	* mpn/ia64/add_n.asm, mpn/ia64/sub_n.asm: Add .body.
	* mpn/ia64/add_n.asm, mpn/ia64/addmul_1.asm, mpn/ia64/mul_1.asm,
	mpn/ia64/sub_n.asm: Position .save ar.lc just before relevant
	instruction.
	* mpn/ia64/addmul_1.asm, mpn/ia64/mul_1.asm: Add .save ar.pfs and pr.
	* mpn/ia64/copyd.asm, mpn/ia64/copyi.asm: Correction to .body position.
	* mpn/ia64/lorrshift.asm: Add .prologue stuff.

	* configure.in (*-*-unicos*): Remove forcible --disable-shared,
	libtool gets this right itself now.

2002-08-07  Kevin Ryde  <kevin@swox.se>

	* mpn/x86/pentium/mmx/hamdist.asm: New file, adapted from
	mpn/x86/pentium/mmx/popham.asm.
	* mpn/x86/pentium/mmx/popham.asm: Remove file, not faster than plain
	mpn/x86/pentium/popcount.asm for the popcount.

	* mpn/alpha/umul.asm: Use PROLOGUE/EPILOGUE, rename it mpn_umul_ppmm.
	* configure.in (alpha*-*-*): Add umul to extra_functions.

	* mpz/remove.c: Make src==0 return 0, not do DIVIDE_BY_ZERO.

2002-08-05  Torbjorn Granlund  <tege@swox.com>

	* acconfig.h: Remove spurious undefs for mpn_divrem_newton and
	mpn_divrem_classic.

2002-08-05  Kevin Ryde  <kevin@swox.se>

	* tests/refmpn.c, tests/tests.h, tests/misc/t-printf.c,
	tests/mpf/t-trunc.c, tests/mpn/t-mp_bases.c, tests/mpn/t-scan.c,
	tests/mpq/t-cmp_ui.c, tests/mpz/bit.c, tests/mpz/t-aorsmul.c,
	tests/mpz/t-powm_ui.c tests/mpz/t-root.c, tests/mpz/t-scan.c: More
	care with long and mp_size_t parameters, for the benefit of K&R.

	* demos/perl/GMP.pm, demos/perl/GMP.xs, demos/perl/GMP/Mpz.pm,
	demos/perl/test.pl: Add mpz_import and mpz_export.
	* demos/perl/GMP.pm: Remove "preliminary" warning.

	* mpn/lisp/gmpasm-mode.el: Set add-log-current-defun-header-regexp to
	pick up m4 defines etc.

	* Makefile.am (libgmpxx_la_DEPENDENCIES): libgmp.la should be here,
	not libgmpxx_la_LIBADD, for the benefit of "make -j2".

	* mpn/ia64/*.asm [hpux ABI=32]: Extend 32-bit operands to 64-bits, not
	optimal and might not be sufficient, but seems to work.

2002-08-03  Kevin Ryde  <kevin@swox.se>

	* gmp.texi (Profiling): Use a table and expand for clarity.
	(Integer Special Functions): New section for mpz_array_init,
	_mpz_realloc, mpz_getlimbn and mpz_size, to discourage their use.

	* configure.in (*-*-msdosdjgpp*): Remove forcible --disable-shared,
	libtool gets this right itself now.

2002-07-30  Kevin Ryde  <kevin@swox.se>

	* mpn/powerpc32/lshift.asm, mpn/powerpc32/rshift.asm: Lose final mr,
	and make final stwu into an stw.

	* gmp.texi (Known Build Problems): An easier workaround for DESTDIR,
	using LD_LIBRARY_PATH.
	(C++ Interface MPFR): Remove mpfrxx.h.

	* mpfrxx.h: Remove file.
	* Makefile.am: Remove mpfrxx.h.
	* tests/cxx/Makefile.am: Add Gerardo's new test programs.

2002-07-30  Gerardo Ballabio <gerardo.ballabio@unimib.it>

	* gmpxx.h: Use mpz_addmul etc for ternary a+b*c etc.  Reorganise some
	macros for maintainability.  Merge mpfrxx.h.
	* tests/cxx/t-constr.cc, tests/cxx/t-expr.cc: Various updates.
	* tests/cxx/t-assign.cc, tests/cxx/t-binary.cc,
	tests/cxx/t-ternary.cc, tests/cxx/t-unary.cc: New files.

2002-07-27  Kevin Ryde  <kevin@swox.se>

	* longlong.h (count_trailing_zeros) [ia64 __GNUC__]: Don't use
	__builtin_ffs for now, doesn't seem to work.

	* configure.in: Establish CONFIG_SHELL to avoid a problem with
	AC_LIBTOOL_SYS_MAX_CMD_LEN on ia64-*-hpux*.

	* tune/speed.h (SPEED_ROUTINE_MPN_GCD_FINDA): Don't let calls to
	mpn_gcd_finda go dead.

	* mpn/generic/tdiv_qr.c: Inline mpn_rshift and MPN_COPY of 2 limbs.

2002-07-24  Kevin Ryde  <kevin@swox.se>

	* demos/primes.c: Use __GMP_PROTO and don't use signed, for the
	benefit of K&R.

	* demos/calc/calclex.l: Add <string.h> for strcmp.

	* mpn/ia64/invert_limb.asm: Use .rodata which works on ia64-*-hpux*
	and should be standard, rather than worrying about RODATA.

	* gmp.texi (Function Classes): Add cross references.
	(Integer Import and Export): Fix return value grouping.

	* mpn/lisp/gmpasm-mode.el (gmpasm-comment-start-regexp): Add // for
	ia64.  Add notes on what the various styles are for.

	* mpn/ia64/default.m4 (ASM_START): Define to empty, not dnl, so as not
	to kill text on the same line.
	(EPILOGUE_cpu): Force a newline after "#", so as not to suppress macro
	expansion in the rest of the EPILOGUE line.

2002-07-21  Kevin Ryde  <kevin@swox.se>

	* tune/speed.h: Fix some missing _PROTOs.

	* Makefile.am (DISTCLEANFILES): Add configure.lineno.

	* acinclude.m4 (GMP_C_DOUBLE_FORMAT): Define
	HAVE_DOUBLE_IEEE_BIG_ENDIAN and HAVE_DOUBLE_IEEE_LITTLE_ENDIAN in
	config.m4 too.
	* mpn/ia64/invert_limb.asm: Add big-endian data.

	* tests/mpz/t-jac.c (try_si_zi): Correction to "a" parameter type.

2002-07-20  Kevin Ryde  <kevin@swox.se>

	* mpz/bin_ui.c, mpz/jacobi.c, mpz/pprime_p.c, mpn/generic/divis.c:
	More care with long and mp_size_t parameters, for the benefit of K&R.

	* gmp-impl.h (invert_limb): Use parens around macro arguments.
	(mpn_invert_limb): Give prototype and define unconditionally.

	* gmp-impl.h (CACHED_ABOVE_THRESHOLD, CACHED_BELOW_THRESHOLD): New
	macros.
	* mpn/generic/sb_divrem_mn.c: Use them to help gcc let preinv code go
	dead when not wanted.

2002-07-17  Kevin Ryde  <kevin@swox.se>

	* tests/refmpz.c (refmpz_hamdist): Ensure mp_size_t parameters are
	that type, for the benefit of hpux ia64 bundled cc ABI=64.

	* configure.in (ia64*-*-hpux*): Need +DD64 in cc_64_cppflags to get
	the right headers for ansi2knr.

	* acinclude.m4 (GMP_TRY_ASSEMBLE, GMP_ASM_UNDERSCORE): Use $CPPFLAGS
	with $CCAS and when linking, as done by the makefiles.
	(GMP_ASM_X86_MMX, GMP_ASM_X86_SSE2): Show $CPPFLAGS in diagnostics.

	* gmp-impl.h (ieee_double_extract): Setup using HAVE_DOUBLE_IEEE_*.
	(GMP_UINT32): New define, 32 bit type for ieee_double_extract.
	* configure.in: Add AC_CHECK_SIZEOF unsigned.
	* configure.in, acinclude.m4 (GMP_IMPL_H_IEEE_FLOATS): Remove.
	(GMP_C_DOUBLE_FORMAT): Instead warn about unknown float here.

	* configure.in, acinclude.m4 (GMP_C_SIZES): Remove.
	* acinclude.m4 (GMP_INCLUDE_GMP_H_BITS_PER_MP_LIMB): Remove this
	scheme, not required.
	* configure.in (unsigned long, mp_limb_t): Run AC_CHECK_SIZEOF for
	these unconditionally, check mp_limb_t against gmp-mparam.h values.
	* gmp-impl.h (BYTES_PER_MP_LIMB, BITS_PER_MP_LIMB): Define based on
	SIZEOF_MP_LIMB_T if not provided by gmp-mparam.h.
	(BITS_PER_ULONG): Define here now.

	* gmp.texi (ABI and ISA): Add HP-UX IA-64 choices.
	(Random State Initialization): Typo in m2exp described for
	gmp_randinit_lc_2exp_size.
	(Formatted Output Functions): Clarify gmp_obstack_printf a bit.
	(Formatted Input Strings): Typo in %n summary.

	* mpz/inp_raw.c (NTOH_LIMB_FETCH): Use simple generic default, since
	endianness detection is now cross-compile friendly.
	* mpz/out_raw.c (HTON_LIMB_STORE): Ditto.

	* mpz/fib_ui.c: Nailify.
	* mpz/random.c: Nailify.

	* mpfr/acinclude.m4 (MPFR_CONFIGS): Patch by Vincent for an apparent
	float rounding gremlin on powerpc.

2002-07-15  Kevin Ryde  <kevin@swox.se>

	* Makefile.am (PRINTF_OBJECTS): Avoid ending in a backslash, hpux ia64
	make doesn't like that.

	* configure.in (ia64*-*-*): Use ABI=64 on non-HPUX systems, for
	consistency.

	* gmp-impl.h (ieee_double_extract): Test __sparc__, used by gcc 3.1.
	Reported by nix@esperi.demon.co.uk.
	* mpfr/mpfr-math.h (_MPFR_NAN_BYTES etc): Ditto.

2002-07-13  Kevin Ryde  <kevin@swox.se>

	* mpn/powerpc32/rshift.asm: Rewrite, transformed from lshift.asm.

	* tune/tuneup.c (DIVEXACT_1_THRESHOLD, MODEXACT_1_ODD_THRESHOLD):
	Always zero for native mpn_divexact_1, mpn_modexact_1_odd.

	* gmp-h.in (__GMP_EXTERN_INLINE): Don't use this during configure,
	ie. __GMP_WITHIN_CONFIGURE, to avoid needing dependent routines.
	* acinclude.m4 (GMP_H_EXTERN_INLINE): Consequent changes.

	* gmp-impl.h, mpn/asm-defs.m4 (mpn_addmul_2, mpn_addmul_3,
	mpn_addmul_4): Add prototypes and defines.

	* gmp.texi (Number Theoretic Functions): Clarify return value.
	Reported by Peter Keller.

2002-07-10  Kevin Ryde  <kevin@swox.se>

	* configure.in, acinclude.m4 (GMP_PROG_LEX): Remove this in favour of
	AM_PROG_LEX, now ok when lex is missing.

	* longlong.h (count_leading_zeros) [pentiummmx]: Don't use __clz_tab
	variant under LONGLONG_STANDALONE.
	(count_trailing_zeros) [ia64 __GNUC__]: Use __builtin_ffs.

	* gmp-impl.h (popc_limb): Add an ia64 asm version.
	(DItype): Use HAVE_LONG_LONG to choose long long, avoiding _LONGLONG
	which is in gcc but means something unrelated in MS Visual C 7.0.
	Reported by David Librik.

	* mpz/divexact.c: Add an ASSERT that den divides num.

	* mpn/asm-defs.m4 (LDEF): New macro.
	(INT32, INT64): Use it.
	* mpn/pa32/*.asm: Use it.
	* mpn/pa32/README: Update notes on labels.

	* tests/refmpn.c, tests/tests.h, tests/t-bswap.c (ref_bswap_limb):
	Renamed from refmpn_bswap_limb.
	* tests/t-bswap.c: Add tests_start/tests_end for randomization.

	* tests/refmpn.c, tests/tests.h (ref_popc_limb): New function.
	* tests/t-popc.c: New file.
	* tests/Makefile.am: Add it.

	* mpn/ia64/invert_limb.asm: Use RODATA since ".section .rodata" is not
	accepted by ia64-*-hpux*.

	* acinclude.m4 (GMP_ASM_BYTE): New macro.
	(GMP_ASM_ALIGN_LOG, GMP_ASM_W32): Use it.
	(GMP_ASM_LABEL_SUFFIX): Use test compiles, not $host.
	(GMP_ASM_GLOBL): Ditto, and add .global for ia64-*-hpux*.
	(GMP_ASM_GLOBL_ATTR): Use GMP_ASM_GLOBL result, not $host.
	(GMP_ASM_LSYM_PREFIX): Allow any "a-z" nm symbol code, add ".text" to
	test program, required by ia64-*-hpux*.
	(GMP_ASM_LABEL_SUFFIX): Make LABEL_SUFFIX just the value, not a "$1:",
	the former being how it's currently being used in fact.

	* configure.in, acinclude.m4 (GMP_PROG_CC_WORKS_LONGLONG): New macro.
	* configure.in (ia64-*-hpux*): Add 32 and 64 bit ABI modes.

2002-07-06  Kevin Ryde  <kevin@swox.se>

	* tests/cxx/t-allfuns.cc: New file.
	* tests/cxx/Makefile.am: Add it.

	* mpz/clrbit.c, mpz/setbit.c: Only MPN_NORMALIZE if high limb changes
	to zero.  Use _mpz_realloc return value.

	* gmp.texi (Build Options, C++ Formatted Output, C++ Formatted Input):
	Cross reference to Headers and Libraries for libgmpxx stuff.
	(Low-level Functions): mpn_divexact_by3 result based on GMP_NUMB_BITS.
	mpn_set_str takes "unsigned char *", reported by Mark Sofroniou.
	(C++ Interface General): Describe linking with libgmpxx and libgmp.

2002-07-01  Kevin Ryde  <kevin@swox.se>

	* tune/tuneup.c, gmp-impl.h: Eliminate the array of thresholds in
	one(), tune just one at a time and let the callers hand dependencies.
	Eliminate the second_start_min hack, handle SQR_KARATSUBA_THRESHOLD
	oddities in tune_sqr() instead.

	* mpn/pa64/umul.asm, mpn/pa64/udiv.asm, mpn/asm-defs.m4, acconfig.h,
	longlong.h, tune/speed.c, tune/speed.h, tune/common.c, tune/many.pl,
	tests/devel/try.c: Introduce mpn_umul_ppmm_r and mpn_udiv_qrnnd_r
	rather than having variant parameter order for mpn_umul_ppmm and
	mpn_udiv_qrnnd on pa64.

	* gmp-h.in (mpz_export): Remove a spurious parameter name.
	* gmp-impl.h (mpn_rootrem): Use __MPN.

2002-06-29  Kevin Ryde  <kevin@swox.se>

	* longlong.h (udiv_qrnnd) [hppa32]: Remove mpn_udiv_qrnnd version, the
	general mechanism for that suffices.

	* mpf/inp_str.c: Fix returned count of chars read, reported by Paul
	Zimmermann.  Also fix a memory leak for invalid input.
	* tests/mpf/t-inp_str.c: New file.
	* tests/mpf/Makefile.am (check_PROGRAMS): Add it.

	* tests/devel/try.c (mpn_mod_34lsub1): Only exists for
	GMP_NUMB_BITS%4==0.
	(SIZE2_FIRST): Respect option_firstsize2 for "fraction" case.

	* mpn/generic/diveby3.c: Further nailifications.
	* gmp-impl.h (MODLIMB_INVERSE_3): Allow for GMP_NUMB_BITS odd.
	(GMP_NUMB_CEIL_MAX_DIV3, GMP_NUMB_CEIL_2MAX_DIV3): New constants.
	* tests/t-constants.c: Check them.

	* gmp-h.in (__GMP_CRAY_Pragma): New macro.
	(__GMPN_COPY_REST): Use it.
	* gmp-impl.h (CRAY_Pragma): Use it.

2002-06-25  Kevin Ryde  <kevin@swox.se>

	* mpz/import.c, mpz/export.c: Cast data pointer through "char *" in
	alignment tests, for the benefit of Cray vector systems.

	* configure.in (x86-*-*): Remove -march=pentiumpro check, seems ok
	with current code.
	* acinclude.m4 (GMP_GCC_MARCH_PENTIUMPRO, GMP_GCC_VERSION_GE): Remove
	macros, no longer needed

	* acinclude.m4 (GMP_ASM_RODATA): Remove temporary files.

	* configure.in (GMP_ASM_GLOBL_ATTR): Reposition to avoid duplication
	through AC_REQUIRE.

2002-06-23  Kevin Ryde  <kevin@swox.se>

	* tests/mpz/t-fib_ui.c (check_fib_table): Check table values, not just
	that they're non-zero.

	* acinclude.m4 (GMP_GCC_ARM_UMODSI): Match bad "gcc --version" output
	exactly, rather than parsing it with GMP_GCC_VERSION_GE.
	(GMP_ASM_UNDERSCORE): Use GLOBL_ATTR.

	* mpn/pa32/udiv.asm, mpn/pa32/hppa1_1/udiv.asm, mpn/pa64/udiv.asm:
	Renamed from udiv_qrnnd.asm, for consistency with other udiv's.
	* mpn/pa64/umul.asm: Renamed from umul_ppmm.asm likewise.
	* configure.in (hppa*-*-*): Update extra_functions.
	(NAILS_SUPPORT): Remove umul_ppmm, udiv_qrnnd, udiv_fp, udiv_nfp from
	nails-neutral list, no longer needed.

	* gmp-h.in (__DECC): Add notes on testing this for ANSI-ness.
	(__GMP_EXTERN_INLINE): Add static __inline for DEC C.
	(mpz_mod_ui): Move up to main section, it's still documented.

2002-06-22  Kevin Ryde  <kevin@swox.se>

	* mpz/jacobi.c, mpz/kronsz.c, mpz/kronuz.c, mpz/kronzs.c,
	mpz/kronzu.c: Allow for odd GMP_NUMB_BITS, tweak a few variable setups.
	* gmp-impl.h (JACOBI_STRIP_LOW_ZEROS): New macro.

	* mpn/generic/mod_34lsub1.c: Nailify.
	* tests/devel/try.c (CNST_34LSUB1): Nailify.
	* gmp-impl.h (ADDC_LIMB): New macro.

	* gmpxx.h (mpf_class::get_str): Make exponent mp_exp_t&, default
	base=10 and ndigits=0.
	(mpz_class::set_str, mpq_class::set_str, mpf_class::set_str): Add
	versions accepting "const char *".
	* mpfrxx.h (mpfr_class::get_str, mpfr_class::set_str): Ditto, and
	uncommenting set_str and operator=.
	* gmp.texi (C++ Interface Integers, C++ Interface Rationals)
	(C++ Interface Floats): Update.

	* gmp-impl.h (modlimb_invert): Merge the <=64bits and general versions.
	(const, signed): Move to near top of file, fixes --enable-alloca=debug
	on K&R.

	* gen-fib.c: New file, derived from mainline in mpn/generic/fib2_ui.c.
	* dumbmp.c (mpz_init_set_ui): New function.
	* Makefile.am, mpn/Makefile.am: Generate fib_table.h, mpn/fib_table.c.
	* gmp-impl.h: Use fib_table.h, add __GMP_DECLSPEC to __gmp_fib_table
	(for the benefit of tests/mpz/t-fib_ui.c).
	* mpn/generic/fib2_ui.c: Remove __gmp_fib_table and generating code.

	* Makefile.am: Add mp.h to BUILT_SOURCES, distclean all BUILT_SOURCES,
	use += more.

	* acinclude.m4 (GMP_ASM_M68K_INSTRUCTION, GMP_ASM_M68K_BRANCHES):
	Don't let "unknown" get into the cache variables.
	(GMP_ASM_TEXT): See what assembles, don't hard-code hpux and aix.
	(GMP_PROG_EXEEXT_FOR_BUILD): Add ,ff8 for RISC OS, per autoconf cvs.
	(GMP_PROG_CPP_FOR_BUILD): Restructure per AC_PROG_CPP, print correct
	result if CPP_FOR_BUILD overrides the cache variable.
	(GMP_PROG_CC_FOR_BUILD_WORKS): New macro split from
	GMP_PROG_CC_FOR_BUILD.  Allow for "conftest" default compiler output.
	* configure.in, acinclude.m4 (GMP_PROG_HOST_CC): Reinstate this,
	separating HOST_CC establishment from GMP_PROG_CC_FOR_BUILD.

	* configure.in (mpn_objs_in_libgmp): Move mpn/mp_bases.lo ...
	* Makefile.am (MPN_OBJECTS): ... to here, add $U, and arrange
	MPN_OBJECTS to be common between libgmp and libmp.

2002-06-20  Torbjorn Granlund  <tege@swox.com>

	* mpn/generic/mul_n.c (TOOM3_MUL_REC, TOOM3_SQR_REC): Don't check if
	basecase is to be invoked when *_TOOM3_THRESHOLD is more than 3 times
	the corresponding *_THRESHOLD.

2002-06-20  Kevin Ryde  <kevin@swox.se>

	* mpn/ia64/submul_1.c: Add missing TMP_DECL, TMP_MARK, TMP_FREE.
	Reported by Paul Zimmermann.

	* configure.in, acinclude.m4 (AC_DEFINE): Make templates read "Define
	to 1", for clarity as per autoconf.
	* acinclude.m4 (GMP_OPTION_ALLOCA): Group WANT_TMP templates.

2002-06-20  Gerardo Ballabio <gerardo.ballabio@unimib.it>

	* gmpxx.h, mpfrxx.h: Remove mpz_classref, let mpq_class::get_num and
	mpq_class::get_den return mpz_class& as per the documentation.
	Reported by Roberto Bagnara.

2002-06-18  Kevin Ryde  <kevin@swox.se>

	* tests/rand/t-lc2exp.c: New file.
	* tests/rand/Makefile.am: Add it, and use tests/libtests.la.

	* randraw.c (lc): Pad seed==0 case with zero limbs, return same
	(m2exp+1)/2 bits as normal, right shift "c" result as normal.

	* configure.in: Don't bother with line numbers in some diagnostics.
	(*-*-mingw*): Use -mno-cygwin if it works, suggested by delta trinity.

	* tests/mpz/Makefile.am, tests/mpq/Makefile.am,
	tests/misc/Makefile.am, (CLEANFILES): Set to *.tmp for test program
	temporaries, to get t-scanf.tmp and reduce future maintenance.

2002-06-16  Torbjorn Granlund  <tege@swox.com>

	* mpn/generic/get_str.c (mpn_dc_get_str): Pass scratch memory area in
	new `tmp' parameter.  Trim allocation needs by reusing input parameter.

2002-06-15  Torbjorn Granlund  <tege@swox.com>

	* mpn/sparc32/v9/udiv.asm: New file.

2002-06-15  Kevin Ryde  <kevin@swox.se>

	* acinclude.m4 (GMP_GCC_VERSION_GE): Correction to recognising mingw
	gcc 3.1 version number.  Reported by Jim Fougeron.

	* configure.in (AC_PROVIDE_AC_LIBTOOL_WIN32_DLL): New define, to make
	AC_LIBTOOL_WIN32_DLL work with autoconf 2.53.

	* acinclude.m4 (GMP_C_SIZES): Establish BITS_PER_MP_LIMB as a value,
	not an expression, for the benefit of the gen-bases invocation.

	* config.guess (CC_FOR_BUILD): Try c99, same as configfsf.guess.

2002-06-15  Paul Zimmermann  <Paul.Zimmermann@loria.fr>

	* mpfr/set_q.c: Allow for 1 bit numerator or denominator.

2002-06-14  Kevin Ryde  <kevin@swox.se>

	* configure.in (AC_C_BIGENDIAN): Use new style action parameters.

	* randlc2x.c: Allow for a<0, allow for c>=2^m2exp.
	* randraw.c (lc): Allow for a==0.

	* mpn/sparc32/udiv.asm: Renamed from udiv_fp.asm.  Don't know if float
	is the best way for v7, but it's what configure has chosen since gmp 3.
	* configure.in (*sparc*-*-* ABI=32): extra_functions="udiv" for all,
	in particular sparc32/v8/udiv.asm is faster (on ultrasparc2) than
	udiv_fp previously used for v9 chips.

	* gen-bases.c: New file, derived from mpn/mp_bases.c.
	* dumbmp.c: New file, mostly by Torbjorn, some by me.
	* configure.in, acinclude.m4 (GMP_PROG_CC_FOR_BUILD,
	GMP_PROG_CPP_FOR_BUILD, GMP_PROG_EXEEXT_FOR_BUILD,
	GMP_C_FOR_BUILD_ANSI, GMP_CHECK_LIBM_FOR_BUILD): New macros.
	(GMP_PROG_HOST_CC): Remove, superceded by GMP_PROG_CC_FOR_BUILD.
	* Makefile.am: Run gen-bases to create mp_bases.h and mpn/mp_bases.c.
	* gmp-impl.h: Use mp_bases.h.
	* mpn/mp_bases.c: Remove file.
	* mpn/Makefile.am: mp_bases.c now in nodist_libmpn_la_SOURCES.

	* tests/mpz/t-cmp_d.c (check_one_2exp): Use volatile to force to
	double, fixes gcc 3.1 with -O4.  Reported by Michael Lee.
	* configure.in (AC_C_VOLATILE): New macro.

	* tests/misc/t-scanf.c:	(fromstring_gmp_fscanf): Add missing va_end.
	Don't mix varargs and fixed args functions, not good on x86_64.
	Reported by Marcus Meissner.

	* Makefile.am (EXTRA_DIST): Remove mpfr/README, now in mpfr/Makefile.in

	* configure, config.in, INSTALL.autoconf: Update to autoconf 2.53.
	* */Makefile.in, install-sh, mdate-sh, missing, aclocal.m4, configure:
	Update to automake 1.6.1.
	* configfsf.guess, configfsf.sub: Update to 2002-05-29.

2002-06-12  Kevin Ryde  <kevin@swox.se>

	* acinclude.m4 (GMP_GCC_VERSION_GE): Recognise mingw gcc 3.1 version.
	(GMP_PROG_CC_WORKS): Allow for a_out.exe, as per autoconf.
	(GMP_GCC_NO_CPP_PRECOMP, GMP_ASM_UNDERSCORE): Ditto, plus a.exe.

2002-06-09  Torbjorn Granlund  <tege@swox.com>

	* randraw.c (lc): Remove broken ASSERT_ALWAYS.

	* mpn/x86: Update gmp-mparam.h files with current measures *_THRESHOLD
	values.
	* mpn/x86/p6/mmx/gmp-mparam.h: New file.

2002-06-09  Kevin Ryde  <kevin@swox.se>

	* mpn/x86/*/gmp-mparam.h (USE_PREINV_DIVREM_1): Add tuned settings.

	* acconfig.h (HAVE_NATIVE_mpn_preinv_divrem_1): New template.

	* tests/refmpn.c, tests/tests.h (refmpn_chars_per_limb,
	refmpn_big_base): New functions.
	* tests/mpn/t-mp_bases.c: Use them, and don't test big_base_inverted
	unless it's being used.

	* gmp.texi (Notes for Particular Systems): Using Microsoft C with DLLs.
	(Known Build Problems): Notes on MacOS and GCC.
	(Integer Logic and Bit Fiddling): Use ULONG_MAX for maximum ulong.
	(Low-level Functions): mpn_get_str accepts base==256.
	(Formatted Output Functions): Note output is not atomic.
	(Internals): Note mp_size_t for limb counts.

	* mp-h.in, gmp-h.in (mp_ptr, mp_srcptr, mp_size_t, mp_exp_t): Remove
	these types from mp.h, not needed.

	* mpfr/tests/tadd.c, mpfr/tests/tmul.c (check): Apply a hack to the
	parameter order to make sparc gcc 2.95.2 happy.

	* doc/configuration: Notes on bootstrapping.

2002-06-08  Kevin Ryde  <kevin@swox.se>

	* mpfr/tests/tsqrt.c, mpfr/tests/tsqrt_ui.c: Suppress tests if sqrt is
	not affected by mpfr_set_machine_rnd_mode.

	* mpfr/mul_2si.c: Workaround a mips gcc 2.95.3 bug under -O2 -mabi=n32.

	* configure.in (alphev56): Fix to use ev5 path.

2002-06-06  Kevin Ryde  <kevin@swox.se>

	* gmp-h.in: Use __gmp_const not const, in a number of places.

	* configure.in (sparc): Use ABI=32 instead of ABI=standard on v7 and
	v8, for consistency with v9 choices.
	(sparc64): Restrict GMP_ASM_SPARC_REGISTER to ABI=64.
	(x86): Move MMX $path munging to before printout.
	(CCAS): Move upward to support this.

	* gmp-impl.h (modlimb_invert): Merge macros for specific limb sizes,
	add a version for arbitrary limb size, use GMP_NUMB_BITS.
	(modlimb_invert, MODLIMB_INVERSE_3): Fix comments to say GMP_NUMB_BITS.

	* gmp-h.in (__GMP_LIKELY, __GMP_UNLIKELY): New macros.
	(mpz_getlimbn, mpz_perfect_square_p, mpz_popcount): Use them, make the
	fetch or mpn call likely, unconditionally calculate the alternative so
	as to avoid an "else" clause.
	* gmp-impl.h (LIKELY, UNLIKELY): Aliases.

	* configure.in, mpfr/tests/Makefile.am: Add $LIBM to $LIBS for
	MPFR_CONFIGS so it detects fesetround, and let it go through to
	$MPFR_LIBS.
	* mpfr/rnd_mode.c: Use gmp-impl.h to get MPFR_HAVE_FESETROUND.

	* tests/mpz/t-sizeinbase.c: Disable fake bits test, such pointer
	setups are bogus and have been seen failing on hppa.

	* tests/misc.c, tests/refmpz.c, tests.tests.h, tests/mpz/t-cong.c:
	Rename mpz_flipbit to refmpz_combit and move from misc.c to refmpz.c.

2002-06-05  Torbjorn Granlund  <tege@swox.com>

	* tests/mpz/t-powm_ui.c Print proper routine name in error message.

2002-06-03  Kevin Ryde  <kevin@swox.se>

	* tune/time.c, tune/freq.c, tune/speed.h: Add powerpc mftb support.
	(FREQ_MEASURE_ONE): Move to speed.h, fix tv_sec factor.
	(freq_measure): Use for mftb measuring too.
	* tune/powerpc.asm, tune/powerpc64.asm: New files.
	* configure.in, tune/Makefile.am: Add them.

	* gmp-impl.h (popc_limb): Add versions for Cray and fallback for
	arbitrary limb size.

	* mpn/sparc32/sparc-defs.m4: New file.
	* configure.in (sparc*-*-*): Use it.
	* acinclude.m4 (GMP_ASM_SPARC_REGISTER): New macro.
	* configure.in (sparc64): Use it.  Also, use -Wc,-m64 for linking.
	* mpn/sparc64/add_n.asm, mpn/sparc64/addmul_1.asm,
	mpn/sparc64/copyd.asm, mpn/sparc64/copyi.asm, mpn/sparc64/lshift.asm,
	mpn/sparc64/mul_1.asm, mpn/sparc64/rshift.asm,
	mpn/sparc64/sqr_diagonal.asm, mpn/sparc64/sub_n.asm,
	mpn/sparc64/submul_1.asm: Use REGISTER for .register.

2002-06-01  Kevin Ryde  <kevin@swox.se>

	* mpz/powm_ui.c: Fix for result range in certain circumstances.

	* mpn/x86/k6/diveby3.asm: Speedup to 10 c/l, same as divexact_1.
	Anomaly pointed out by Alexander Kruppa.

2002-05-31  Torbjorn Granlund  <tege@swox.com>

	* mpz/export.c: Cast pointer via `unsigned long' when checking
	alignment to avoid compiler warnings.

2002-05-29  Kevin Ryde  <kevin@swox.se>

	* gmp-impl.h (BSWAP_LIMB): Versions for m68k, powerpc, and arbitrary
	limb size.
	* configure.in, acconfig.h (HAVE_HOST_CPU_FAMILY_m68k): New define.

2002-05-27  Torbjorn Granlund  <tege@swox.com>

	* mpn/generic/mul_basecase.c: Improve MAX_LEFT handling, returning
	when possible.  Add code for mpn_addmul_5 and mpn_addmul_6.

2002-05-25  Kevin Ryde  <kevin@swox.se>

	* tune/tuneup.c: Misc nailifications, and disable preinv thresholds
	with nails.
	* tune/speed.h: Use GMP_NUMB_HIGHBIT with mpn_sb_divrem_mn and
	mpn_divrem_2.
	* mpz/powm.c (redc): Nailify q.

	* tests/mpn/t-scan.c: Reduce the amount of testing, to go faster.

2002-05-23  Torbjorn Granlund  <tege@swox.com>

	* Version 4.1 released.

	* mpn/alpha/ev6/nails/gmp-mparam.h: New file.

	* tests/devel/add_n.c (refmpn_add_n): Nailify.
	* tests/devel/sub_n.c (refmpn_sub_n): Nailify.
	* tests/devel/addmul_1.c (refmpn_addmul_1): Nailify.
	* tests/devel/submul_1.c (refmpn_submul_1): Nailify.

	* mpn/alpha/ev6/nails/add_n.asm: New file.
	* mpn/alpha/ev6/nails/sub_n.asm: New file.
	* mpn/alpha/ev6/nails/mul_1.asm: New file.
	* mpn/alpha/ev6/nails/submul_1.asm: New file.

2002-05-22  Torbjorn Granlund  <tege@swox.com>

	* mpn/alpha/ev6/nails/addmul_1.asm: New file.

	* mpz/inp_str.c (mpz_inp_str_nowhite): Nailify.

	* mpn/generic/mul_basecase.c: Update pointers before conditional
	MAX_LEFT break statements.

2002-05-21  Torbjorn Granlund  <tege@swox.com>

	* tests/mpz/t-gcd.c: Test mpz_gcd_ui.

	* mpz/lcm_ui.c: Nailify.

	* mpz/gcd_ui.c: Nailify.  Make it work as documented, allowing
	NULL to be passed for result parameter.  Fix gcd(0,0) case.

	* mpz/set_str.c: Nailify.

	* randlc2x.c (gmp_randinit_lc_2exp): Nailify.

	From Jakub Jelinek:
	* longlong.h (add_ssaaaa,sub_ddmmss) [64-bit sparc]:
	Make it actually work.

2002-05-18  Torbjorn Granlund  <tege@swox.com>

	* mpf/ui_div.c: Shut up compiler warning.

	* mpn/generic/mul_basecase.c: Use mpn_addmul_2, mpn_addmul_3, and
	mpn_addmul_4, as available.

	* mpn/alpha/ev6/nails/addmul_2.asm: Adjust NAILS_SUPPORT decls.
	* mpn/alpha/ev6/nails/addmul_3.asm: Likewise
	* mpn/alpha/ev6/nails/addmul_4.asm: Likewise.

	* configure.in (*-cray-unicos*): Back again to -hscalar0.
	(gmp_mpn_functions_optional): Add mul_3, mul_4, addmul_2, addmul_3,
	and addmul_4.
	* acconfig.h: Add #undefs for new optional mpn functions.

2002-05-18  Kevin Ryde  <kevin@swox.se>

	* gmp.texi (Integer Import and Export): Mention Cray unfilled words.

	* mpz/set_d.c, mpq/set_d.c: Use LIMBS_PER_DOUBLE for the output of
	__gmp_extract_double.  Reported by Henrik Johansson.

2002-05-17  Torbjorn Granlund  <tege@swox.com>

	* mpn/alpha/ev6/nails/addmul_2.asm: New file.
	* mpn/alpha/ev6/nails/addmul_3.asm: New file.
	* mpn/alpha/ev6/nails/addmul_4.asm: New file.

	* mpn/generic/dump.c: Rewrite and nailify.

2002-05-16  Kevin Ryde  <kevin@swox.se>

	* mpfr/Makefile.am (EXTRA_DIST): Add BUGS file.

2002-05-15  Torbjorn Granlund  <tege@swox.com>

	* configure.in (*-cray-unicos*): Remove -hscalar0, add -hnofastmd
	as workaround for compiler bug.
	(mips64*-*-*): Pass just -O1 to cc, to work around compiler bug.

2002-05-14  Torbjorn Granlund  <tege@swox.com>

	* configure.in (*-cray-unicos*): Pass -hscalar0 to work around
	compiler bug for mpz/import.c.

2002-05-11  Torbjorn Granlund  <tege@swox.com>

	* mpz/import.c: Cast pointer via `unsigned long' when checking
	alignment to avoid compiler warnings.

	* mpn/generic/rootrem.c: Adjust allocation of qp temporary area.

2002-05-09  Kevin Ryde  <kevin@swox.se>

	* mpz/import.c: Corrections to size store, special case tests, and
	general case ACCUMULATE.
	* tests/mpz/t-import.c, tests/mpz/t-export.c: More test data.

2002-05-09  Torbjorn Granlund  <tege@swox.com>

	* mpn/generic/rootrem.c: Use temp space for root, copy value in place
	before returning.
	* mpz/root.c: Don't allocate extra limb for root value.
	* mpz/perfpow.c: Undo last change.

2002-05-08  Torbjorn Granlund  <tege@swox.com>

	* gmp-impl.h (powerpc BSWAP_LIMB_FETCH): Rename local variable to make
	it not clash with caller.

	* mpn/generic/rootrem.c: New file.
	* configure.in (gmp_mpn_functions): Add rootrem and pow_1.
	* mpn/Makefile.am (nodist_libdummy_la_SOURCES): Add rootrem.c and
	pow_1.c
	* gmp-impl.h (mpn_rootrem): Add declaration.
	* mpz/perfpow.c: Amend allocations for mpn_rootrem requirements.
	* mpz/root.c: Rewrite to use mpn_rootrem.

2002-05-08  Kevin Ryde  <kevin@swox.se>

	* gmp-impl.h (MUL_KARATSUBA_THRESHOLD etc): Remove forced nail values.

	* mpf/fits_u.h, mpf/fits_s.h, tests/mpf/t-fits.c: Ignore fraction
	part, making the code match the documentation.

	* gmpxx.h (struct __gmp_binary_minus): Use mpz_ui_sub.

2002-05-07  Kevin Ryde  <kevin@swox.se>

	* mpn/powerpc32/README: New file.

	* mpz/root.c: Use unsigned long with mpz_sub_ui not mp_limb_t.

	* tune/README: Misc updates including sparc32/v9 smoothness, low res
	timebase, and mpn_add_n operand overlaps.
	* tune/many.pl: Add udiv.asm support.

	* gmp.texi (Build Options): A couple of --build better as --host.
	(Known Build Problems, Notes for Package Builds): Add DESTDIR problem.
	(Compatibility with older versions): Compatible with 4.x versions.
	(Converting Integers): Remove mpz_get_ui + mpz_tdiv_q_2exp decompose.
	(Integer Import and Export): New section.
	(Miscellaneous Integer Functions): Clarify mpz_sizeinbase returns 1
	for operand of 0.
	(Language Bindings): Add GNU Pascal.
	(Low-level Functions): Add GMP_NUMB_MAX.

	* tests/mpz/t-import.c, tests/mpz/t-export.c, tests/mpz/t-get_d.c:
	New tests.
	* tests/mpz/Makefile.am: Add them.

	* mpz/import.c, mpz/export.c: New files.
	* Makefile.am, mpz/Makefile.am, gmp-h.in: Add them.

	* gmp-h.in, gmp-impl.h (GMP_NUMB_MAX): Move to gmp.h.
	* gmp-impl.h (CNST_LIMB): Add cast to mp_limb_t to ensure unsigned.
	(CRAY_Pragma, MPN_REVERSE, MPN_BSWAP, MPN_BSWAP_REVERSE,
	ASSERT_ALWAYS_LIMB, ASSERT_ALWAYS_MPN): New macros.
	(MPZ_CHECK_FORMAT): Use ASSERT_ALWAYS_MPN.

2002-05-07  Torbjorn Granlund  <tege@swox.com>

	* mpz/aors_ui.h: Nailify.

	* tests/mpz/t-addsub.c: New file.
	* tests/mpz/Makefile.am (check_PROGRAMS): Add t-addsub.

	* mpz/ui_sub.c: New file.
	* mpz/Makefile.am (libmpz_la_SOURCES): Add ui_sub.c.
	* Makefile.am (MPZ_OBJECTS): Ditto.
	* gmp-h.in (mpz_ui_sub): Add declaration.

	* gmp-impl.h (MPZ_REALLOC): Rewrite to allow the use of _mpz_realloc
	return value.

	* gmp-h.in (mpn_pow_1): Add declaration.

	* mpn/generic/pow_1.c: Handle exp <= 1.  Reverse rp/tp parity scheme
	for bn == 1 arm.

	* Rename MP_LIMB_T_HIGHBIT => GMP_LIMB_HIGHBIT.

2002-05-06  Torbjorn Granlund  <tege@swox.com>

	* demos/pexpr.c (main): Don't call mpz_sizeinbase with negative base.

	* randraw.c (lc): Remove an unused variable.

	* mpn/generic/get_str.c: Clarify an algorithm description.

	* tests/mpf/t-trunc.c: Nailify.
	* tests/mpf/t-set_si.c: Disable for nails.

	* mpf/cmp_si.c: Nailify.
	* mpf/cmp_ui.c: Nailify.
	* mpf/div.c: Nailify.
	* mpf/div_2exp.c: Nailify.
	* mpf/div_ui.c: Nailify.
	* mpf/eq.c: Nailify.
	* mpf/get_d.c: Nailify.
	* mpf/get_d_2exp.c: Nailify.
	* mpf/get_si.c: Nailify.
	* mpf/get_str.c: Nailify.
	* mpf/get_ui.c: Nailify.
	* mpf/mul_2exp.c: Nailify.
	* mpf/random2.c: Nailify.
	* mpf/set_q.c: Nailify.
	* mpf/set_si.c: Nailify.
	* mpf/set_str.c: Nailify.
	* mpf/set_ui.c: Nailify.
	* mpf/sub.c: Nailify.
	* mpf/ui_div.c: Nailify.
	* mpf/ui_sub.c: Nailify.
	* mpf/urandomb.c: Nailify.

	* gmp-impl.h (__GMPF_BITS_TO_PREC, __GMPF_PREC_TO_BITS): Nailify.

	* mpz/get_si.c: Misc variable name changes.

	* mpf/fits_u.h: Rewrite - nailify.
	* mpf/fits_s.h: Likewise.

	* mpz/mod.c: Disambiguate if-statament with extra {}.

	* mpf/int_p.c: Fix type of size variables.
	* mpf/get_ui: Likewise.
	* mpf/get_si: Likewise.
	* mpq/equal.c: Likewise.
	* mpq/get_d.c: Likewise.
	* mpz/cmp_d.c: Likewise.
	* mpz/cmpabs_d.c: Likewise.
	* mpz/divis_2exp.c: Likewise.
	* mpz/kronuz.c: Likewise.
	* mpz/kronzu.c: Likewise.
	* mpz/kronzs.c: Likewise.
	* mpz/kronsz.c: Likewise.
	* mpz/scan0.c: Likewise.
	* mpz/scan1.c: Likewise.
	* mpz/tstbit.c: Likewise.
	* mpz/cong_2exp.c: Likewise.
	* mpz/divis.c: Likewise.

2002-05-04  Torbjorn Granlund  <tege@swox.com>

	* mpn/generic/gcd.c: Additional nailify changes.

2002-05-04  Kevin Ryde  <kevin@swox.se>

	* gmp-h.in (__GNU_MP_VERSION): Set to 4.1.
	* Makefile.am (-version-info): Bump for new release.

2002-04-30  Torbjorn Granlund  <tege@swox.com>

	* mpn/generic/divrem_1.c: Additional nailify changes.
	* mpn/generic/mod_1.c: Likewise.

	* tests/mpq/t-get_d.c: Print floats with all 16 digits.

	* mpq/get_d.c: Nailify.

	* tests/mpq/t-set_f.c: Disable for nails.

	* mpz/get_d.c: Nailify.

	* gmp-impl.h (LIMBS_PER_DOUBLE, MP_BASE_AS_DOUBLE): Nailify.

	* gmp-h.in (__GMPZ_FITS_UTYPE_P): Cast maxval to before shifting it.

	* extract-dbl.c: Nailify.

2002-04-29  Torbjorn Granlund  <tege@swox.com>

	* mpq/md_2exp.c (mord_2exp): Nailify.

	* mpq/cmp_ui.c: Nailify.

	* mpq/cmp.c (mpq_cmp): Nailify.

	* mpn/generic/gcd.c: Nailify.  GNUify code layout.

	* mpn/generic/gcdext.c: Nailify.  Misc changes.

	* tests/mpz/t-sqrtrem.c: Let argv[1] mean # of repetitions.
	* tests/mpz/t-gcd.c: Likewise.

	* mpz/gcd.c: Nailify.

	* mpn/generic/random.c: Nailify.

	* gmp-impl.h (modlimb_invert): Nailify.

2002-04-27  Torbjorn Granlund  <tege@swox.com>

	* mpn/generic/gcdext.c (div2): Remove qh parameter.
	(mpn_gcdext): Streamline double-limb code.
	Move GCDEXT_THRESHOLD check to after initial division.

2002-04-27  Kevin Ryde  <kevin@swox.se>

	* gmp-impl.h (JACOBI_MOD_OR_MODEXACT_1_ODD): Allow for odd
	GMP_NUMB_BITS.

	* tune/time.c (sgi_works_p): Allow for 64-bit counter, and fix
	SGI_CYCLECNTR_SIZE handling.

	* demos/expr/exprfr.c: Add nan and inf constants.
	* demos/expr/t-expr.c: Exercise them.

2002-04-26  Torbjorn Granlund  <tege@swox.com>

	* mpz/cmp_ui.c: Fix overflow conditions for nails.

	* gmp-h.in (mpz_get_ui): Fix typo from last change.

	* mpz/n_pow_ui.c: Adjust allocation for nails.
	(GMP_NUMB_HALFMAX): Renamed from MP_LIMB_T_HALFMAX.
	Fix umul_ppmm invocation for for nails.

2002-04-24  Torbjorn Granlund  <tege@swox.com>

	* mpn/generic/gcdext.c: Simplify by using mpn_tdiv_qr instead of
	mpn_divmod.

2002-04-24  Kevin Ryde  <kevin@swox.se>

	* configure.in (*-*-cygwin*): Give a sensible default command line
	limit, to avoid blowups reported by Jim Fougeron on windows 9x.
	(--enable-nails): Make the default 2, since mp_bases has data for that.

	* mpfr/mpfr-math.h (__mpfr_nan): Use a "double" for the bytes, to
	avoid a mis-conversion on alpha gcc 3.0.2.
	(_MPFR_INFP_BYTES, _MPFR_INFM_BYTES): Should be a zero mantissa.

2002-04-23  Torbjorn Granlund  <tege@swox.com>

	* mpz/dive_ui.c: Fix typo.

	* mpz/fits_s.h: Rewrite.

	* mpz/jacobi.c: Nailify.
	* mpz/kronuz.c: Additional nailify changes.
	* mpz/kronsz.c: Likewise.

2002-04-23  Kevin Ryde  <kevin@swox.se>

	* demos/expr/Makefile.am (LDADD): Add $(LIBM) for the benefit of mpfr.

	* mpz/divis_ui.c, mpz/cong_ui.c: Nailify.
	* mpn/generic/bdivmod.c, mpz/divexact.c, mpz/dive_ui.c: Nailify.
	* mpn/generic/sb_divrem_mn.c, mpn/generic/divrem.c,
	mpn/generic/divrem_2.c: Nailify ASSERTs.
	* mpn/x86/k6/mmx/logops_n.asm, mpn/x86/k6/mmx/com_n.asm: Nailify.
	* mpz/inp_raw.c, mpz/out_raw.c: Nailify.
	* mpz/kronzu.c, mpz/kronuz.c, mpz/kronzs.c, mpz/kronsz.c: Nailify.
	* mpn/generic/divis.c, mpz/cong.c, mpz/cong_2exp.c: Nailify.
	* gmp-impl.h (NEG_MOD): Nailify.

	* gmp-impl.h, mpn/mp_bases.c: Add back GMP_NUMB_BITS==30 bases data.

	* mpfr/get_d.c: Patch from Paul to avoid problem with constant folding
	in gcc on OSF.

	* mpn/lisp/gmpasm-mode.el: Remove mention of defunct LF macro.

2002-04-22  Torbjorn Granlund  <tege@swox.com>

	* demos/pexpr.c: Handle "binomial" operator.

	* mpz/cmp_ui.c: Move assignments of `up' out of conditionals.

	* mpn/generic/gcdext.c: Fix fencepost error in STAT code.

	* gmp-impl.h (mpn_com_n): Nailify.

	* tests/mpz/t-cdiv_ui.c: New file.
	* tests/mpz/Makefile.am (check_PROGRAMS): Add t-cdiv_ui.
	* mpz/cdiv_qr_ui.c: Nailify.
	* mpz/cdiv_q_ui.c: Nailify.
	* mpz/cdiv_r_ui.c: Nailify.
	* mpz/cdiv_ui.c: Nailify.

	* tests/misc/t-printf.c (CHECK_N): Add cast to allow `char' to be an
	unsigned type.
	* tests/misc/t-scanf.c: Likewise.

	* mpz/mul_i.h: Rework nails code to handle parameter overlap.

	* tests/mpz/t-set_f.c: Disable for nails.

2002-04-21  Torbjorn Granlund  <tege@swox.com>

	* mpz/set_si.c: Add cast to support LONG_LONG_LIMB.
	* mpz/iset_si.c: Likewise.

	* mpz/bin_ui.c: Nailify.
	* mpz/bin_uiui.c: Nailify.

	* mpz/cmpabs_ui.c: Nailify.

	* tests/mpz/t-aorsmul.c: Nailify.
	* mpz/aorsmul_i.c (mpz_addmul_ui, mpz_submul_ui): Nailify better.

2002-04-20  Torbjorn Granlund  <tege@swox.com>

	* tests/mpz/t-fdiv_ui.c: Check mpz_fdiv_ui.
	* tests/mpz/t-tdiv_ui.c: Check mpz_tdiv_ui.

	* mpz/tdiv_ui.c: Rewrite nails code.
	* mpz/fdiv_ui.c: Nailify.

	* tests/mpz/t-tdiv_ui.c: Check returned remainders.
	* tests/mpz/t-fdiv_ui.c: Merge in recent t-tdiv_ui changes.

	* mpz/tdiv_q_ui.c: Remove spurious TMP_* calls.

	* mpz/fdiv_qr_ui.c: Nailify.
	* mpz/fdiv_q_ui.c: Nailify.
	* mpz/fdiv_r_ui.c: Nailify.

	* mpz/get_si.c: Misc nailify changes to shut up compiler warnings.

	* mpz/ui_pow_ui.c: Fix typo in last change.

2002-04-20  Kevin Ryde  <kevin@swox.se>

	* tests/misc/t-printf.c, tests/misc/t-scanf.c: Check all %n types.

	* mpn/x86/k7/mmx/divrem_1.asm, mpn/x86/p6/mmx/divrem_1.asm
	(mpn_preinv_divrem_1): New entrypoint.
	(mpn_divrem_1): Avoid a branch when testing high<divisor.
	* mpn/asm-defs.m4: Add define_mpn(preinv_divrem_1).
	* configure.in: Allow divrem_1.asm to provide mpn_preinv_divrem_1.

	* gmp-impl.h [nails]: Add #undefs of MUL_KARATSUBA_THRESHOLD etc, to
	override CPU gmp-mparam.h.  Remove JACOBI_BASE_METHOD override since
	it's nails-neutral.

	* tests/mpn/t-mp_bases.c: New file.
	* tests/mpn/Makefile.am (check_PROGRAMS): Add it.
	* tests/t-constants.c: Move MP_BASES constants checks to it.

	* mpn/mp_bases.c: Fix big_base_inverted values for nails.
	* gmp-impl.h (MP_BASES_BIG_BASE_INVERTED_10,
	MP_BASES_NORMALIZATION_STEPS_10): Fix nails values.
	(MP_BASES_*): Remove GMP_NUMB_BITS == 30 data.

	* mpn/x86/pentium/com_n.asm, mpn/x86/pentium/logops_n.asm: Add
	NAILS_SUPPORT indicators.

	* configure.in: Grep for NAILS_SUPPORT in cpu-specific code, and look
	in "nails" subdirectories, print path used.
	* mpn/asm-defs.m4 (NAILS_SUPPORT): New macro.

	* mpfr/mpfr-test.h: Include config.h, for the benefit of test programs
	not using gmp-impl.h.

2002-04-19  Torbjorn Granlund  <tege@swox.com>

	* tests/mpz/t-scan.c: Nailify.

	* mpz/tdiv_qr_ui.c: Nailify.
	* mpz/tdiv_q_ui.c: Nailify.
	* mpz/tdiv_r_ui.c: Nailify.
	* mpz/tdiv_ui.c: Nailify.

	* mpz/cmp_ui.c: Nailify.

	* mpz/ui_pow_ui.c: Misc nailify changes to shut up compiler warnings.

	* mpz/scan0.c: Nailify.
	* mpz/scan1.c: Nailify.

	* tests/mpz/t-sizeinbase.c (mpz_fake_bits): Nailify.

2002-04-18  Torbjorn Granlund  <tege@swox.com>

	* mpz/aorsmul_i.c: Nailify.

	* mpz/cmp_si.c: Nailify (botched).

	* mpz/ui_pow_ui.c: Nailify.

	* gmp-h.in (__GMPZ_FITS_UTYPE_P): Nailify.

	* mpz/fits_s.h: Nailify.

	* tests/mpz/bit.c (check_tstbit): Nailify.

	From Paul Zimmermann:
	* mpn/generic/sqrtrem.c: Nailify.

	* mpz/n_pow_ui.c: Nailify.

	* mpz/cfdiv_r_2exp.c: Nailify.

	* randraw.c (lc): Undo: Let mpn_rshift put result in place to avoid
	extra MPN_COPY.

2002-04-17  Torbjorn Granlund  <tege@swox.com>

	* mpz/clrbit.c: Add two GMP_NUMB_MASK masks after addition.

	* mpn/generic/random2.c (LOGBITS_PER_BLOCK): Decrease to 4.

	* gmp-impl.h (nail DIV_DC_THRESHOLD): Decrease to 50 to allow fast
	division.

	* mpn/generic/random2.c: Nailify.

	* mpz/fac_ui.c: Nailify.

	* mpz/mul_i.h: #if ... #endif code block to shut up gcc warnings.

	* mpn/generic/sqrtrem.c: Adopt to GNU coding standards.
	(mpn_dc_sqrtrem): New name for mpn_dq_sqrtrem.
	Partial nailification.

	* configure.in: As a temporary hack, clear extra_functions for nails
	builds.

	* gmp-h.in (mpz_get_ui): #if ... #endif else code block to shut up gcc
	warnings.

2002-04-17  Kevin Ryde  <kevin@swox.se>

	* texinfo.tex: Update to 2002-03-26.08 per texinfo 4.2.
	* gmp.texi: Must have @top in @ifnottex (or @contents doesn't come out
	in one run).

	* mpn/generic/scan0.c, mpn/generic/scan1.c: Nailify.

	* tests/mpn/t-scan.c: New file.
	* tests/mpn/Makefile.am (check_PROGRAMS): Add it.

	* tests/refmpn.c, tests/tests.h (refmpn_tstbit): Use unsigned long for
	bit index.
	(refmpn_setbit, refmpn_clrbit, refmpn_scan0, refmpn_scan1): New
	functions.

	* mpfr/cmp_ui.c (mpfr_cmp_si_2exp): Fix b==0 i!=0 case.

2002-04-17  Gerardo Ballabio <gerardo.ballabio@unimib.it>

	* gmpxx.h, mpfrxx.h: Remove mpfr_class bool combinations, remove
	mpfr_class::get_str2, use mp_rnd_t for rounding modes, use
	8*sizeof(double) for mpfr_t's holding doubles.

2002-04-17  Torbjorn Granlund  <tege@swox.com>

	* mpz/powm.c: Nailify.
	* mpz/powm_ui.c: Nailify.

2002-04-16  Torbjorn Granlund  <tege@swox.com>

	* mpz/hamdist.c: Nailify.
	* tests/misc.c (urandom): Nailify.

	* mpz/get_si.c: Nailify.
	* gmp-h.in (mpz_get_ui): Nailify.  Streamline (and probably upset
	memory checkers).

	* gmp-impl.h (mp_bases[10] values): Add versions for GMP_NUMB_BITS
	being 28, 60, and 63.
	* mpn/mp_bases.c: Add tables for GMP_NUMB_BITS being 28, 60, and 63.

	* mpz/iset_si.c: Nailify.
	* mpz/iset_ui.c: Nailify

	* tests/mpz/convert.c (main): Print test number in error message.

	* mpn/generic/get_str.c (mpn_sb_get_str): Shift up `frac' into nails
	field after bignum division.

2002-04-16  Kevin Ryde  <kevin@swox.se>

	* gmp-h.in, gmp-impl.h (GMP_NAIL_MASK): Move to gmp.h.

	* gmp.texi: Use @documentdescription and @copying, per texinfo 4.2.
	(Low-level Functions): Clarify mpn_gcd overlap requirements, rewrite
	mpn_set_str description, add nails section.
	(C++ Interface General): Remove bool from types that mix with classes.
	(Language Bindings): Add STklos, GNU Smalltalk, Regina.
	(Binary to Radix, Radix to Binary): Describe new code.
	(Assembler Cache Handling): More notes, mostly by Torbjorn.

	* macos/configure (%vars): Remove __GMP from substitutions, per change
	to main configure.

	* mpn/generic/dive_1.c: Nailify.
	* mpn/generic/mode1o.c: Nailify, remove bogus ASSERT in commented-out
	alternate implementation.
	* gmp-impl.h (SUBC_LIMB): New macro.

	* tests/devel/try.c (validate_divexact_1): Correction to compare.
	(udiv_qrnnd): New testing.
	(SHIFT_LIMIT): Nailify.
	(-b): New option, remove spurious "H" from getopt string.

	* mpz/clrbit.c: Nailify.
	* tests/mpz/t-hamdist.c: Nailify.
	* gmp-impl.h (MPN_FIB2_SIZE): Nailify.
	(PP): Nailify conditionals.
	* tests/mpz/t-fib_ui.c (MPZ_FIB_SIZE_FLOAT): Nailify.

	* configure.in, acinclude.m4: Establish GMP_NAIL_BITS and
	GMP_LIMB_BITS for gmp-h.in configure tests.

	* mpfr/*, configure.in: Update to final mpfr 2.0.1.
	* mpfr/acinclude.m4 (MPFR_CONFIGS): Use $host, not uname stuff.
	* mpfr/tests/tout_str.c: Patch from Paul for denorm fprintf tests.

2002-04-15  Torbjorn Granlund  <tege@swox.com>

	* mpn/generic/divrem_1.c (EXTRACT): Remove.

	* tests/mpz/t-tdiv_ui.c (dump_abort): Accept argument for error string.

	* mpz/rrandomb.c: Nailify.  Needs further work.

	* mpn/generic/mod_1.c: Nailify.

	* gmp-impl.h: Set various *_THRESHOLD values to be used for nails to
	avoid not yet qualified algorithms.
	(MPZ_CHECK_FORMAT): Check that nail part is zero.

	* tests/mpz/t-mul.c (main): Test squaring even for huge operands.
	(base_mul): Nailify.
	(dump_abort): Accept argument for error string.  Print product
	difference.

	* mpn/generic/set_str.c: Nailify.

	* gmp-h.in (__GMPN_ADD, __GMPN_SUB): Nailify.

2002-04-14  Torbjorn Granlund  <tege@swox.com>

	* randraw.c (lc): Return non-nonsense return value for seed=0 case.
	Check for m2exp being non-zero early; remove all other tests of m2exp.
	Remove redundant MPN_ZERO call.
	Let mpn_rshift put result in place to avoid extra MPN_COPY.
	Remove confusing comment before function `lc' describing BBS algorithm.
	Misc simplification and cleanups.
	Nailify.  Needs further work.

	* mpz/set_si.c: Nailify.
	* mpz/set_ui.c: Nailify.
	* mpz/mul_i.h: Nailify.

	* tests/mpz/t-mul_i.c: Actually test _ui routines.  Add some more test
	values.

	* mpn/generic/mul_n.c: Finish nailifying toom3 code.

2002-04-13  Kevin Ryde  <kevin@swox.se>

	* mpfr/*: Update to another new mpfr 2.0.1.
	* configure.in, Makefile.am, mpfr/Makefile.am, mpfr/tests/Makefile.am:
	Use MPFR_CONFIGS macro, establish separate MPFR_CFLAGS for mpfr build.

	* mpfr/tests/Makefile.am: Correction to convenience rule for libmpfr.a.

2002-04-11  Kevin Ryde  <kevin@swox.se>

	* mpfr/set_q.c: gmp-impl.h before mpfr.h to avoid _PROTO redefine.

	* mpfr/*, configure.in: Update to new mpfr 2.0.1.

	* tests/refmpn.c (refmpn_udiv_qrnnd, refmpn_divmod_1c_workaround):
	Fixes for nails.

	* tests/t-constants.c (MODLIMB_INVERSE_3): Nailify tests.
	(MP_BASES_BIG_BASE_INVERTED_10, MP_BASES_NORMALIZATION_STEPS_10): Only
	check these under USE_PREINV_DIVREM_1.
	* tests/t-modlinv.c: Nailify tests.

2002-04-11  Gerardo Ballabio <gerardo.ballabio@unimib.it>

	* gmpxx.h: Remove bool combinations, remove mpf_class::get_str2, only
	need <iosfwd> now.

2002-04-11  Torbjorn Granlund  <tege@swox.com>

	* mpn/generic/diveby3.c: Nailify.
	* gmp-impl.h (MODLIMB_INVERSE_3): Nailify.

	* mpn/generic/mul_n.c: Nailify Toom3 code.

2002-04-10  Kevin Ryde  <kevin@swox.se>

	* gmp-impl.h (MPN_KARA_MUL_N_MINSIZE, MPN_KARA_SQR_N_MINSIZE): Set to
	3, as needed by nails case.

	* mpn/generic/addmul_1.c, mpn/generic/submul_1.c [nails]: Fix vl
	assert, add rp,n and up,n asserts.

	* mpfr/Makefile.am: Add new mpfr-math.h, install mpf2mpfr.h.

2002-04-10  Torbjorn Granlund  <tege@swox.com>

	* mpn/generic/divrem_1.c: Nailify.  Update mp_size_t variables to use
	`n' suffix instead of `size' suffix.
	* mpn/generic/divrem_2.c: Likewise.
	* mpn/generic/sb_divrem_mn.c: Nailify.
	* mpn/generic/tdiv_qr.c: Nailify.
	(SHL): Remove silly macro.

	* mpn/generic/mul_n.c (mpn_kara_mul_n): Replace open-coded increment by
	mpn_incr_u call.  Handle nails in ws[n] increment.
	* mpn/generic/mul_n.c (mpn_kara_sqr_n): Likewise.

	* gmp-h.in (GMP_NUMB_MASK): New #define.
	(__GMPN_AORS_1): Add version for nails.

	* gmp-impl.h (GMP_NUMB_MASK): Comment out, now in gmp.h.
	(mpn_incr_u): Don't assume `incr' is non-zero.
	(mpn_decr_u): Similarly.

2002-04-09  Kevin Ryde  <kevin@swox.se>

	* mpfr/*, configure.in: Update to mpfr 2.0.1.

	* tests/refmpn.c (refmpn_mul_1c, lshift_make): Corrections for nails.
	* tssts/refmpn.c, tests/tests.h (refmpn_cmp_allowzero): New function.

	* mpn/generic/mul_1.c [nails]: Fix vl assert, add {up,n} assert.

	* mpn/pa32/hppa1_1/pa7100/addmul_1.asm,
	mpn/pa32/hppa1_1/pa7100/submul_1.asm: Rename "size" define, to avoid
	ELF .size directive.  Reported by LaMont Jones.

	* tests/mpz/t-set_si.c: Add nails support.

2002-04-05  Torbjorn Granlund  <tege@swox.com>

	* gmp-impl.h: Replace nail mpn_incr_u, mpn_decr_u with faster versions.
	(mp_bases[10] values): Check GMP_NUMB_BITS instead of BITS_PER_MP_LIMB.
	Add GMP_NUMB_BITS == 30 version.
	(__gmp_doprnt, etc): Remove parameter names.

	* mpn/generic/mul_n.c: Nailify Karatsuba code.
	* mpn/generic/get_str.c: Nailify.
	* mpn/generic/sqr_basecase.c: Nailify.
	* mpn/generic/lshift.c: Nailify.
	* mpn/generic/rshift.c: Likewise.
	* mpn/generic/add_n.c: Nailify.  Revamp non-nail code.
	* mpn/generic/sub_n.c: Likewise.
	* mpn/generic/mul_1.c: Likewise.
	* mpn/generic/addmul_1.c: Likewise.
	* mpn/generic/submul_1.c: Likewise.

2002-04-02  Kevin Ryde  <kevin@swox.se>

	* gmp-impl.h (BSWAP_LIMB_FETCH, BSWAP_LIMB_STORE) [powerpc]:
	Corrections to constraints, and restrict to bigendian.

2002-03-31  Kevin Ryde  <kevin@swox.se>

	* tests/mpz/dive.c: Better diagnostics.

	* tests/devel/try.c (mpn_get_str, mpn_umul_ppmm_r): New tests.

	* tests/misc.c, tests/tests.h (byte_diff_lowest, byte_diff_highest):
	New functions.

	* tests/t-bswap.c: New file.
	* tests/Makefile.am (check_PROGRAMS): Add it.

	* tests/mpn/t-aors_1.c, tests/mpn/t-iord_u.c: Add nails support.

	* gmp-impl.h (MPN_IORD_U) [x86]: Eliminate unnecessary jiord and iord,
	rename "n" to incr per generic versions, restrict to nails==0.
	(mpn_incr_u, mpn_decr_u): Add nails support.
	(GMP_NAIL_LOWBIT, GMP_NUMB_MAX): New macros.

	* tests/trace.c, tests/tests.h (byte_trace, byte_tracen): New
	functions.
	* tests/trace.c: Handle NULL operands.

	* tests/refmpn.c, tests/devel/try.c, tune/speed.c: Add preliminary
	nail support.

	* tests/refmpn.c, test/tests.h (byte_overlap_p, refmpn_equal_anynail,
	refmpn_umul_ppmm_r, refmpn_udiv_qrnnd_r, refmpn_get_str,
	refmpn_bswap_limb, refmpn_random, refmpn_random2, refmpn_bswap_limb):
	New functions.

	* gmp-impl.h, tests/refmpn.c (ASSERT_LIMB): Renamed from
	ASSERT_MP_LIMB_T.

	* mpn/x86/*/*.asm, mpn/powerpc32/*/*.asm, mpn/powerpc64/*/*.asm: Put
	speeds after the copyright notice, so as to keep that clear.

2002-03-29  Kevin Ryde  <kevin@swox.se>

	* configure.in (powerpc*-*-aix*): Correction to xlc -qarch selection,
	for 32-bit mode.

2002-03-28  Torbjorn Granlund  <tege@swox.com>

	* mpn: Fix spacing in many files.

	* mpn/generic/aorsmul_1.c: Split into addmul_1.c and submul_1.c.
	* mpn/generic/aors_n.c: Split into add_n.c and sub_n.c.

